/***************************************************************************
												   Count8.1 -  description
												  -------------------------
    begin                : mar ott 19 08:23:37 CEST 1999
    copyright            : (C) 1999 by Simone Ascheri
    email                : s.goku@libero.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#define __MSDOS__ 1

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

void	uso(void);
void	minimal(char *);
void	estrai(char *);
int	calcola(char *);
long	getval(char *from);
void	ricalco();
void    clean();
void	fatt();
void	stamp(void);
void    mergedprint(void);
int	inlist(char*);
void	headhtml(FILE *,FILE *);
void	dettagli(FILE *,FILE *,char *, int);
void    banner(FILE *);



char    versio[25]="COUNT Versione 8.1",siste[12]="Standard",intesta[80]="Risultati del Torneo";

long    gf2f[90][90],vminf2f[90][90],vf2f[90][90],n4f2f[90][90],p2f2f[90][90],p3f2f[90][90],p4f2f[90][90],vittmin[90],vitt[90],parmin[90],par[90],sconf[90],schem[75][90];
long 	pari[4][90];
char    rlist[90][64];
char    parklist[90][64];
float   parkperc[90];
float   ftfperc[90];
float   qvqperc[90];
int 	pesi[2]={9,1};
int 	qvq=1;
int 	ftf=2;
long	actuamatch,totmatch;
int	numrob;
int     mrg=0;    /*abilita la tabellina di sintesi finale*/
float   media1[90][90],media2[90][90],media3[90][90],mediapar[90][90],premio,punizione;
int     percentual, infoext;
char    atxta=0;
char    torneosi;
char	listone[5][128];
int	flaggo, iol, iul, ripetizioni, ripetute;
int 	merg;
char 	title[2][10];
char 	flg[2][2];

char	ordinett=0,multiple=0;

float	punti[5]={0.0,3.0,1.0,1.0,1.0};


char 	nome[5][128], dannos[5][128], init[128],*starts,cmd[128],robot1[128],cosa[128];
int	contendenti, start;
char    dest[64],               /*.txt*/
	dest1[64],              /*.html*/
	dest2[64],              /*.lst*/
	parkdest[64],
	parkdest1[64],
	parkdest2[64],
	rb[64],                 /*robot senza .r*/
	torneo[128],             /*da chi e' gestito il torneo*/
	robot[64];



int	main(int argc, char *argv[])
{

	FILE	*fp;
	int	k;
	char    temporan[64];
	char	co[128],		/*file di log senza est.*/
		so[128];		/* .log*/
	char 	park1[5][128], xpark[5][128], perc[5][128];

	int	danno,numero;
	int     nilo,cicli,zolla,zimbello,null,flag,pirla,pp,niki;

#if defined(__MSDOS__)
	clrscr();
	printf("%s\n[(c) Simone ASCHERI & Michelangelo MESSINA 1999-2001]\n",versio);
#else
	printf("\n\n\n%s\n[(c) Simone ASCHERI & Michelangelo MESSINA 1999-2001]\n",versio);
#endif
	if (argc<2) uso();
	so[0]=0;
	premio=0.0;
	punizione=0.0;
	infoext=0;
	for(k=1;k<argc;k++)
	{
#if defined(__MSDOS__)
		if(argv[k][0]=='/') {
#else
		if(argv[k][0]=='-') {
#endif
			if((tolower(argv[k][1]))=='v') ordinett=1;
			else if((tolower(argv[k][1]))=='c') ; /*compatibilita'*/
			else if((tolower(argv[k][1]))=='a') multiple=1;
			else if((tolower(argv[k][1]))=='n') totmatch=getval(argv[k]);
			else if((tolower(argv[k][1]))=='i') strcpy(intesta,argv[k]+3);
			else if((tolower(argv[k][1]))=='b') premio=3.0;
			else if((tolower(argv[k][1]))=='d') infoext=1;
			else if((tolower(argv[k][1]))=='t') atxta=1;
			else if((tolower(argv[k][1]))=='q') pesi[0]=getval(argv[k]);
			else if((tolower(argv[k][1]))=='f') pesi[1]=getval(argv[k]);
			else if((tolower(argv[k][1]))=='p') {
				strcpy(siste,"Pranzo");
				punti[1]=12.0;
				punti[2]=3.0;
				punti[3]=2.0;
				punti[4]=1.0;
				punizione=1.0;
			}
			else if((tolower(argv[k][1]))=='w') punti[1]=getval(argv[k]);
			else if((tolower(argv[k][1]))=='x') punizione=0.0;
			else uso();
		}
		else {
			if(!so[0]) strcpy(so,argv[k]);
			else strcpy(rb,argv[k]);
		}
	}
	strcpy(co,so);

	strcat(so,".log");

/*azzera i contatori*/

strcpy(title[0],"Eff. 4vs4");
strcpy(title[1],"Eff. f2f");
strcpy(flg[0],"4");
strcpy(flg[1],"2");

clean();

/*estrapola:*/


	printf("\nParsing ...\n");

	strcpy(dest,co);
	strcpy(dest1,co);
	strcpy(dest2,co);

	strcpy(parkdest,dest);
	strcpy(parkdest1,dest1);
	strcpy(parkdest2,dest2);

	if((fp=fopen(so,"rt"))==NULL) {
		printf("File di log non trovato\n");
		printf("%s\n",so);
		exit(-1);
	}

	while(!feof(fp)) {
		do
			{
				fgets(init,128,fp);
				if (strstr(init,"Torneo gestito"))	  /*Ricerca eventuali parentele con torneo99*/
					{
						torneosi=1;
						strcpy (torneo,init);
						fgets(init,128,fp);
						if (strstr(init,"Numero incontri="))		/*Ricerca il numero degli incontri*/
						{
							totmatch=getval(init);
							fgets(init,128,fp);
						}
					}

				if (strstr(init,"----------"))        /*Ricerca eventuali parentele con torneo99*/
				  {
				    if (start==3)
				      {
					qvq=0;
					ftf=1;
				      }
				    else
				      {
					qvq=1;
					ftf=0;
				      }

		                     /*  dovrebbe modificare il nome del primo file di output, maper ora lo lascio uguale

                                    strcpy (dest,parkdest);
                                    strcat (dest,flg[qvq]);
                                    strcpy (dest1,parkdest1);
                                    strcat (dest1,flg[qvq]);
                                    strcpy (dest2,parkdest2);
                                    strcat (dest2,flg[qvq]);
                                    */

				    stamp();
				    strcpy (dest,parkdest);
				    strcat (dest,flg[ftf]);
				    strcpy (dest1,parkdest1);
				    strcat (dest1,flg[ftf]);
				    strcpy (dest2,parkdest2);
				    strcat (dest2,flg[ftf]);

				    /*stabilisce quale dei log e' f2f*/

				    /*memorizza i parziali per una successiva rielaborazione*/

				    for (nilo=1;nilo<=numrob;nilo++)
				       {
					 strcpy(parklist[nilo],rlist[nilo]);
					 parkperc[nilo]=(100*(float)(vitt[nilo]*punti[1]+vittmin[nilo]*premio+pari[1][nilo]*punti[2]+pari[2][nilo]*punti[3]+pari[3][nilo]*punti[4]-parmin[nilo]*punizione)/((float)sconf[nilo]*(punti[1]+premio)));
				       }
				    mrg=1;

				    /*riazzera i contatori*/

				    clean();
				    numrob=0;
				  }
			}
		while( (!feof(fp)) && !strstr(init,"cycles = ") );

		if(feof(fp)) break;

		starts=strstr(init,"cycles =")+9;
		cicli=(int)(atol(starts)/20000)+1;

		++actuamatch;

		if(cicli>10) cicli=10;
		zolla=0;
		do {
			fgets(init,128,fp);
			strcpy(xpark[++zolla],init);
		}
		while( (!feof(fp)) && !strstr(init,"Cumulative score") );
		if(feof(fp)) break;


		start=0;
		strcpy(cosa," wins");
		do
		{
			fgets(init,128,fp);
			if(strlen(init)>10) estrai(init);
		} while(!feof(fp) && strlen(init)>10);
		/*if(feof(fp)) break; */

		contendenti=start;
		if (!ripetute)
			for (iol=1;iol<=start;iol++)
				{
		    strcpy(listone[iol],nome[iol]);
				}

		flaggo=0;

		if (!ripetizioni)
			{
			for (iol=1;iol<=start;iol++)

				for (iul=1;iul<=start;iul++)
					flaggo+=(!(!strstr(listone[iul],nome[iol])));
			if (flaggo==start)
				++ripetute;
			else
					ripetizioni=ripetute;

			}

		zimbello=start;
		strcpy(cosa,"%");
		for(null=1;null<=zimbello;null++) {
			strcpy(park1[null],nome[null]);
			flag=calcola(nome[null]);
			for(pirla=1;pirla<=zimbello;pirla++) {
				strcpy(robot,nome[pirla]);
				if(strcmp(robot,nome[null])) {
					numero=calcola((char*)robot);
					gf2f[flag][numero]++;
				}
			}
		}

		start=0;
		for(null=1;null<=zolla;null++) {
			strcpy(init,xpark[null]);
			if(strlen(init)>10) estrai(init);
		}
		if(start==1) {
			strcpy(robot,nome[1]);
			strcpy(robot1,robot);
			numero=calcola((char*)robot);
			danno=(int)(atoi(dannos[1])/20)+1;
			schem[cicli+(danno-1)*15][numero]++;
			vitt[numero]++;
			if (cicli<6) vittmin[numero]++;
			flag=numero;
			for(pp=1;pp<=zimbello;pp++) {
				if(strcmp(robot1,park1[pp])) {
					vf2f[flag][(calcola(park1[pp]))]++;
					if (cicli<6) vminf2f[flag][(calcola(park1[pp]))]++;
				}
			}

		}
		else {
			for(niki=1;niki<=start;niki++) {
				strcpy(robot,nome[niki]);

				strcpy(robot1,robot);
				flag=calcola((char*)robot);
				danno=(int)(atoi(dannos[niki])/20)+1;
				schem[9+start+(danno-1)*15][flag]++;
				pari[start-1][flag]++;
				if ((start==4)&&(danno<3)) parmin[flag]++;
				par[flag]++;
				for(pp=1;pp<=start;pp++) {
					if (strcmp(robot1,nome[pp])) {
				if (start>1)
				  {
				    mediapar[flag][(calcola(nome[pp]))]+=atoi(dannos[pp])/(start-1);
				    if (start==2) media1[flag][(calcola(nome[pp]))]+=atoi(dannos[pp]);
				    if (start==3) media2[flag][(calcola(nome[pp]))]+=atoi(dannos[pp])/2;
				    if (start==4) media3[flag][(calcola(nome[pp]))]+=atoi(dannos[pp])/3;
				  }
						if (start==2) p2f2f[flag][(calcola(nome[pp]))]++;
						else if (start==3) p3f2f[flag][(calcola(nome[pp]))]++;
						else if (start==4)
										{
											p4f2f[flag][(calcola(nome[pp]))]++;
											if (danno<3) n4f2f[flag][(calcola(nome[pp]))]++;
										}
					}
				}
			}
		}

	}
	fclose(fp);

	stamp();
	if (mrg)
	  {
	    for(nilo=1;nilo<=numrob;nilo++)
	      {
	      for (mrg=1;mrg<=numrob;mrg++)
		 {
		   if (!strcmp(parklist[nilo],rlist[mrg]))
		     {
			qvqperc[nilo]=parkperc[nilo];
			ftfperc[nilo]=(100*(float)(vitt[mrg]*punti[1]+vittmin[mrg]*premio+pari[1][mrg]*punti[2]+pari[2][mrg]*punti[3]+pari[3][mrg]*punti[4]-parmin[mrg]*punizione)/((float)sconf[mrg]*(punti[1]+premio)));
			parkperc[nilo]=(pesi[qvq]*qvqperc[nilo]+pesi[ftf]*ftfperc[nilo])/(pesi[0]+pesi[1]);
		     }
		 }
	      }
	     mergedprint();
	  }
	return(0);
}

void	estrai(char *init)
{
	char	ric[4];
	char	*inizio;
	int	numero,n;


	for(n=1;n<=4;n++) {
		strcpy(ric,"(x)");
		ric[1]='0'+n;
		inizio=(char*) strstr(init,ric);
		if(inizio)
		{
			inizio=&(inizio[5]);

			start++;
			strcpy(nome[start],inizio);
			nome[start][10]=0;
			strcpy(robot,nome[start]);
			if(!inlist((char*)robot)) {

				numrob++;
				strcpy(rlist[numrob],robot);
			}
			numero=calcola((char*)robot);
			if(strcmp(cosa,"%")) sconf[numero]++;
			inizio=(char*)strstr(init,cosa);
			if(!strcmp(cosa,"%")) strcpy(dannos[start],&(inizio[2]));
			strcpy(init,&(inizio[4]));
		}
	}
}

int	calcola(char *robot)
{
	int numero;
	for(numero=1;strcmp(rlist[numero],robot);numero++);
	return(numero);
}

int	inlist(char *robot)
{
	int i;
	for(i=numrob;strcmp(rlist[i],robot)&&i;i--);
	return (i>0);
}

void	stamp()
{
	FILE *cana=NULL;
	FILE *can3;

	FILE *can6=NULL;
	char *h;
	int n,z,temp,t;
	char cla[90];

	strcat(dest,".txt");
#if defined(__MSDOS__)
	strcat(dest1,".htm");
#else
	strcat(dest1,".html");
#endif
	strcat(dest2,".lst");

	if (atxta)
	  {
	    if((cana=fopen(dest,"wt"))==NULL) {
		printf("Errore nell'apertura del file %s di output\n",dest);
		exit(1);
	    }
	    if((can6=fopen(dest2,"wt"))==NULL) {
		printf("Errore nell'apertura del file %s di output\n",dest2);
		exit(1);
	    }
	  }



	/*a questo punto a volte crasha*/

	if((can3=fopen(dest1,"wt"))==NULL) {
		printf("Errore nell'apertura del file %s di output\n",dest1);
		exit(1);
	}
	headhtml(cana,can3);
	for(n=1;n<=numrob;n++) {
		cla[n]=n;
		minimal(rlist[n]);
	}
	minimal((char*)rb);
  for(n=1;n<numrob;n++) {
	for(t=n+1;t<=numrob;t++) {
		if( ((float)(vitt[cla[t]]*punti[1]+vittmin[cla[t]]*premio-parmin[cla[t]]*punizione+pari[1][cla[t]]*punti[2]+pari[2][cla[t]]*punti[3]+pari[3][cla[t]]*punti[4])/(sconf[cla[t]]*(punti[1]+premio))) >
		((float)(vitt[cla[n]]*punti[1]+vittmin[cla[n]]*premio-parmin[cla[n]]*punizione+pari[1][cla[n]]*punti[2]+pari[2][cla[n]]*punti[3]+pari[3][cla[n]]*punti[4])/(sconf[cla[n]]*(punti[1]+premio))) ) {
			temp=cla[n];
			cla[n]=cla[t];
			cla[t]=temp;
		}
	}
  }
  if(cana) {
	  if (infoext==1)
	  {
		fprintf(cana,"    Nome  robot  - Partite - Partite - Partite - Partite - Punteggio - Perc    - Vittorie - Patte - Patte - Patte - Patte a 4\n");
		fprintf(cana,"    Combattente    giocate    vinte     patte     perse    ottenuto      %%       <100000     a 2     a 3     a 4    danni<40%%\n\n");
	  }
	  else
	  {
		fprintf(cana,"    Nome  robot  - Partite - Partite - Partite - Partite - Punteggio - Perc\n");
		fprintf(cana,"    Combattente    giocate    vinte     patte     perse    ottenuto      %%\n\n");
	  }
  }
  for (t=1;t<=numrob;t++) {
	n=cla[t];
	h=rlist[n];
	if(can6) fprintf(can6,"%s.r\n",h);
	if(cana) {
		if (infoext==1) fprintf(cana,"%2d %12s %9d %8d %9d %9d %11.0f %9.2f %8d %10d %7d %7d %7d\n",t,h,sconf[n],vitt[n],par[n],sconf[n]-vitt[n]-par[n],
			((float)(vitt[n]*punti[1]+vittmin[n]*premio+pari[1][n]*punti[2]+pari[2][n]*punti[3]+pari[3][n]*punti[4]-parmin[n]*punizione)),
			(100*(float)(vitt[n]*punti[1]+vittmin[n]*premio+pari[1][n]*punti[2]+pari[2][n]*punti[3]+pari[3][n]*punti[4]-parmin[n]*punizione)/((float)sconf[n]*(punti[1]+premio))),
			vittmin[n],pari[1][n],pari[2][n],pari[3][n],parmin[n] );
		else fprintf(cana,"%2d %12s %9d %8d %9d %9d %11.0f %9.2f\n",t,h,sconf[n],vitt[n],par[n],sconf[n]-vitt[n]-par[n],
			((float)(vitt[n]*punti[1]+vittmin[n]*premio+pari[1][n]*punti[2]+pari[2][n]*punti[3]+pari[3][n]*punti[4]-parmin[n]*punizione)),
			(100*(float)(vitt[n]*punti[1]+vittmin[n]*premio+pari[1][n]*punti[2]+pari[2][n]*punti[3]+pari[3][n]*punti[4]-parmin[n]*punizione)/((float)sconf[n]*(punti[1]+premio))));
	}
	fprintf(can3,"<tr><td><Font Size=+1>%u</FONT></td><td>\n", t);
	if ( (multiple==1)||(!strcmp(h,rb)) )
		fprintf(can3,"<a href=\"#%s\">",h);
	fprintf(can3,"<Font Size=+1>%s</FONT>",h);
	if ( (multiple==1)||(!strcmp(h,rb)) )
		fprintf(can3,"</a>",h);
	fprintf(can3,"</td><td>%u",sconf[n]);
	fprintf(can3,"</td><td>%u",vitt[n]);
	fprintf(can3,"</td><td>%u",par[n]);
	fprintf(can3,"</td><td>%u",sconf[n]-vitt[n]-par[n]);
	fprintf(can3,"</td><td>%.0f",((float)(vitt[n]*punti[1]+vittmin[n]*premio-parmin[n]*punizione+pari[1][n]*punti[2]+pari[2][n]*punti[3]+pari[3][n]*punti[4])) );
	fprintf(can3,"</td><td><b>%4.2f</b></td>",
		(100*(float)(vitt[n]*punti[1]+vittmin[n]*premio-parmin[n]*punizione+pari[1][n]*punti[2]+pari[2][n]*punti[3]+pari[3][n]*punti[4])/((float)sconf[n]*(punti[1]+premio))) );
	if (infoext==1)
	{
		fprintf(can3,"</td><td><FONT SIZE=-1><i>%u</i></FONT>",vittmin[n]);
		fprintf(can3,"</td><td><FONT SIZE=-1><i>%u</i></FONT>",pari[1][n]);
		fprintf(can3,"</td><td><FONT SIZE=-1><i>%u</i></FONT>",pari[2][n]);
		fprintf(can3,"</td><td><FONT SIZE=-1><i>%u</i></FONT>",pari[3][n]);
		fprintf(can3,"</td><td><FONT SIZE=-1><i>%u</i></FONT>",parmin[n]);
	}
	fprintf(can3,"</tr>\n");
  }
  if(can6) fclose(can6);

  fprintf(can3,"</table></center>\n");
  if (multiple==1) {
	for(n=1;n<=numrob;n++) {

		t=cla[n];
		dettagli(cana,can3,rlist[t],n);
	}
	banner(can3);
  } else {
	if(inlist((char*)rb)){
		for(n=1;cla[n]!=calcola((char*)rb);n++);
		dettagli(cana,can3,(char*)rb,n);
	}
	banner(can3);
  }

  if(cana) fclose(cana);
}

void    banner(FILE *can3)
{

	fprintf(can3,"<BR>\n");
	fprintf(can3,"<table BORDER=0 WIDTH=\"99%%\" ><tr><td WIDTH=\"75%%\">");
	fprintf(can3,"<i>Report creato da %s &copy Simone Ascheri & Michelangelo Messina\n",versio);
	if (torneosi)
		fprintf(can3,"<BR>%s</i></td></table></html>\n",torneo);
	fprintf(can3,"</i></td></table></html>");
	fclose(can3);
}

void	dettagli(FILE *cana, FILE *can3, char *co, int nn)
{
	float	ef;
	int	numero,o,t,n;
	int	y,j,temp;
	float	eff[90];
	char 	cla[90];

	fprintf(can3,"<BR>\n");

	if ((nn==1)&&(percentual==100))
		{
			fprintf(can3,"<center><hr WIDTH=\"88%%\" >\n");
			fprintf(can3,"<FONT SIZE =+4>\n");
			fprintf(can3,"<L><a name=%s>Il Torneo si &egrave concluso con la vittoria di</a><BR></FONT><FONT SIZE =+5>%s</L>\n",co,co);
			fprintf(can3,"</FONT></center><BR>\n");
		}
	fprintf(can3,"\n");

	if(cana) {
		fprintf(cana,"\n\n\nScheda tecnica del crobot %s:\n\n",co);
		fprintf(cana,"In classifica e' alla posizione numero %u\n\n",nn);
	}
	fprintf(can3,"<center><hr WIDTH=\"88%%\" ></center>\n");
	fprintf(can3,"<FONT SIZE =+2>\n");
	fprintf(can3,"<BR>\n");
	if ((percentual==100)&&(nn==1))
		fprintf(can3,"<L>Scheda tecnica del crobot <b>%s:</b></L>\n",co,co);
	else
		fprintf(can3,"<L>Scheda tecnica del crobot <b><a name=\"%s\">%s:</a></b></L>\n",co,co);
	fprintf(can3,"</FONT><BR>\n");
	fprintf(can3,"<FONT SIZE =+1><L>Nella <b><a href=#Testa>CLASSIFICA</a></b> &egrave alla posizione numero %u</L><BR>\n",nn);
	fprintf(can3,"</FONT><BR>\n");



	n = calcola(co);
	ef=(vitt[n]*punti[1]+vittmin[n]*premio+pari[1][n]*punti[2]+pari[2][n]*punti[3]+pari[3][n]*punti[4]-parmin[n]*punizione)/(sconf[n]*(punti[1]+premio))*100;
	if(cana) {
		fprintf(cana, "Partite combattute:%4d  Punteggio finale: %.0f\n",sconf[n],
		(float) (vitt[n]*punti[1]+vittmin[n]*premio+pari[1][n]*punti[2]+pari[2][n]*punti[3]+pari[3][n]*punti[4]-parmin[n]*punizione) );

		fprintf(cana, "Partite vinte     :%4d  Efficienza      :%3.2f\n",vitt[n],ef);
		fprintf(cana, "Partite pareggiate:%4d\nPartite perse     :%4d\n\n\n", par[n],sconf[n]-vitt[n]-par[n]);
	}
	fprintf(can3, "<table noborder>\n");
	fprintf(can3, "<tr><td>Partite combattute </td><td>%u</td>\n",sconf[n]);
	fprintf(can3, "<td>Punteggio finale   </td><td>%.0f</td></tr>\n",
		(float)(vitt[n]*punti[1]+vittmin[n]*premio+pari[1][n]*punti[2]+pari[2][n]*punti[3]+pari[3][n]*punti[4]-parmin[n]*punizione));
	fprintf(can3, "<tr><td>Partite vinte      </td><td>%u<//td>\n", vitt[n]);
	fprintf(can3, "<td>Efficienza         </td><td>%2.2f</td></tr>\n", ef);
	fprintf(can3, "<tr><td>Partite pareggiate </td><td>%u</td></tr>", par[n]);
	fprintf(can3, "<tr><td>Partite perse      </td><td>%u</td></tr>\n", sconf[n] - vitt[n] - par[n]);

	fprintf(can3, "</table><BR>\n");
	fprintf(can3,"<table border>\n<FONT>\n<tr nowrap>\n");
	fprintf(can3,"<th>CPU * 100\n");
	if(cana) {
		fprintf(cana, "                         Le vittorie sono maturate cosi'           |Pareggi|\n");
		fprintf(cana,"CPU * 10000 ");
	}
	for(y=1;y<=10;y++) {
		if(cana) fprintf(cana," |<%2d",2*y);
		fprintf(can3,"</th><th>%u",y*200);
	}
	if(cana) fprintf(cana," |1Sup|2Sup|3Sup\n");
	fprintf(can3,"</th><th>1Sup</th><th>2Sup</th><th>3Sup</th>");
	if(cana) {
		fprintf(cana,"            ");
		for(y=1;y<=13;y++) fprintf(cana," |   ");
		fprintf(cana,"\n");
	}


	for(j=1;j<=5;j++) {
		if(cana) fprintf(cana, "%2d<Danni<%3d ",(j-1)*20,j*20);
		fprintf(can3,"<tr><td>%u< Danni <%u",(j-1)*20,j*20);
		for(y=1;y<=13;y++) {
		   if(cana) fprintf(cana,"|%4d",schem[y+(j-1)*15][n]);
		   fprintf(can3,"</td><td>%u",schem[y+(j-1)*15][n]);
		}
		fprintf(can3,"</td></tr>\n");
		if(cana) fprintf(cana,"\n");
	}
	fprintf(can3,"<BR></table><BR>\n");
	fprintf(can3,"<FONT SIZE =+1>\n");
	fprintf(can3,"<BR><L>Le vittorie di <b>%s</b> sono maturate cos&igrave</L>\n",co);
	if(cana) {
		fprintf(cana,"\n %s ha riportato i seguenti risultati\n\n",co);
		if (infoext==1) {
			fprintf(cana," Nome del Robot    Partite   Partite   Perc.     Partite   Percentuale   Vittorie   Patte  Patte  Patte  Patte a 4\n");
			fprintf(cana,"  Combattente      giocate    vinte    vitt.      patte    aggiustata    <10000      a 2    a 3    a 4   danni<40%%\n");
		} else {
			fprintf(cana," Nome del Robot    Partite   Partite   Perc.     Partite   Percentuale\n");
			fprintf(cana,"  Combattente      giocate    vinte    vitt.      patte    aggiustata\n");
		}
	}
	fprintf(can3,"</FONT>\n");
	fprintf(can3,"<BR>\n");
	fprintf(can3,"<table border>\n");
	fprintf(can3,"<tr nowrap>\n");
	if (infoext==1) fprintf(can3,"<th>Pos</th><th>Nome del Crobot</th><th>Giocate</th><th>Vinte</th><th>Vitt%%</th><th>Patte</th><th>Tot%%</th><th><FONT SIZE=-1><i>Vitt. <100000</FONT></i></th><th><FONT SIZE=-1><i>Patte a 2</FONT></i></th><th><FONT SIZE=-1><i>Patte a 3</FONT></i></th><th><FONT SIZE=-1><i>Patte a 4</FONT></i></th><th><FONT SIZE=-1><i>Patte a 4 danni<40%%</FONT></i></th>\n");
	else fprintf(can3,"<th>Classifica</th><th>Nome del Crobot</th><th>Giocate</th><th>Vinte</th><th>Perc.Vitt.</th><th>Patte</th><th>Perc.Agg.</th><th><FONT SIZE=-1><i>1 Nemico %</FONT></i></th><th><FONT SIZE=-1><i>2 Nemici %</FONT></i></th><th><FONT SIZE=-1><i>3 Nemici %</FONT></i></th><th><FONT SIZE=-1><i>Media Gen.</FONT></i></th>\n");
	numero=calcola(co);
	for(n=1;n<=numrob;n++) {
		cla[n]=n;
		if(gf2f[numero][n]) {
			if (!ordinett) eff[n]=((float)vf2f[numero][n]*punti[1]+(float)vminf2f[numero][n]*premio+(float)p2f2f[numero][n]*punti[2]+(float)p3f2f[numero][n]*punti[3]+(float)p4f2f[numero][n]*punti[4]-(float)n4f2f[numero][n]*punizione)/(((float)premio+punti[1])*(float)gf2f[numero][n]);
			else eff[n]=(((float)vf2f[numero][n]*punti[1]+(float)vminf2f[numero][n]*premio)/(((float)premio+(float)punti[1])*gf2f[numero][n]));
		}
		else eff[n]=0;
	}
	eff[numero]=-1;

	for(n=1;n<numrob;n++) {
		for(t=n+1;t<=numrob;t++) {
			if( eff[cla[t]] > eff[cla[n]] ) {
				temp=cla[n];
				cla[n]=cla[t];
				cla[t]=temp;
			}
		}
	}

	for (n=1;n<=numrob;n++) {
		t=cla[n];
		if (gf2f[numero][t]) {
			if ((p2f2f[numero][t]+p3f2f[numero][t]+p4f2f[numero][t])>0) mediapar[numero][t]/=(p2f2f[numero][t]+p3f2f[numero][t]+p4f2f[numero][t]); else mediapar[numero][t]=100;
			if (p2f2f[numero][t]>0) media1[numero][t]/=p2f2f[numero][t]; else media1[numero][t]=100;
			if (p3f2f[numero][t]>0) media2[numero][t]/=p3f2f[numero][t]; else media2[numero][t]=100;
			if (p4f2f[numero][t]>0) media3[numero][t]/=p4f2f[numero][t]; else media3[numero][t]=100;
			if(cana) {
				if (infoext==1) fprintf(cana,"%2d %12s %8d %9d %9.2f %8d %12.2f %10d %10d %6d %6d %6d\n",n,rlist[t],gf2f[numero][t],vf2f[numero][t],
				  100*(((float)vf2f[numero][t]*punti[1]+vminf2f[numero][t]*premio)/((premio+punti[1])*gf2f[numero][t])),
				  p2f2f[numero][t]+p3f2f[numero][t]+p4f2f[numero][t],100*eff[t]
					,vminf2f[numero][t],p2f2f[numero][t],p3f2f[numero][t],p4f2f[numero][t],n4f2f[numero][t]);
				else fprintf(cana,"%2d %12s %8d %9d %9.2f %8d %12.2f\n",n,rlist[t],gf2f[numero][t],vf2f[numero][t],
				  100*(((float)vf2f[numero][t]*punti[1]+vminf2f[numero][t]*premio)/((premio+punti[1])*gf2f[numero][t])),
				  p2f2f[numero][t]+p3f2f[numero][t]+p4f2f[numero][t],100*eff[t]);
			}
			fprintf(can3,"<tr><td>%u</td><td>%s</td><td>%u</td><td>%u</td><td><b>%2.2f</b></td><td>%u</td><td><b>%2.2f</b>",n,rlist[t],gf2f[numero][t],vf2f[numero][t],
			  100*(((float)vf2f[numero][t]*punti[1]+vminf2f[numero][t]*premio)/((premio+punti[1])*gf2f[numero][t])),
			  p2f2f[numero][t]+p3f2f[numero][t]+p4f2f[numero][t],100*eff[t]);
			if (infoext!=1)
			{
				fprintf(can3,"</td><td><FONT SIZE=-1><i>%2.2f</i></FONT>",media1[numero][t]);
				fprintf(can3,"</td><td><FONT SIZE=-1><i>%2.2f</i></FONT>",media2[numero][t]);
				fprintf(can3,"</td><td><FONT SIZE=-1><i>%2.2f</i></FONT>",media3[numero][t]);
				fprintf(can3,"</td><td><FONT SIZE=-1><i>%2.2f</i></FONT>",mediapar[numero][t]);
			}
			else
			{
				fprintf(can3,"</td><td><FONT SIZE=-1><i>%u</i></FONT>",vminf2f[numero][t]);
				fprintf(can3,"</td><td><FONT SIZE=-1><i>%u</i></FONT>",p2f2f[numero][t]);
				fprintf(can3,"</td><td><FONT SIZE=-1><i>%u</i></FONT>",p3f2f[numero][t]);
				fprintf(can3,"</td><td><FONT SIZE=-1><i>%u</i></FONT>",p4f2f[numero][t]);
				fprintf(can3,"</td><td><FONT SIZE=-1><i>%u</i></FONT>",n4f2f[numero][t]);
			}

			fprintf(can3,"</td></tr>\n");
		}
		else break;
	}
	fprintf(can3,"<BR></table></FONT>\n");
}

void	headhtml(FILE *cana,FILE *can3)
{
	char	stima[9]=" ", prepos[5];

	fprintf(can3,"<html>\n");
	fprintf(can3,"<head>\n");
	fprintf(can3,"<meta name=\"GENERATOR\" content=\"Simone Ascheri & Michelangelo Messina\">\n");
	fprintf(can3,"<meta name=\"KEYWORDS\" content=\"Crobots Torneo 99\">\n");
	fprintf(can3,"<meta name=\"DESCRIPTION\" content=\"Risultati Crobots\">\n");
	fprintf(can3,"<title>Risultati Torneo Crobots</title>\n");
	fprintf(can3,"</head>\n");
	fprintf(can3,"<center>\n");
	fprintf(can3,"<FONT>\n");
	fprintf(can3,"<caption align=top><FONT SIZE=+4><a name=Testa>%s</a></FONT><BR>\n",intesta);

	if ((!totmatch)&&(ripetizioni)&&(actuamatch>(ripetizioni*numrob)))
		{
			strcpy(stima," stimati,");
			ricalco();
		}
	if (totmatch)
		{

			percentual=(actuamatch*100)/totmatch;
			if ((percentual==1)||(percentual==11)||(percentual==8)||((percentual>79)&&(percentual<90)))
				strcpy(prepos," all'");
			else
				if (percentual==0)
					strcpy(prepos," allo");
				else
					strcpy(prepos," al");
			if (!merg)
			  {
			    if(cana) fprintf(cana,"Sono stati disputati %ld incontri su %ld%s pari%s %u%% del totale\n",actuamatch,totmatch,stima,prepos,percentual);
			    fprintf(can3,"Sono stati disputati %ld incontri su %ld%s pari%s %u%% del totale</FONT><BR>\n",actuamatch,totmatch,stima,prepos,percentual);
			    if (percentual==100)
			       fprintf(can3,"La classifica &egrave definitiva<BR>\n");
			  }
			else
			  {
			    fprintf(can3,"&Egrave; stata utilizzata la formula <b>Eff. Tot</b>=(%d*<b>%s</b>+%d*<b>%s</b>)/%d\n",pesi[ftf],title[ftf],pesi[qvq],title[qvq],pesi[0]+pesi[1]);
			    fprintf(can3,"<BR>\n");
			  }
		       }


	fprintf(can3,"<FONT SIZE=-2>I punteggi sono stati assegnati con il sistema %s</caption><BR>\n",siste);
	fprintf(can3,"<table border><tr><td>Punti per la vittoria</td><td>%3.0f</td>\n",punti[1]);
	fprintf(can3,"<td>Premio per la vittoria sotto i 100000 cicli</td><td>%3.0f</td></tr>\n",premio);
	fprintf(can3,"<tr><td>Punti per il pareggio a due</td><td>%3.0f</td>\n",punti[2]);
	fprintf(can3,"<td>Punti per il pareggio a tre</td><td>%3.0f</td></tr>\n",punti[3]);
	fprintf(can3,"<tr><td>Punti per il pareggio a quattro</td><td>%3.0f</td>\n",punti[4]);
	fprintf(can3,"<td>Penalit&agrave; per il pareggio a 4 sotto il 40%% di danni</td><td>%3.0f</td></tr>\n",punizione);
	fprintf(can3,"</table><BR>\n");
	if(cana) {
		fprintf(cana,"I punteggi sono stati assegnati con il sistema %s\n",siste);
		fprintf(cana,"Punti per la vittoria   :%3.0f    Premio per la vittoria sotto i 100000 cicli :%3.0f\n",punti[1],premio);
		fprintf(cana,"Punti per pari a 2      :%3.0f    Punti per pari a 3                          :%3.0f\n",punti[2],punti[3]);
		fprintf(cana,"Punti per pari a 4      :%3.0f    Penalita' per paria a 4 sotto il 40%% danni  :%3.0f\n",punti[4],punizione);
		fprintf (cana,"\n");
	}
	fprintf(can3,"</FONT><br><table border>\n");
	fprintf(can3,"<tr nowrap>\n");
	if (merg)
	  {
	    fprintf(can3,"<th>Pos.</th><th>Nome del Crobot</th><th>%s</th><th>%s</th><th>Eff. Totale</th>\n",title[ftf],title[qvq]);
	  }
	else
	  {
	    if (infoext) fprintf(can3,"<th>Pos.</th><th>Nome del Crobot</th><th>Giocate</th><th>Vittorie Totali</th><th>Patte Totali</th><th>Perse</th><th>Punti</th><th>Eff.%%</th><th><Font SIZE=-1>Vittorie prima dei 10000 cicli</Font></th><th><Font SIZE=-1>Patte a 2</Font></th><th><Font SIZE=-1>Patte a 3</Font></th><th><Font SIZE=-1>Patte a 4</Font></th><th><Font SIZE=-1>Patte a 4 e Danni< 40%</Font></th>\n");
	    else fprintf(can3,"<th>Pos.</th><th>Nome del Crobot</th><th>Giocate</th><th>Vittorie Totali</th><th>Patte Totali</th><th>Perse</th><th>Punti</th><th>Eff.%%</th>\n");
          }

}

void uso()
{
  char barr[2];
  printf("Effettua il parsing dei risultati di un torneo di Crobots\n\n");

#if defined(__MSDOS__)
strcpy(barr,"/");
#else
strcpy(barr,"-");
#endif

  printf("Uso:\nCount Path\\NomeFileLog[senza.log] [NomeRobotStudiare[senza.r]] [%s(vtapbwxdnfqi)]\n",barr);
  printf("Switch [posizionabili ovunque]:\n");
  printf(" %sv     Ordina la tabellina dei confronti incrociati sulla percentuale vittorie\n",barr);
  printf(" %st     Crea il file .txt e il file .lst\n",barr);
  printf(" %sa     Stampa un report del comportamento incrociato di TUTTI i crobots\n",barr);
  printf(" %sp     Assegna i punti secondo lo schema Pranzo\n",barr);
  printf("        0  punti per la sconfitta o il pareggio a 4 sotto il 40%% di danni\n");
  printf("        1  punto per il pareggio a 4          2  punti per il pareggio a 3\n");
  printf("        3  punti per il pareggio a 2          12 punti per la vittoria\n");
  printf(" %sb     Aggiunge 3 punti per la vittoria sotto i 100000 cicli\n",barr);
  printf(" %sw=xx  Modifica il punteggio per la vittoria\n",barr);
  printf(" %sx     Elimina la penalizzazione per pareggi a 4 con danni sotto il 40%% (schema Pranzo)\n",barr);
  printf(" %sd     Abilita la visualizzazione delle info aggiuntive su vittorie e pareggi\n",barr);
  printf(" %sq=xx  Modifica il peso del torneo 4vs4 nella classifica totale\n",barr);
  printf(" %sf=xx  Modifica il peso del torneo f2f nella classifica totale\n",barr);
  printf(" %sn=n   Aggiunge al report la percentuale di incontri disputata\n",barr);
  printf(" \"%si=???\" Usa ??? come intestazione del report HTML\n\n",barr);
#if defined(__MSDOS__)
  printf(" I file di output sono:   Path\\NomeFileDiLog.htm    Path\\NomeFileDiLog.txt\n");
  printf("                          Path\\NomeFileDiLog.lst\n");
#else
  printf(" I file di output sono:   Path/NomeFileDiLog.html    Path/NomeFileDiLog.txt\n");
  printf("                          Path/NomeFileDiLog.lst\n");
#endif
  exit(-1);
}

void minimal(char *init)
{
	char i,o;
	for(i=0;i<strlen(init);i++) {

		if(init[i]!=':'&&init[i]!='/'&&init[i]!='\\'&&init[i]!=32) init[i]=tolower(init[i]);
		else {
			for(o=i;o<(strlen(init));o++) init[o]=init[o+1];
			i--;
		}
	}
}

long	getval(char *from)
{
	char *r;
	r=(char*)strchr(from,'=');
	return(atol(r+1));
}

void fatt()
{
	int provv, contiamo;

	provv=1;
	for (contiamo=1;contiamo<=contendenti;contiamo++)
		provv*=contiamo;

	contendenti=provv;
}

void ricalco()
{
	int conta;

	totmatch=1;
	for (conta=(numrob-contendenti+1);conta<=numrob;conta++)
			totmatch*=conta;
	fatt();
	totmatch=(totmatch*ripetizioni)/contendenti;
}

/*inizializza array e variabili*/

void clean()
{
int k, nuli;
	for(k=1;k<90;k++) {
		vitt[k]=0;
		vittmin[k]=0;
		par[k]=0;
		sconf[k]=0;
		pari[1][k]=0;
		pari[2][k]=0;
		pari[3][k]=0;
	}
	for(k=1;k<75;k++) for(nuli=1;nuli<90;nuli++) schem[k][nuli]=0;


	for(k=1;k<90;k++) for(nuli=1;nuli<90;nuli++) {

		gf2f[k][nuli]=0;
		vf2f[k][nuli]=0;
		vminf2f[k][nuli]=0;
		p2f2f[k][nuli]=0;
		p3f2f[k][nuli]=0;
		p4f2f[k][nuli]=0;
		n4f2f[k][nuli]=0;
		media1[k][nuli]=0;
		media2[k][nuli]=0;
		media3[k][nuli]=0;
		mediapar[k][nuli]=0;
	}
  actuamatch=0;
  totmatch=0;

}

void    mergedprint()
{
	FILE *cana=NULL;
	FILE *can3;

	FILE *can6=NULL;
	char *h;
	int n,z,temp,t;
	char cla[90];

        strcpy (dest,parkdest);
        strcat (dest,"T");
	strcpy (dest1,parkdest1);
        strcat (dest1,"T");
	strcpy (dest2,parkdest2);
        strcat (dest2,"T");

	strcat(dest,".txt");
#if defined(__MSDOS__)
	strcat(dest1,".htm");
#else
	strcat(dest1,".html");
#endif
	strcat(dest2,".lst");

	if (atxta)
	  {
	    cana=fopen(dest,"wt");
	    can6=fopen(dest2,"wt");
	  }
	can3=fopen(dest1,"wt");
	merg=1;
	headhtml(cana,can3);
	for(n=1;n<=numrob;n++) {
		cla[n]=n;
		minimal(parklist[n]);
	}
	minimal((char*)rb);
	if(cana) {
		fprintf(cana,"    Nome  robot  -   Eff.  -   Eff.  -   Eff. \n");
		fprintf(cana,"    Combattente      4vs4      f2f      Totale\n");
	}
	for(n=1;n<numrob;n++) {
		for(t=n+1;t<=numrob;t++) {
			if(parkperc[cla[t]] > parkperc[cla[n]])
			{
				temp=cla[n];
				cla[n]=cla[t];
				cla[t]=temp;
			}
		}
	}
	for (t=1;t<=numrob;t++) {
		n=cla[t];
		h=parklist[n];
		if(can6) fprintf(can6,"%s.r\n",h);
		fprintf(can3,"<tr><td><Font Size=+1>%u</FONT></td><td>\n", t);

		fprintf(can3,"<Font Size=+1>%s</FONT>",h);

		fprintf(can3,"</td><td>%3.2f",ftfperc[n]);

		fprintf(can3,"</td><td>%3.2f",qvqperc[n]);
		fprintf(can3,"</td><td><b>%3.2f</b>",parkperc[n]);
		fprintf(can3,"</tr>\n");
		if(cana) fprintf(cana,"%2d %12s %9.2f %9.2f %9.2f\n",t,h,ftfperc[n],qvqperc[n],parkperc[n]);
	}
	if(can6) fclose(can6);
	fprintf(can3,"</table></center>\n");
	banner(can3);
	if(cana) fclose(cana);
}
