/***************************************************************************
                             ppc.h  -  Preprocessore per crobots
                             -----------------------------------
    begin                : thu jun 6 11:00:36 CET 2000
    copyright            : (C) 2000 by Marco Giovannini
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PPC_H
#define PPC_H

#ifndef NULL
#define NULL              0
#endif
#ifndef TRUE
#define TRUE              1
#endif
#ifndef FALSE
#define FALSE             0
#endif

#define MAXPARAMS         20

#define READBUFSIZE       2048
#define BUFSIZE           (2*READBUFSIZE)

#define PPC_OK            0
#define PPC_FILENOTEXIST  1
#define PPC_NODEFNAME     2
#define PPC_DEFNOTDEFINED 3
#define PPC_NOTINIF       4
#define PPC_NODEFVALUE    5

#include <string.h>

class PPCError
{
public:
    PPCError(int code=0, char* file=NULL, int line=0) { set(code,file,line); }
	void set(int code, char* file, int line)
	    { setCode(code); setFileName(file); setLine(line); }
	
    int getCode(void)             { return cod; }
    void setCode(int code)        { cod=code; }
    char* getFileName(void)       { return fil; }
    void setFileName(char* file)  { if (file) strcpy(fil,file); }
    int getLine(void)             { return lin; }
    void setLine(int line)        { lin=line; }

private:
    int   cod, lin;
    char  fil[80];
};


extern FILE* fopen_read(char* fname, PPCError* error);
extern FILE* fopen_write(char* fname, PPCError* error);

#endif

