package it.edmaster.eLisa.ordini;

import java.sql.*;
import java.util.*;

import it.edmaster.eLisa.*;
import it.edmaster.eLisa.common.*;
import it.edmaster.eLisa.util.*;

public class ElencoOrdini {
    
    public ElencoOrdini() {
    }
    
    public Pagina getElenco( String codiceUtente, boolean evaso, int inizio, int quanti ) 
            throws CaricamentoOrdiniException {
                
        Pagina pagina = null;
        
        OrdiniDAO dao = DAOLocator.getInstance().getOrdiniDAO();
        
        try {
            pagina = dao.getElenco( codiceUtente, evaso, inizio, quanti );
        } catch( SQLException se ) {
            throw new CaricamentoOrdiniException( se );
        }
        
        //Logger.log( "getElenco() " + pagina );

        return pagina;
    }
    
}
