package it.edmaster.eLisa.utenti;

public class Utente {
    
    static UtenteNonEsistente utenteNonEsistente = new UtenteNonEsistente();
    
    int id;
    String codiceUtente;
    String password;
    String nome;
    String cognome;
    int livello;
    
    public Utente() {
    }
    
    public Utente( int id, String codiceUtente, String password, String nome, String cognome,
        int livello ) {
            
        this.id = id;
        this.codiceUtente = codiceUtente;
        this.password = password;
        this.nome = nome;
        this.cognome = cognome;
        this.livello = livello;
    }
    
    public String getCodiceUtente() {
        return codiceUtente;
    }
    
    public String getNome() {
        return nome;
    }
    
    public String getCognome() {
        return cognome;
    }
    
    public String getPassword() {
        return password;
    }
    
    public String getDescrizione() {
        return nome + " " + cognome;
    }
    
    public int getLivello() {
        return livello;
    }
    
    public boolean autentica( String password ) {
        return this.password.equals( password );
    }
    
    public static Utente getUtenteNonEsistente() {
        return utenteNonEsistente;
    }
    
    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append( "Utente=[id=" );
        sb.append( id );
        sb.append( ", codiceUtente=" );
        sb.append( codiceUtente );
        sb.append( ", password=" );
        sb.append( password );
        sb.append( ", nome=" );
        sb.append( nome );
        sb.append( ", cognome=" );
        sb.append( cognome );
        sb.append( ", livello=" );
        sb.append( livello );
        sb.append( "]" );
        
        return sb.toString();
    }
}

