import java.sql.*;

public class SupportoDatabase {

    Connection conn;
    
    public SupportoDatabase() {
        try {
            connect();
            
            CategorieProdotto cp = new CategorieProdotto( conn );
            cp.generate();
            
            Utenti ut = new Utenti( conn );
            ut.generate();
            
            Prodotti p = new Prodotti( conn );
            p.generate();
            
        } catch( Exception ex ) {
            ex.printStackTrace();
        }
    }
    
    protected void connect() throws ClassNotFoundException, InstantiationException, 
            IllegalAccessException, SQLException {
        Class.forName("com.mysql.jdbc.Driver").newInstance();
        conn = DriverManager.getConnection("jdbc:mysql:///elisa?user=max&password=max");
    }
    
    public static void main( String[] args ) {
        new SupportoDatabase();
    }
    
}
