<%@ page errorPage="../include/PaginaErrore.jsp" %>
<%@ taglib prefix='c' uri='http://java.sun.com/jstl/core' %>
<%@ taglib prefix='fmt' uri='http://java.sun.com/jstl/fmt' %>

<jsp:useBean
  id="carrello"
  class="it.edmaster.eLisa.carrello.CarrelloHelper"
  scope="session"
/>

<HTML>
<HEAD>
    <TITLE>eLisa - Carrello</TITLE>
    <LINK REL="stylesheet" HREF="css/default.css" TYPE="text/css"/>
</HEAD>    
<BODY MARGINHEIGHT="0" MARGINWIDTH="0" MARGINTOP="0" MARGINLEFT="0">
<jsp:include page="../include/testata.jsp" />

<TABLE BORDER="0" WIDTH="100%" CELLSPACING="0" CELLPADDING="5">
<TR>
    <TD WIDTH="20%" CLASS="sidebar"></TD>
    <TD WIDTH="60%">
        <H1>Carrello</H1>
    </TD>
    <TD WIDTH="20%" CLASS="sidebar"></TD>
</TR>

<TR>
    <TD CLASS="sidebar">
        <jsp:include page="../include/sinistra.jsp"/>
    </TD>
    
    <TD STYLE="padding: 20px">
        <TABLE BORDER="0" WIDTH="100%">
            <TR BGCOLOR="#EEEEEE">
                <TD>Prodotto</TD>
                <TD>Prezzo</TD>
                <TD>IVA</TD>
                <TD>Sconto</TD>
                <TD>Totale</TD>
            </TR>
            
            <c:forEach var="item" items="${carrello.elenco}" varStatus="status">
            <TR>
                <TD><c:out value="${item.nome}" /></TD>
                <TD CLASS="carrello-importi"><fmt:formatNumber value="${item.prezzo}" pattern="####.00"/></TD>
                <TD CLASS="carrello-importi"><c:out value="${item.iva.descrizione}" /></TD>
                <TD CLASS="carrello-importi"><fmt:formatNumber value="${item.sconto}" pattern="###.##"/>%</TD>
                <TD CLASS="carrello-importi"><fmt:formatNumber value="${item.prezzoFinale}" pattern="####.00"/></TD>
            </TR>
            </c:forEach>
            <TR BGCOLOR="#EEEEEE">
                <TD>&nbsp;</TD>
                <TD>&nbsp;</TD>
                <TD>&nbsp;</TD>
                <TD>&nbsp;</TD>
                <TD CLASS="carrello-importi"><fmt:formatNumber value="${carrello.totale}" pattern="######.00"/></TD>
            </TR>
        </TABLE>
        <P>
        (*) gli importi sono espressi tutti in euro.
        <P>
        <TABLE BORDER="0" WIDTH="100%">
        <TR>
            <TD WIDTH="100%">&nbsp;</TD>
            <c:if test="${carrello.numeroProdotti>0 && !empty sessionScope.utenteConnesso}">
            <TD>
                <FORM ACTION="controller?op=carrello.checkout.1" METHOD="post">
                    <INPUT TYPE="submit" VALUE="Procedi con l'ordine"/>
                </FORM>
            </TD>
            <TD>
                <FORM ACTION="controller?op=carrello.svuota" METHOD="post">
                    <INPUT TYPE="submit" VALUE="Svuota il carrello"/>
                </FORM>
            </TD>
            </c:if>
            <TD>
                <FORM ACTION="controller?op=home" METHOD="post">
                    <INPUT TYPE="submit" VALUE="Continua lo shopping"/>
                </FORM>
            </TD>
        </TR>
        </TABLE>
        <P>
        <c:if test="${empty sessionScope.utente}">
        Non  possibile ordinare i prodotti in quanto non hai eseguito il login
        </c:if>
    </TD>
    
    <TD CLASS="sidebar">
        <jsp:include page="../include/destra.jsp"/>
    </TD>
</TR>

<jsp:include page="../include/piede.jsp" />

</BODY>
</HTML>
