<%@ page errorPage="../include/PaginaErrore.jsp" %>
<%@ taglib prefix='c' uri='http://java.sun.com/jstl/core' %>

<jsp:useBean
  id="catalogo"
  class="it.edmaster.eLisa.catalogo.CatalogoHelper"
  scope="session"
/>

<c:set value="${param.testo}" target="${catalogo}" property="testoDaCercare"/>
<c:set value="${catalogo.risultatoRicerca}" var="paginaRisultati" />

<HTML>
<HEAD>
    <TITLE>eLisa - Dettagli Prodotto</TITLE>
    <LINK REL="stylesheet" HREF="css/default.css" TYPE="text/css"/>
</HEAD>    
<BODY>
<H1>Risultati della ricerca</H1>
<P>
Hai cercato <c:out value="${param.testo}" />
<P>

<table border="0"
       width="100%"
       cellpadding="1"
       cellspacing="0">

<c:forEach var="item" items="${paginaRisultati.elenco}" varStatus="status">
    <tr>
    
    <td>
        <A HREF="controller?op=catalogo.dettagliProdotto&id=<c:out value="${item.id}" />"/>
        <c:out value="${item.nome}" /><BR>
        </A>
        <c:out value="${item.descrizione}" /><BR>
    </td>
    
    </tr>
</c:forEach>

</table>

</BODY>
</HTML>
