main (int ident)
{
  int ret, x, y, i;
  int master_id;
  unsigned int c;

  c = (0x0001 << (ident-1));

  master_id = message (1000, ident);

  if (master_id == 0) {
    x = 100;
    y = 100;
  } else {
    do 
      ret = message (1000+master_id, 0);
    while (ret == 0);

    x = ret / 1000;
    y = ret % 1000;
  }
  message (1000+ident, (x+100)*1000+y+100);
  Go (x, y);

  if (master_id == 0) {
    message (1010, 0x0100);
    for (x=0;;x=1-x) {
      for (i=0; i<100; i++)
        loc_x ();
      while (message (1010, 0) == 0);
      while (cannon ((x ? 90 : 0), 200) == 0);
      message (1010, 0x00FF | (x ? 0x0100 : 0x0000));
    }     
  } else {
    for (;;) {
      while ((ret = message (1010, 0)) == 0);
      if (ret & c) {
        while (cannon (((ret & 0x0100) ? 90 : 0), 200) == 0);
        ret &= ~c;
      }
      message (1010, ret);
    }
  }
}

Go (int dest_x, int dest_y)
{
  int course, dist;

  while ((dist=distance (loc_x(), loc_y(), dest_x, dest_y)) > 1) {
    course = plot_course (dest_x, dest_y);
    drive (course, dist);
  }
  drive (course, 0);
}
                                   /* classical pythagorean distance formula */
int distance (x1, y1, x2, y2)
{
  int x, y;
  x = x1 - x2;
  y = y1 - y2;
  return (sqrt((x*x) + (y*y)));
}
                           /* plot course function, return degree heading to */
                         /* reach destination x, y; uses atan() trig function */
int plot_course (xx,yy)
{
  int ret;
  int x,y;
  int scale;
  int curx, cury;

  scale = 100000;                                 /* scale for trig functions */
  curx = loc_x();                                     /* get current location */
  cury = loc_y();
  x = curx - xx;
  y = cury - yy;
                    /* atan only returns -90 to +90, so figure out how to use */
                                                          /* the atan() value */

  if (x == 0) {      /* x is zero, we either move due north or south */
    if (yy > cury)
      ret = 90;        /* north */
    else
      ret = 270;       /* south */
  } else {
    if (yy < cury) {
      if (xx > curx)
        ret = 360 + atan((scale * y) / x);  /* south-east, quadrant 4 */
      else
        ret = 180 + atan((scale * y) / x);  /* south-west, quadrant 3 */ 
    } else {
      if (xx > curx)
        ret = atan((scale * y) / x);        /* north-east, quadrant 1 */
      else
        ret = 180 + atan((scale * y) / x);  /* north-west, quadrant 2 */
    }
  }
  return (ret);
}

