package com.mcapp.servlet;

import javax.servlet.http.*;
import javax.servlet.RequestDispatcher;

public class Controller extends HttpServlet
{

    public final void doGet(HttpServletRequest req, HttpServletResponse resp)
    {
        this.doPost(req, resp);
    }

    private String getOutputType(HttpServletRequest request)
    {
        String userAgent = request.getHeader("User-Agent");
        if (userAgent.indexOf("UP.Browser") >= 0)
            return "wml";
        return "html";
    }

    private String getAction(HttpServletRequest request)
    {
        String action = request.getParameter("Action");
        if (action == null)
            return "error";
        return action;
    }

    public final void doPost(HttpServletRequest req, HttpServletResponse resp)
    {

        String type = null;
        String action = null;
        type = getOutputType(req);
        action = getAction(req);

        RequestDispatcher rd;
        try
        {
            rd =
                getServletContext().getRequestDispatcher(
                    "/jsp/".concat(action).concat("_").concat(type).concat(
                        ".jsp"));
            rd.forward(req, resp);
        }
        catch (Exception ex)
        {
        }

    }

}
