#include <iostream>
#include <string>

using namespace std;


//Funzione per il test di uguaglianza tra stringhe mediante operatore "=="
void test(const string& a, const string& b) {
	cout << "Le stringhe (" << a << ") e (" << b << ") ";	
	if (a == b)
		cout << "SONO uguali!\n";
	else
		cout << "NON sono uguali!\n";
}


void main() 
{
 	//////////////////////////////////////////////////////////////////////
	//concatenazione di stringhe
	string s1 = "La mia prima";
	string s2 = " stringa concatenata";
	string s1_s2 = s1 + s2; //"La mia prima stringa concatenata" :-)
	//////////////////////////////////////////////////////////////////////
	
	
	//////////////////////////////////////////////////////////////////////
	//stampa di stringhe con cout
	cout << s1_s2 << endl;
	//////////////////////////////////////////////////////////////////////
	
	//////////////////////////////////////////////////////////////////////
	//concatenazione con l'operatore "+="
	string s3 = "Seconda";
	s3 += s2; //"Seconda stringa concatenata"

	cout << s3 << endl;
	//////////////////////////////////////////////////////////////////////

	//////////////////////////////////////////////////////////////////////
	//Differenza tra concatenazione di stringhe e concatenazione di flussi
	string s5 = "Ci";
	string s6 = "ao!";
	//stampo una stringa concatenata
	cout << (s5 + s6) << endl;
	//concateno i FLUSSI di stampa! 
	cout << s5 << s6 << endl; 
	//////////////////////////////////////////////////////////////////////

	//////////////////////////////////////////////////////////////////////
	//Test di uguaglianza tra stringhe 
	string s7 = "Ciao!";
	string s8 = "Ciao!";
	string s9 = "Hello!";
	test(s7,s8);
	test(s7,s9);
	//////////////////////////////////////////////////////////////////////


	//////////////////////////////////////////////////////////////////////
	//Test di comparazione lessicale con l'operatore ">"
	string casa = "casa";
	string castello = "castello";

	if (castello > casa)
		cout << "La condizione (castello > casa) e' \"true\"" << endl;
	//////////////////////////////////////////////////////////////////////


	//////////////////////////////////////////////////////////////////////
	//Utilizzo di cin e getline()
	cout << "Ciao! Come ti chiami? ";
	string nome;
 	
	//provare a commentare *alternativamente* le seguenti due istruzioni
	cin >> nome;
	//getline(cin,nome); 

 	cout << "Ciao " << nome << "! Io sono HAL 9000..." << endl;
	//////////////////////////////////////////////////////////////////////

}
