#define MAXROB 32

#define msdos 1
#define correctcrh 1
#define __TURBO__ 1
/*#define djgpp 1*/
/* Righe da COMMENTARE x compilare in LINUX
*/
/*#define debug 1*/
#ifdef WIN32
#define msdos 1
#endif

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<time.h>
#include	<ctype.h>
#ifdef linux
#include	<termio.h>
#include	<curses.h>
#else
#include 	<process.h>
#include	<conio.h>
#include	<io.h>
#include    <sys\stat.h>
#endif
#ifdef WIN32
#include	<direct.h>
void clrscr();
void gotoxy(int x, int y);
void clreol();
#endif

#ifdef	msdos
void	patch(void);
#else
#ifdef debug
 #define kbhit() getchar()
#endif
#endif
int	getval(char *from);
void 	analisi();
void	aggiorna(long nr);
void	finale(int exitmode);
void	init(FILE *fp, char status);
void	stampa(FILE *fp, int maxrow, long nr);
#ifdef linux
void	stampaw(long nr);
#endif
void	save(long k, char mode);
void	esci();
void	pulisci();
void	uso();
void	errore(char status);
void	comando(char* cm, int argc, char *argv[]);
int     torneo(char);
void	logrestore();

#ifdef msdos
void refresh(void);
void initscr(void);
void cbreak(void);
void noecho(void);
void curs_set();
void endwin(void);
#endif

#define msrand() srand((unsigned int) time(NULL))
#ifdef msdos
#define mrand(num)((long)(rand()*((float)num))/(RAND_MAX+1.0))
#else
#define mrand(num) ((long)(rand()%(num)))
#endif

int	numrob=0,limrob=0;
int	numinc=0,mnuminc=0;
int	bitorneo=0;
int	birep=0;
char	rob[MAXROB+1][50];
char	srob[MAXROB+1][50];
long	data[MAXROB+1][4];
long	c=0,bias=0;
long	matches=0;
int	matchperc=10;
#ifdef __TURBO__
char huge in[143841L]; /*(MAXROB*(MAXROB-1)*(MAXROB-2)*(MAXROB-3)/6)+1*/
void	scambia(long i,long j,char huge *in);
void	mischia(long j, char huge *in);
void	scambiaf2f(long i,long j,char huge *in);
void	mischiaf2f(long j, char huge *in);
#else
char	*in;
void	scambia(long i,long j,char *in);
void	mischia(long j, char *in);
void	scambiaf2f(long i,long j,char *in);
void	mischiaf2f(long j, char *in);
#endif

char	fileout[50];
int	isfileout=0;
char	temp[256];
int	plog=0;
FILE	*flog=NULL;
char	extcount[256];
int	ordine=0;
int	rep=1;
int	win=3;
int	pari=1;
int	rtest=0,mtest=0;
int	quiet=0;
int	f2f=0;
#ifdef debug
char    versio[50]="TORNEO XP debug version";
#else
char	versio[50]="TORNEO XP v2.0";
#endif
char	robstring[100]="torneo.rob";
char	dirstring[100];
char	outstring[100];
int	fake=0;
char 	fk[8]="";
char	logridotto=0;
char	autocount=0;




#ifdef linux
	#define clrscr clear
#else
	#define clear clrscr
	#define printw printf
#endif


int main(int argc, char *argv[])
{
	int	z;
	FILE	*fp;
	char	nuovo=0;

	outstring[0]=0;
	extcount[0]=0;

	if (argc!=1) {
		if(!strcmp(argv[1],"save")) comando("save",argc,argv);
		else if(!strcmp(argv[1],"quit")) comando("quit",argc,argv);
		else if(!strcmp(argv[1],"agg")) comando("aggiorna",argc,argv);

		else for(z=1;z<argc;z++)
		{
			if(argv[z][0]=='-') {
				if((tolower(argv[z][1]))=='f') f2f=1;
				else if((tolower(argv[z][1]))=='r'&&(strlen(argv[z])>3)) {
					rtest=1;
					strcpy(rob[0],(argv[z]+3));
				}
				else if((tolower(argv[z][1]))=='m') {
					mtest=1;
					mnuminc=getval(argv[z]);
				}
				else if((tolower(argv[z][1]))=='o') ordine=1;
				else if((tolower(argv[z][1]))=='x') rep=0;
				else if((tolower(argv[z][1]))=='t') plog=1;
				else if((tolower(argv[z][1]))=='l') limrob=getval(argv[z]);
				else if((tolower(argv[z][1]))=='q') quiet=1;
				else if((tolower(argv[z][1]))=='w') win=getval(argv[z]);
				else if((tolower(argv[z][1]))=='p') pari=getval(argv[z]);
				else if((tolower(argv[z][1]))=='d') strcpy(outstring,(argv[z]+3));
				else if((tolower(argv[z][1]))=='c') {
					if (strlen(argv[z])>3) {
					#ifdef correctcrh
						if(argv[z][3]!='\'')
					#endif
						strcpy(extcount,(argv[z]+3));
					}
					else if(strlen(argv[z])==2) {
						#ifdef msdos
						strcpy(extcount,"count /p /q=5 ");
						#else
						strcpy(extcount,"count -p -q=5 ");
						#endif
						autocount=1;
					}
				} else if((tolower(argv[z][1]))=='a') {
					bitorneo=1;
					birep=getval(argv[z]);
				}

			}
			else strcpy(robstring,argv[z]);
		}

	}
	remove("cmnd");
	if(!quiet) {
		#ifdef __TURBO__
			textmode(C80);
		#endif
		printf("\n\n\n\n\nCROBOTS %s\nCopyright (C) Michelangelo Messina\n",versio);
		printf("e-mail m.messina@tiscalinet.it\n       m.messina@libero.it\n");
		printf("http://go.to/crobots\n");
		printf("www.yahoogroups.com/group/crobots\n\n\n\n");
	}

	if(!strstr(robstring,".")) strcat(robstring,".rob");
	if(!outstring[0]) {
		strcpy(outstring,robstring);
		while(strstr(outstring,"\\"))strcpy(outstring,strstr(outstring,"\\")+1);
		while(strstr(outstring,"/"))strcpy(outstring,strstr(outstring,"/")+1);
		if(strstr(outstring,".")) *(strstr(outstring,"."))=0;
		strcpy(dirstring,outstring);
		strcpy(fileout,dirstring);
		strcat(fileout,".sco");
	} else {
		strcpy(dirstring,outstring);
		strcpy(fileout,outstring);
		if(strstr(dirstring,".")) *(strstr(dirstring,"."))=0;
		while(strstr(dirstring,"\\"))strcpy(dirstring,strstr(dirstring,"\\")+1);
		while(strstr(dirstring,"/"))strcpy(dirstring,strstr(dirstring,"/")+1);
		if(strstr(outstring,".")) *(strstr(outstring,"."))=0;
		if(!strstr(fileout,".")) strcat(fileout,".sco");
	}
	strcpy(temp,outstring);
	strcat(temp,".msg");
	remove(temp);
	if(bitorneo) f2f=1;

	if(autocount) strcat(extcount,outstring);

	if(!quiet) {
		initscr();
		cbreak();
		noecho();

		clear();
		curs_set(0);
		printw("CROBOTS %s\nCopyright (C) Michelangelo Messina\n",versio);
		printw("e-mail m.messina@tiscalinet.it\n       m.messina@libero.it\n");
		printw("http://go.to/crobots\n");
		printw("www.yahoogroups.com/group/crobots\n\n\n\n");
		printw("Un ringraziamento speciale a\n TOM POINTEXTER - autore del programma CROBOTS\n\n\n");
		printw("\n\nDedicato a tutti gli amanti di Crobots\n\n");
		if(f2f) printw("\n\nModalita' Face2Face");
		else printw("\n\n");

		/* debug */
		#ifdef debug
		{
			int i;
			printw("\nRiga di comando ");
			for(i=0;i<argc;i++) printw("%s ",argv[i]);
		}
		#endif
		/*debug */

		printw("\n\n Premi un tasto\n");
		refresh();
		#ifdef msdos
			while(!kbhit());
		#endif
		getch();
		clear();
	}

	strcpy(temp,outstring);
	strcat(temp,".da_");
	if((fp=fopen(temp,"rt"))!=NULL) {
		fclose(fp);
		if(!quiet) {
			printw("\nHo trovato un'interruzione anomala!\n");
			printw("Digitare N se si vuole iniziare un nuovo torneo (i vecchi dati saranno persi)\n");
		#ifdef linux
			refresh();
			if((z=getchar())=='N' || z=='n') {
		#else
			while(!kbhit());
			if((z=getch())=='N' || z=='n') {
		#endif
				nuovo=1;
				remove(temp);
			}
		}
		if (!nuovo) {
			char temp1[256];
			strcpy(temp1,outstring);
			strcat(temp1,".dat");
			if(rename(temp,temp1)) {
				endwin();
				if(!quiet) printf("Errore nel recupero dei dati!\n");
				else {
					strcpy(temp,outstring);
					strcat(temp,".msg");
					if((fp=fopen(temp,"wt"))!=NULL) {
						fprintf(fp,"Errore nel recupero dei dati\n");
						fclose(fp);
					}
				}
				exit(-1);
			}
			logrestore();
			strcpy(temp,outstring);
			strcat(temp,".dat");
			if(!quiet) printw("\n\nRecupero dati effettuato con SUCCESSO\n\n");
		}
	} else {
		strcpy(temp,outstring);
		strcat(temp,".dat");
		if((fp=fopen(temp,"rt"))!=NULL) {
			fclose (fp);
			if(!quiet) {
				printw("\nHo trovato un salvataggio precedente !\n");
				printw("Digitare N se si vuole iniziare un nuovo torneo (i vecchi dati saranno persi)\n");
			#ifdef linux
				refresh();
				if((z=getchar())=='N' || z=='n') {
			#else
				while(!kbhit());
				if((z=getch())=='N' || z=='n') {
			#endif
					nuovo=1;
					remove(temp);
				}
			}
		} else nuovo=1;
	}

	#ifndef __TURBO__
	if((in=(char *)calloc((MAXROB*(MAXROB-1)*(MAXROB-2)*(MAXROB-3)/6)+1,sizeof(char)))==NULL) {

		printf("Memoria non allocata\n");
		exit(-1);

	}
	#endif

	if(torneo(nuovo)){
		#ifdef debug
		printf("alla fine del torneo:\n");
		printf("numinc=%d - mtest=%d - mnuminc=%d\n",numinc,mtest,mnuminc);
		while(!kbhit());
		getch();
		#endif

		if(bitorneo&&f2f) {
			strcpy(fileout,outstring);
			f2f=0;
			c=0,bias=0;
			if(rep!=1) rep=0;
			if(plog)plog=1;
			autocount=0;
			clear();
			torneo(1);
		}
	}
	strcpy(temp,outstring);
	strcat(temp,".da_");
	remove(temp);
	strcpy(temp,outstring);
	strcat(temp,".msg");
	if((fp=fopen(temp,"wt"))!=NULL) {
		fprintf(fp,"FINE\n");
		fclose(fp);
	}
	exit(0);
	return(0);
}

int torneo(char nuovo)
{
	long	L;
	FILE	*fp;
	long 	k;

	int	i,j,z,kk,exitmode=0;
	int	rp;
	char	parameter[256];
	char    pars[256],nr[10];

	msrand();
	if (nuovo) {
		if((fp=fopen(robstring, "rb"))==NULL) uso();
		if(!quiet) {
			printw("\nInizio un nuovo torneo\n\n");
			printw("\n\n\nDurante il torneo:\nS: salva la situazione\nQ: abbandona il torneo");
			printw("\nAltro tasto: aggiorna la classifica\n\n");
			refresh();
		}
		init(fp,0);
		fclose(fp);

		if(autocount&&limrob==1) {
			strcat(extcount," ");
			strcat(extcount,srob[0]);
			if(strstr(extcount,".r")) *(strstr(extcount,".r"))=0;
		}
		#ifdef debug
		printw("%s\n",extcount);
		printw("%d %d\n",autocount,limrob);
		printw("robot:%s\n",srob[0]);
		getch();
		#endif

		for(i=0;i<numrob;i++) for(j=0;j<3;j++) data[i][j]=0;

		if(f2f) {
			for(i=0;i<limrob;i++) {
				for(j=i+1;j<numrob;j++)
				{
					in[(long)c*2]=(char)i;
					in[(long)(c++)*2+1]=(char)j;
				}
			}

			k=c;
			if (!ordine) {
				for(c=0;c<k;c++) scambiaf2f(c, c+(long)((long)mrand((k-c))), in);
				for(c=0;c<k;c++) scambiaf2f((long)mrand(k),(long)mrand(k), in);
			}
		}
		else {
			for(i=0;i<limrob;i++) {
				for(j=i+1;j<numrob;j++)
					for(kk=j+1;kk<numrob;kk++)
						for(z=kk+1;z<numrob;z++)
						{
							in[(long)c*4]=(char)i;
							in[(long)c*4+1]=(char)j;
							in[(long)c*4+2]=(char)kk;
							in[((long)(c++))*4+3]=(char)z;
						}
			}

			for(i=1,k=0;i<=limrob;i++)
				k+=((long)(numrob-i)*(long)(numrob-(i+1))*(long)(numrob-(i+2))/6);
			if (!ordine) {
				for(c=0;c<k;c++) scambia(c, c+(long)(mrand(k-c)), in);
				for(c=0;c<k;c++) scambia((long)mrand(k),(long)mrand(k), in);
			}

		}
		if(matchperc) matches=(long)((float)(k*matchperc)/100);
	} else	{
		if(!quiet) {
			printw("\nContinuo il torneo salvato in precedenza\n\n");
			printw("\n\n\nDurante il torneo:\nS: salva la situazione\nQ: abbandona il torneo");
			printw("\nAltro tasto: aggiorna la classifica\n\n");
			refresh();
		}
		init(fp=fopen(temp,"rt"),1);
		fscanf(fp, "%ld", &k);
		if(f2f) for(L=0;L<(2*k);L++) fscanf(fp, "%d", &in[L]);
		else for(L=0;L<(4*k);L++) fscanf(fp, "%d", &in[L]);
		fscanf(fp,"%ld",&bias);
		temp[0]=0;
		while(toupper(temp[0]!='C')&&(temp[0]<'0'||temp[0]>'9')) fgets(temp,80,fp);
		if (toupper(temp[0])=='C'){
			if(!(extcount[0])) strcpy(extcount,strstr(temp,"=")+1);
		} else {
			for(i=0;i<numrob;i++) for(j=0;j<3;j++) {
				data[i][j]=atol(temp);
				fscanf(fp,"%s",temp);
			}
		}
		do {
			if (toupper(temp[0])=='M' && strstr(temp,"=")) {
				if(!(matches=getval(temp))) matches=100;
			} else if (toupper(temp[0])=='X') rep=0;
			else if (toupper(temp[0])=='D') {
				strcpy(fileout,strstr(temp,"=")+1);
				isfileout=1;
				if(strchr(fileout,13))
				*(strchr(fileout,13))=0;
				if(strchr(fileout,10))
				*(strchr(fileout,10))=0;
			} else if (toupper(temp[0])=='T') plog=2;
		} while (fgets(temp,80,fp));
		fclose(fp);
		strcpy(temp,outstring);
		strcat(temp,".dat");
		if (remove(temp)) {
			printf("errore nella rimozione del file %s\n",temp);
			exit(0);
		}



		if (plog==2) {
			strcpy(temp,outstring);
			strcat(temp,".log");
			if((flog=fopen(temp,"rt"))==NULL) {
				endwin();
				if(!quiet) printf("File di log non trovato\n");
				else {
					strcpy(temp,outstring);
					strcat(temp,".msg");
					if((fp=fopen(temp,"wt"))!=NULL) {
						fprintf(fp,"File di log non trovato\n");
						fclose(fp);
					}
				}
				exit(-1);

			}
			else fclose(flog);
		}
	}
	if (extcount[0] && !plog) {
		if(quiet) extcount[0]=0;
		else {
		#ifdef msdos
			while(kbhit())getch();
		#endif
			clear();
			printw("\n\n Per utilizzare un programma di conteggio esterno e' necessario creare il log\n");
			printw("degli incontri. Inserire la riga\n\n  T\n\n nel .rob\n\noppure, su linea di comando\n\n  -t\n");
			printw("\n\n Digitare S per abilitare la creazione del log\n");
			refresh();
			#ifdef msdos
				while(!kbhit());
				if((z=getch())!='S' && z!='s') {
			#else
				if((z=getchar())!='S' && z!='s') {
			#endif
					chdir(dirstring);
					esci();
				}
			plog=1;
		}
	}
	else if (!(quiet||extcount[0]||(!nuovo)||(bitorneo&&!f2f))) {
		#ifdef msdos
			while(kbhit())getch();
		#endif
		clear();
		printw("\nATTENZIONE\n\nPer un preciso controllo delle efficienze dei robot\n");
		printw("si consiglia di utilizzare COUNT v8.0 e superiori (di S. Ascheri e M. Messina)\nper il controllo dei risultati ");
		printw("e implementare il metodo PRANZO,\nusato nei tornei ufficiali di crobots.\n");
		printw("\n\nPer utilizzare il metodo PRANZO basta aggiungere nel .rob la riga\n");
		printw("\n   C\n\n");
		printw("oppure su linea di comando\n\n");
		printw("   -c\n\n");
		printw("Per ulteriori informazioni su COUNT consultare la guida acclusa al programma.\n");
		printw("Per il download: http://go.to/crobots oppure www.itportal.it/crobots");
	}
		#ifdef debug
		printf("Il numero di matches per l'aggiornamento e': %ld",matches);
		#endif
	if(!matches) matches=1;
	if(!rep) {
		rep=numinc;
		numinc=1;
	}
	if (plog) {
		strcpy(temp,outstring);
		#ifdef debug
		printf("\ntemp=%s\n",temp);
		#endif
		strcat(temp,".log");
		#ifdef debug
		printf("temp=%s\n",temp);
		#endif
		if(plog==2||((!f2f)&&bitorneo)) flog=fopen(temp,"ab");
		else flog=fopen(temp,"wb");
		if (flog==NULL) {
			endwin();
			if(!quiet) printf("\n\nNon riesco a creare il file di log.\n");
			else {
				strcpy(temp,outstring);
				strcat(temp,".msg");
				if((fp=fopen(temp,"wt"))!=NULL) {
					fprintf(fp,"File di log non creato\n");
					fclose(fp);
				}
			}
			exit(-1);
		}
		if (plog==1) {
			if((!f2f)&&bitorneo) {
				fprintf(flog,"\n\n----------\n\n\n");
				bitorneo=0;
			}
			fprintf(flog,"Torneo gestito da <a href=\"http://go.to/crobots\">TORNEO XP</a> \n");
			/*fprintf(flog,"Torneo gestito da <a href=\"http://go.to/crobots\">%s</a> di Michelangelo Messina\n",versio);*/
			fprintf(flog,"Numero incontri=%ld",k*numinc*rep);
		}
	}
	if(!extcount[0]&&bitorneo&&f2f) {
		if(strstr(fileout,".")) *(strstr(fileout,"."))=0;
		strcat(fileout,".f2f");
	}

	#ifdef linux
	if(extcount[0]) if(!strstr(extcount,">/dev/null") ) {
		if(extcount[strlen(extcount)-1]==10) extcount[strlen(extcount)-1]=0;
		strcat(extcount," >/dev/null");
	}
	/*if(extcount[0]) quiet=1;*/
	strcpy(pars,"crobots </dev/null >L 2>/dev/null -l200000 -m");
	strcpy(nr,"0000");
	#else
	strcpy(pars,"c <nul >L -l200000 -m");
	#endif
	if(f2f) {
		#ifdef msdos
		gotoxy(1,17);
		#endif
		if(numinc>9999) {
			#ifdef linux
			endwin();
			#else
			clrscr();
			#endif
			printf("\nNr massimo incontri per il F2F: 9999\n");
			esci();
		}
		nr[0]=(char)('0'+(numinc)/1000);
		nr[1]=(char)('0'+(numinc-1000*(int)((numinc)/1000))/100);
		nr[2]=(char)('0'+(numinc-100*(int)((numinc)/100))/10);
		nr[3]=(char)('0'+numinc%10);
		nr[4]=' ';
		nr[5]=0;
	} else {
		#ifdef msdos
		gotoxy(1,16);
		#endif
		if(numinc>99) {
			#ifdef linux
			endwin();
			#else
			clrscr();
			#endif
			printf("\nNr massimo incontri per il 4vs4: 99\n");
			esci();
		}
		nr[0]=(char)('0'+(numinc)/10);
		nr[1]=(char)('0'+(numinc)%10);
		nr[2]=' ';
		nr[3]=0;
	}
	strcat(pars,nr);
	strcat(pars,fk);
	chdir(dirstring);

	#ifdef linux
	if(!quiet) nodelay(stdscr,TRUE);
	#endif

	if(!nuovo) save(k,1);  /*test*/
	for(c=0;c<k;c++) {
		#ifdef linux
		if(!quiet) {
			move(23,1);
			printw("In corso: Match %ld su %ld",c+bias+1,k+bias);
			refresh();
		}
		#endif
		for(rp=0;rp<rep;rp++) {
			strcpy(parameter,pars);
			if(f2f) {
				mischiaf2f(c,in);
				strcat(parameter,srob[in[(long)c*2]]);
				strcat(parameter,srob[in[(long)c*2+1]]);
			}
			else {
				mischia(c,in);
				strcat(parameter,srob[in[(long)c*4]]);
				strcat(parameter,srob[in[(long)c*4+1]]);
				strcat(parameter,srob[in[(long)c*4+2]]);
				strcat(parameter,srob[in[(long)c*4+3]]);
			}
			#ifdef msdos
			if(fake) {
				gotoxy(1,21);
				printf("In corso: Match %ld su %ld",(long)c+bias+1,k+bias);
				clreol();
			}
			else if (f2f) gotoxy(1,17);
			else gotoxy(1,16);
			if(system(parameter)) {
				if(!quiet) {
					clrscr();
					if(strlen(parameter)>123) printf("\nErrore DOS: riga di comando troppo lunga: %d caratteri\nRidurre la lunghezza dei path dei robot (max CMDLINE = 123 caratteri)\n",strlen(parameter));
					else printf("\nErrore DOS nell'esecuzione di crobots.exe\nProgramma interrotto\n");
					#ifdef debug
					printf("\nCMDLINE=%s\n",parameter);
					exit(0);
					#endif
				}else {
					strcpy(temp,outstring);
					strcat(temp,".msg");
					if((fp=fopen(temp,"wt"))!=NULL) {
						fprintf(fp,"Programma interrotto\n");
						fclose(fp);
					}
				}
				esci();
			}
			#else
			if(system(parameter)) {
				endwin();
				if(!quiet) {
					printf("\nCMDLINE=%s\n",parameter);
					printf("\nProgramma interrotto\n");
				} else {
					strcpy(temp,outstring);
					strcat(temp,".msg");
					if((fp=fopen(temp,"wt"))!=NULL) {
						fprintf(fp,"Programma interrotto\n");
						fclose(fp);
					}
				}
				esci();
			}
			#endif
			analisi();

			if(!quiet||rp==rep-1) {
				if((fp=fopen("cmnd","rt"))!=NULL) {
					aggiorna(k);
					fscanf(fp,"%s",temp);
					fclose(fp);
					remove("cmnd");
					if(!strcmp("save",temp)) exitmode=2;
					else if(!strcmp("quit",temp)&&!exitmode) {
						exitmode=1;
						break;
					}
				}
				#ifdef linux
				else if((fp=fopen("../cmnd","rt"))!=NULL) {
				#else
				else if((fp=fopen("..\\cmnd","rt"))!=NULL) {
				#endif
					aggiorna(k);
					fscanf(fp,"%s",temp);
					fclose(fp);
					if(!strcmp("save",temp)) exitmode=2;
					else if(!strcmp("quit",temp)&&!exitmode) {
						exitmode=1;
						break;
					}
				}
				#ifdef linux
				else if(!quiet) {
					if((z=getch())!=ERR) {
						aggiorna(k);
						if(z=='q'||z=='Q'||z=='s'||z=='S') {
							if(z=='s'||z=='S') exitmode=2;
							else if(!exitmode){
								exitmode=1;
								break;
							}
						}
					}
				}
				#else
				if(kbhit()) {
					aggiorna(k);
					if((z=getch())=='q' || z=='Q' || z=='s' ||z=='S') {
						if(z=='s' || z=='S') exitmode=2;
						else if(!exitmode){
							exitmode=1;
							break;
						}
					}
				}
				#endif
			}
		}
		if(exitmode==2) save(k,0);
		if(exitmode) break;
		else if(!((c+1)%matches))aggiorna(k);
	}
	if(c==k) c--;
	if (plog) fclose(flog);
	finale(exitmode);
	pulisci();
	return(!exitmode);
}

void	init(FILE *fp, char status)
{
	int	i;
	int	tipo=0;
	FILE	*test;
	char	temp[256];

	if(status){
		mtest=0;
		rtest=0;
		rep=1;
		plog=0;
		f2f=0;
		bitorneo=0;
		fscanf(fp, "%d",&tipo);
		if(tipo>1) {
			bitorneo=1;
			tipo-=2;
		}
		if(tipo>0) f2f=1;
		if(bitorneo) {
			fscanf(fp,"%d",&birep);
			fscanf(fp,"%s",robstring);
			fscanf(fp,"%d",&limrob);
		}
	}
	fscanf(fp, "%d",&numrob);
	if(!numrob) errore(status);
	fscanf(fp, "%d",&numinc);
	if(birep&&f2f) {
		if(!mtest) {
			mnuminc=numinc;
			mtest=1;
		}
		numinc=birep;
	} else if(mtest) numinc=mnuminc;
	if(!numinc) errore(status);
	#ifdef debug
	printf("numinc=%d - mtest=%d - mnuminc=%d",numinc,mtest,mnuminc);
	while(!kbhit());
	getch();
	#endif
	numrob+=rtest;
	for(i=rtest;i<numrob;i++) if(fscanf(fp,"%s",rob[i])==EOF) errore(status);
	#ifdef djgpp
	if (mkdir(dirstring,S_IWUSR)) {
	#else
	if (mkdir(dirstring)) {
	#endif
		fclose(fp);
		endwin();
		if(!quiet) {
			printf("\n\nE' in corso un'altro torneo nella directory %s !\n",dirstring);
			printf("\nSe la directory %s e' stata creata da una esecuzione non andata a buon fine,\n eliminarla prima di lanciare %s\n",dirstring,versio);
			printf("\n\nAltrimenti utilizzare -d=xxxx per cambiare directory di destinazione\n");
		} else {
			strcpy(temp,outstring);
			strcat(temp,".msg");
			if((fp=fopen(temp,"wt"))!=NULL) {
				fprintf(fp,"\n\nE' in corso un'altro torneo nella directory %s !\n",dirstring);
				fprintf(fp,"\nSe la directory %s e' stata creata da una esecuzione non andata a buon fine,\n eliminarla prima di lanciare %s\n",dirstring,versio);
				fprintf(fp,"\n\nAltrimenti utilizzare -d=xxxx per cambiare directory di destinazione\n");
				fclose(fp);
			}
		}
		exit(-1);
	}
	#ifdef msdos
	patch();
	#else
	strcpy(temp,"chmod a=rwx ");
	strcat(temp,dirstring);
	system(temp);
	#endif

	for(i=0;i<numrob;i++) {
		strcpy(srob[i],rob[i]);
		if(strchr(rob[i],13))
		*(strchr(rob[i],13))=0;
		if(strchr(rob[i],10))
		*(strchr(rob[i],10))=0;
		strcpy(srob[i],rob[i]);

		strcpy(temp,srob[i]);
		if(strstr(temp," ")) *(strstr(temp," "))=0;
		#ifdef linux
		if(strstr(temp,"\\")) strcpy(strstr(temp,"\\"),strstr(temp,"\\")+1);
		#endif
		if((test=fopen(temp,"r"))!=NULL) fclose(test);
		else {
			printf("Robot: %s\n",temp);
			errore(2);
		}
		strcat(srob[i]," ");
		#ifdef linux
		strcpy(temp,"cp >/dev/null "); /*strcpy(temp,"ln -s >/dev/null ");*/
		/*(srob[i][0]!='/') strcat(temp,"../");*/
		strcat(temp,srob[i]);
		while(strstr(srob[i],"/")) strcpy(srob[i],strstr(srob[i],"/")+1);
		strcat(temp,dirstring);
		#else
		strcpy(temp,"copy >nul ");
		strcat(temp,srob[i]);
		while(strstr(srob[i],":")) strcpy(srob[i],strstr(srob[i],":")+1);
		while(strstr(srob[i],"\\")) strcpy(srob[i],strstr(srob[i],"\\")+1);
		strcat(temp,dirstring);
		#endif
		if(system(temp)) {
			endwin();
			if(!quiet) {
				printf("Errore nell'apertura dei files\n");
				#ifdef debug
				printf("comando:%s\n",temp);
				#endif
			} else {
				strcpy(temp,outstring);
				strcat(temp,".msg");
				if((fp=fopen(temp,"wt"))!=NULL) {
					printf("Errore nell'apertura dei files\n");
					fclose(fp);
				}
			}
			exit(-1);
		}

		if(strstr(srob[i],".pr") || strstr(srob[i],".PR") ) {
			#ifdef linux
			strcpy(temp,"ppc </dev/null >/dev/null ");
			#else
			strcpy(temp,"ppc <nul >nul ");
			#endif
			strcat(temp,dirstring);
			#ifdef linux
			strcat(temp,"/");
			#else
			strcat(temp,"\\");
			#endif
			strcat(temp,srob[i]);
			if(system(temp)) {
				endwin();
				if(!quiet) {
					printf("\nErrore nel file .rob\no nell'utilizzo del preprocessore\n");
				} else {
					strcpy(temp,outstring);
					strcat(temp,".msg");
					if((fp=fopen(temp,"wt"))!=NULL) {
						fprintf(fp,"\nErrore nel file .rob\no nell'utilizzo del preprocessore\n");
						fclose(fp);
					}
				}
				exit(-1);
			}

			strcpy(temp,dirstring);
			#ifdef linux
			strcat(temp,"/");
			#else
			strcat(temp,"\\");
			#endif
			strcat(temp,srob[i]);
			if(strstr(temp," ")) *(strstr(temp," "))=0;
			remove(temp);

			*(strstr(srob[i],"."))=0;
			strcat(srob[i],".r ");
		}

		if(!strstr(srob[i],".r") && !strstr(srob[i],".R")) {
			printf("Robot: %s\n",srob[i]);
			errore(2);
		}
	}

	if (status) {
		if(bitorneo) fscanf(fp,"%d",&rtest);
		return;
	}

	while (fgets(temp,80,fp)){
		if (toupper(temp[0])=='L' && strstr(temp,"=") &&(!limrob)) limrob=getval(temp);
		else if (toupper(temp[0])=='M' && strstr(temp,"=")) {
			if(strstr(temp,"%")) {
				if(!(matchperc=getval(temp))) matchperc=10;
			}
			else {
				if(!(matches=getval(temp))) matches=100;
				matchperc=0;
			}
		}
		else if (toupper(temp[0])=='X') rep=0;
		else if (toupper(temp[0])=='D') {
			strcpy(fileout,strstr(temp,"=")+1);
			isfileout=1;
			if(strchr(fileout,13))
			*(strchr(fileout,13))=0;
			if(strchr(fileout,10))
			*(strchr(fileout,10))=0;

		}
		else if (toupper(temp[0])=='T') plog=1;
		else if (toupper(temp[0])=='O') ordine=1;
		else if (toupper(temp[0])=='C'&&!extcount[0]) {
			if(strlen(temp)>2) strcpy(extcount,strstr(temp,"=")+1);
			else {
                                #ifdef msdos
				strcpy(extcount,"count /p /q=5 ");
                                #else
                                strcpy(extcount,"count -p -q=5 ");
				#endif
				autocount=1;
			}
		}
	}
	if ((!limrob)||(limrob>numrob)) limrob=numrob;
}

#ifdef __TURBO__
void	scambia(long i,long j,char huge *in)
#else
void	scambia(long i,long j,char *in)
#endif
{
	char k,temp;
	for(k=0;k<4;k++) {
		temp=in[(long)j*4+(long)k];
		in[(long)j*4+(long)k]=in[(long)i*4+(long)k];
		in[(long)i*4+(long)k]=temp;
	}

}

#ifdef __TURBO__
void mischia(long j, char huge *in)
#else
void mischia(long j, char *in)
#endif
{
	long z;
	char k,temp;
	for(k=0;k<4;k++) {
		z=(long)mrand(4);
		temp=in[(long)j*4+(long)z];
		in[(long)j*4+(long)z]=in[(long)j*4+(long)k];
		in[(long)j*4+(long)k]=temp;
	}
}

void save(long k,char mode)
{
	long	L;
	int	i,j;
	FILE	*fp;

	chdir("..");
	strcpy(temp,outstring);
	if(mode) {
		strcat(temp,".da_");
		if(plog) fprintf(flog,"T?\n");
	} else strcat(temp,".dat");
	if((fp=fopen(temp,"wt"))!=NULL) {
		fprintf(fp, "%d\n",(f2f+2*bitorneo));
		if(bitorneo) {
			fprintf(fp, "%d\n",birep);
			fprintf(fp, "%s\n",robstring);
			fprintf(fp, "%d\n",limrob);
		}
		fprintf(fp, "%d\n",numrob);
		if(mtest) fprintf(fp, "%d\n",mnuminc);
		else {
			if(rep==1) fprintf(fp, "%d\n",numinc);
			else fprintf(fp,"%d\n",rep);
		}
		for(i=0;i<numrob;i++)
			fprintf(fp,"%s\n",rob[i]);
		if(bitorneo) fprintf(fp,"%d\n",rtest);
		fprintf(fp,"%ld\n",k-c-1);

		if(f2f) for(L=(2*((long)c+1));L<(2*k);L++) {
			fprintf(fp, "%d\n", in[L]);
		}
		else for(L=(4*((long)c+1));L<(4*k);L++) {
			fprintf(fp, "%d\n", in[L]);
		}
		fprintf(fp,"%ld\n", bias+c+1);
		if (extcount[0]) fprintf(fp, "C=%s \n",extcount);
		else {
			for(i=0;i<numrob;i++)
				for(j=0;j<3;j++) fprintf(fp,"%ld\n",data[i][j]);
		}
		if (matches!=100) fprintf(fp, "M=%ld\n", matches);
		if (rep!=1) fprintf(fp, "X\n");
		if (plog) fprintf(fp, "T\n");
		if (isfileout) fprintf(fp, "D=%s\n", fileout);
		fclose(fp);
		if (!quiet&& !mode) printf("\n\n Situazione salvata nel file  %s.dat\n",outstring);
	}
	else {
		endwin();
		if(!quiet) {
			printf("Errore nel salvataggio!\n");
		} else {
			strcpy(temp,outstring);
			strcat(temp,".msg");
			if((fp=fopen(temp,"wt"))!=NULL) {
				fprintf(fp,"\nErrore nel salvataggio!\n");
				fclose(fp);
			}
		}
		esci();
	}
	chdir(dirstring);
}



void analisi()
{
	char	buffer[17][80];
	int	j,k;
	long	i;
	FILE	*fp;
	char	car,ncar;


	if(plog) {
		if((fp=fopen("L", "rb"))==NULL) {
			endwin();
			printf("Errore nel caricamento di L\n");
			esci();
		}
		car=(char)fgetc(fp);
		while (!feof(fp)) {
			ncar=(char)fgetc(fp);
			if(fputc(car,flog)==EOF) {
				endwin();
				printf("Errore nella scrittura del log\n");
				fclose(fp);
				esci();
			}
			car=ncar;
		}
		fflush(flog);
		fclose(fp);
	}

	if(!extcount[0]) {
		if((fp=fopen("L", "rt"))==NULL) {
			endwin();
			printf("Errore nel caricamento di L\n");
			esci();
		}
		i=0;
		if(f2f) {
			while (!feof(fp)) {
				fscanf(fp,"%s",buffer[((++i)%10)]);
			}
			fclose (fp);

			if(++i<3) {
				endwin();
				printf("\n\nErrore a runtime nella compilazione di un robot!\n");
				esci();
			}
			for(j=0;j<2;j++) {
				k=in[c*2+j];
				data[k][0]+=numinc;
				data[k][1]+=getval((char *)buffer[((i+4*j+3)%10)]);
				data[k][2]+=getval((char *)buffer[((i+4*j+4)%10)]);
			}
			return;

		}
		while (!feof(fp)) {
			fscanf(fp,"%s",buffer[((++i)%17)]);
		}
		fclose (fp);

		i++;
		for(j=0;j<4;j++)
		{
			k=in[c*4+j];
			data[k][0]+=numinc;
			data[k][1]+=getval((char *)buffer[((i+4*j+2)%17)]);
			data[k][2]+=getval((char *)buffer[((i+4*j+3)%17)]);

		}
			if(strlen(buffer[(i+13)%17])==1) {
			endwin();
			printf("\n\nErrore a runtime nella compilazione di un robot!\n");
			esci();
		}
	}

}


void	aggiorna(long nr)
{
	FILE	*afp;

	save(nr,1); /*backup situation!*/
	chdir("..");
	if(extcount[0]) {
		system(extcount);
#ifdef debug
		printw("\n\n eseguito %s\n",extcount);
		refresh();
#endif
	} else {
		if (isfileout||quiet) {
			if((afp=fopen(fileout, "wt"))==NULL) {
				endwin();
				printf("Errore nella scrittura dei risultati\n");
				esci();
			}
			stampa(afp,100,nr);
			fclose(afp);
		}
		if(!quiet) {
			#ifdef msdos
			clrscr();
			gotoxy(1,1);
			stampa(stdout,19,nr);
			#else
			stampaw(nr);
			#endif
		}
	}
	chdir(dirstring);

}

int	getval(char *from)
{
	char *r;
	r=strchr(from,'=');
	return(atoi(r+1));
}

void finale(int exitmode)
{
	FILE	*fp;

	chdir("..");

	clrscr();
	endwin();
	if(extcount[0]) {
		if(!exitmode) system(extcount);
	} else {
		if((fp=fopen(fileout,"wt"))==NULL) {
			printf("\nRisultati non salvati!\n");
			chdir(dirstring);
			esci();
		}
		stampa(fp,100,0);
		fclose(fp);
		if(!quiet) {
			stampa(stdout,100,0);
			printf("\n\n I risultati sono stati salvati nel file %s\n",fileout);
		}
	}
	chdir(dirstring);
}

void stampa(FILE *fp,int maxrow, long nr)
{
	int	i,j,temp,classifica[MAXROB+1];
	float	media[MAXROB+1];

	for(i=0;i<numrob;i++) {
		if(data[i][0])
		media[i]=(float)(100*((float)data[i][1]+(float)data[i][2]*pari/win)/(float)data[i][0]);
		else media[i]=-1;
	}
	for(i=0;i<numrob;i++) classifica[i]=i;
	if (!nr) fprintf(fp, " Risultati finali:\n");
	else fprintf(fp," Risultati dopo %ld incontri su %ld (%d %%):\n",(long)c+1+bias,(long)nr+bias,(((long)(c+bias+1)*(long)100))/(long)(nr+bias));
	fprintf(fp,"Pos -   Robot - partite - vinte - patte - perse -    punti -   eff.%\n");
	for(i=0;i<numrob;i++) {
		for(j=i;j<numrob;j++) {
			if(media[classifica[i]]<media[classifica[j]]) {
				temp=classifica[i];
				classifica[i]=classifica[j];
				classifica[j]=temp;
			}
		}
	}
	for(i=0;i<numrob&&i<maxrow;i++) {
		if(data[classifica[i]][0])
		fprintf(fp,"%2d%14s %5ld   %6ld   %5ld   %5ld   %8.0f    %6.2f\n",(i+1),srob[classifica[i]],
		data[classifica[i]][0], data[classifica[i]][1],
		data[classifica[i]][2], data[classifica[i]][0]-data[classifica[i]][1]-data[classifica[i]][2],
		(float) data[classifica[i]][1]*win+(float)data[classifica[i]][2]*pari,
		media[classifica[i]]);
		else fprintf(fp,"%2d%14s\n",(i+1),srob[classifica[i]]);
	}
}

#ifdef linux
void stampaw(long nr)
{
	int	i,j,temp,classifica[MAXROB+1];
	float	media[MAXROB+1];

	for(i=0;i<numrob;i++) {
		if(data[i][0])
		media[i]=(float)(100*((float)data[i][1]+(float)data[i][2]*pari/win)/(float) data[i][0]);
		else media[i]=-1;
	}
	for(i=0;i<numrob;i++) classifica[i]=i;
	clear();
	printw(" Risultati dopo %ld incontri su %ld (%ld %%):\n",c+1+bias,nr+bias,(((long)(c+bias+1)*100))/(nr+bias));
	printw("Pos -   Robot - partite - vinte - patte - perse -    punti -   eff.%\n");
	for(i=0;i<numrob;i++) {
		for(j=i;j<numrob;j++) {
			if(media[classifica[i]]<media[classifica[j]]) {
				temp=classifica[i];
				classifica[i]=classifica[j];
				classifica[j]=temp;
			}
		}
	}
	for(i=0;i<numrob&&i<21;i++) {
		if(data[classifica[i]][0])
		printw("%2d%14s %5ld   %6ld   %5ld   %5ld   %8.0f    %6.2f\n",(i+1),srob[classifica[i]],
		data[classifica[i]][0],	data[classifica[i]][1],
		data[classifica[i]][2],data[classifica[i]][0]-data[classifica[i]][1]-data[classifica[i]][2],
		(float) data[classifica[i]][1]*win+(float)data[classifica[i]][2]*pari,
		media[classifica[i]]);
		else printw("%2d%14s\n",(i+1),srob[classifica[i]]);
	}
}
#else
void patch()
{
	unsigned long 	c,l;
	char	i,j,temp[128];
	FILE	*fp1,*fp2,*fp;

	if((fp1=fopen("crobots.exe","rb"))==NULL) {
		printf("Il file CROBOTS.EXE deve essere nella directory corrente!\n");
		exit(-1);
	}

	if(filelength(fileno(fp1))!=60224) fake=1;

	strcpy(temp,dirstring);
	strcat(temp,"\\c.exe");
	if((fp2=fopen(temp,"wb"))==NULL) {
		fclose(fp1);
		if(!quiet) printf("Errore in scrittura!\n");
		else {
			strcpy(temp,outstring);
			strcat(temp,".msg");
			if((fp=fopen(temp,"wt"))!=NULL) {
				fprintf(fp,"\nErrore nel salvataggio!\n");
				fclose(fp);
			}
		}
		exit(-1);
	}
	if((fp=fopen("patch.dat","rb"))==NULL) {
		printf("Il file PATCH.DAT deve essere nella directory corrente!\n");
		fclose(fp1);
		fclose(fp2);
		exit(-1);
	}
	if(filelength(fileno(fp))!=5280) {
		printf("E' necesaria la nuova versione del file PATCH.DAT\n");
		fclose(fp);
		fclose(fp1);
		fclose(fp2);
		exit(-1);
	}
	fread(&l,sizeof(long),1,fp);
	if(fake) strcpy(fk,"-g ");
	for(c=0;!feof(fp1);c++) {
		if(!(fread(&i,sizeof(char),1,fp1))) break;
		if(c==l&& !fake) {
			fread(&j,sizeof(char),1,fp);
			fwrite(&j,sizeof(char),1,fp2);
			fread(&l,sizeof(long),1,fp);
		}
		else  fwrite(&i,sizeof(char),1,fp2);
	}
	fclose(fp1);
	fclose(fp2);
	fclose(fp);
}
#endif
void esci()
{
	FILE *fp;

	if (plog&&flog) fclose(flog);
	pulisci();

	if(quiet) {
		strcpy(temp,outstring);
		strcat(temp,".msg");
		if((fp=fopen(temp,"wt"))!=NULL) {
			fprintf(fp,"\nTerminazione anomala\n");
			fclose(fp);
		}
	}

	exit(-1);
}

#ifdef __TURBO__
void	scambiaf2f(long i,long j,char huge *in)
#else
void	scambiaf2f(long i,long j,char *in)
#endif
{
	char k,temp;
	for(k=0;k<2;k++) {
		temp=in[(long)j*2+(long)k];
		in[(long)j*2+(long)k]=in[(long)i*2+(long)k];
		in[(long)i*2+(long)k]=temp;
	}

}

#ifdef __TURBO__
void mischiaf2f(long j, char huge *in)
#else
void mischiaf2f(long j, char *in)
#endif
{
	char k,temp;
	long z;
	for(k=0;k<2;k++) {
		z=(long)mrand(2);
		temp=in[(long)j*2+(long)z];
		in[(long)j*2+(long)z]=in[(long)j*2+(long)k];
		in[(long)j*2+(long)k]=temp;
	}
}

void uso()
{
	if(quiet) printf("Errore - digitare txp ? per ottenere l'aiuto\n");
	else {
		clear();
		#ifdef linux
		printw("Uso: txp [switches] [file di comando[.rob]]\n");
		printw("     txp save|quit|agg [nometorneo]\n");
		#else
		printw("Uso: Txp [switches] [file di comando[.rob]]\n");
		printw("     Txp save|quit|agg [nometorneo]\n");
		#endif
		printw("Per default il file di comando e' torneo.rob\n\n");
		printw("Switches:\n\n");
		printw("-d=x  : files di output del tipo x.est\n");
		printw("-r=x.r: aggiunge x.r come primo robot\n");
		printw("-f    : attiva modalita' Face2Face\n");
		printw("-a[=x]: esegue il torneo F2F e poi il 4vs4 (F2F con x ripetizioni per incontro)\n");
		printw("-x    : avvia piu' volte crobots (obsoleto-usare per il crobots.exe originale)\n");
		printw("-m=x  : x incontri per match \n");
		printw("-t    : crea il file di log  \n");
		#ifdef msdos
		printw("\"-c=x\": esegue il prog. esterno di conteggio (p.es. \"-c=count73 torneo /a\")\n");
		#else
		printw("\"-c=x\": esegue il prog. esterno di conteggio (p.es. \"-c=count73 torneo -a\")\n");
		#endif
		printw("-o    : torneo ordinato\n");
		printw("-l=x  : torneo completato dai primi x robots\n");
		#ifdef linux
		printw("-q    : modalita' 'QUIET' per i batch\n");
		#endif
		printw("-w=x  : assegna x punti per vittoria (default=3)\n");
		printw("-p=x  : assegna x punti per il pareggio (default=1)\n");
		printw("\n\nQuesti switches hanno la priorita' su quelli inseriti nel file di comando\n");
		printw("\n\n Premi un tasto");
		refresh();
		#ifdef msdos
		while(!kbhit());
		getch();
		#else
		getchar();
		#endif
		clear();
		printw("\nIl file di comando deve contenere:\nnumero robot\nnumero incontri\nrobot del torneo (max %d, comprensivi di path)\n\n",MAXROB);
		printw("Opzioni da inserire dopo l'ultimo robot, obbligatoriamente senza spazi:\n\nL=n (con n <=numero robot)\n     ");
		printw("per far giocare solo gli incontri dei primi n robots\n");
		printw("O    per avere il torneo in ordine\n");
		printw("M=n  per avere l'aggiornamento della situazione ogni n partite\n");
#ifdef WIN32
                printw("M=n% per avere l'aggiornamento ogni n% degli incontri (default 10)\n");
#else
                printw("M=n\%% per avere l'aggiornamento ogni n\%% degli incontri (default 10)\n");
#endif
		printw("X    per avviare piu' volte crobots col parametro -m1 (obsoleto)\n");
		printw("D=fileoutput\n     per avere l'aggiornamento su un file diverso dal default (.sco)\n");
		printw("T    per conservare il log completo degli incontri (.log)\n");
		printw("C=progconteggio (da usare in congiunzione all'opzione T - creazione log)\n     per usare un programma esterno per l'analisi\n");
		printw("\n\n Premi un tasto\n");
		refresh();
		#ifdef msdos
		while(!kbhit());
		getch();
		#else
		getchar();
		#endif
		endwin();
	}
	exit(-1);

}
void comando(char* cm,int argc, char *argv[])
{
	FILE *fp;


	printf("\n\n\n\n\nCROBOTS %s\nCopyright (C) Michelangelo Messina\n",versio);
	printf("e-mail m.messina@tiscalinet.it\n       m.messina@libero.it\n");
	printf("http://go.to/crobots\n");
	printf("www.yahoogroups.com/group/crobots\n\n");

	if (argc>2) {
		strcpy(temp,argv[2]);
		if(strstr(temp,".")) *(strstr(temp,"."))=0;
		while(strstr(temp,"\\"))strcpy(temp,strstr(temp,"\\")+1);
		while(strstr(temp,"/"))strcpy(temp,strstr(temp,"/")+1);
		#ifdef linux
		if(temp[strlen(temp)-1] !='/') strcat(temp,"/");
		#else
		if(temp[strlen(temp)-1] !='\\') strcat(temp,"\\");
		#endif
		strcat(temp,"cmnd");
	}
	else {
		if(!strcmp(cm,"aggiorna")) {
			printf("Errore\nSpecificare il nome del torneo\n");
			exit(-1);
		}
		strcpy(temp,"cmnd");
	}
	if((fp=fopen(temp,"wt"))==NULL) {
		strcpy(temp,argv[2]);
		#ifdef linux
		if(temp[strlen(temp)-1] !='/') strcat(temp,"/");
		#else
		if(temp[strlen(temp)-1] !='\\') strcat(temp,"\\");
		#endif
		strcat(temp,"cmnd");
		if((fp=fopen(temp,"wt"))==NULL) {
			printf("Errore\nFile %s non creato\n",temp);
			printf("Lanciare il comando dalla stessa directory da cui si e' fatto partire il torneo\n");
			printf("oppure indicare il percorso in cui si svolge il torneo\n");
			exit(-1);
		}
	}
	fprintf(fp,"%s\n",cm);
	fclose(fp);
	printf("Inviato comando %s\n",cm);
	exit(0);
}
void errore(char status)
{
	FILE *fp;
	endwin();
	if(!quiet) {
		if(!status) printf("\nErrore nel file .rob\n");
		else if(status==1) printf("\nErrore nel file .dat\n");
		else printf("\nErrore nella compilazione\n");
	} else {
		strcpy(temp,outstring);
		strcat(temp,".msg");
		if((fp=fopen(temp,"wt"))!=NULL) {
			if(!status) fprintf(fp,"\nErrore nel file .rob\n");
			else if(status==1) fprintf(fp,"\nErrore nel file .dat\n");
			else fprintf(fp,"\nErrore nella compilazione\n");
			fclose(fp);
		}
	}
	exit(-1);
}

void pulisci()
{
	int i;

	remove("L");
	#ifdef msdos
	for(i=0;i<numrob;i++) remove(srob[i]);
	#else
	for(i=0;i<numrob;i++) {
		strcpy(temp,srob[i]);
		if(strstr(temp," ")) *(strstr(temp," "))=0;
		if(strstr(temp,"\\")) strcpy(strstr(temp,"\\"),strstr(temp,"\\")+1);
		remove(temp);
	}
	#endif
	remove("cmnd");
	chdir("..");
	endwin();
	rmdir(dirstring);
}

void	logrestore()
{
	long nrlinee=0,i=0;
	FILE *fp1,*fp2;
	char temp1[256];
	char reading[256];

	strcpy(temp,outstring);
	strcat(temp,".log");
	if((fp1=fopen(temp,"rb"))==NULL) return;
	strcpy(temp1,outstring);
	strcat(temp1,".lo_");
	if((fp2=fopen(temp1,"wt"))==NULL) {
		endwin();
		printf("Errore nel recupero del log\n");
		exit(-1);
	}
	while(!feof(fp1)) {
		fgets(reading,256,fp1);
		if(strstr(reading,"T?")) nrlinee=i;
		i++;
	}
	rewind(fp1);
	for(i=0;i<nrlinee;i++) {
		fgets(reading,256,fp1);
		/*#ifdef msdos*/
		if(!strstr(reading,"T?")) {
			if(strchr(reading,13)) *(strchr(reading,13))=0;
			if(strchr(reading,10)) *(strchr(reading,10))=0;
			fprintf(fp2,"%s\n",reading);

		}
		/*#else
		if(!strstr(reading,"T?")) fprintf(fp2,"%s",reading);
		#endif*/
	}
	/*fprintf(fp2,"T?\n");*/
	fclose(fp1);
	fclose(fp2);
	remove(temp);
	rename(temp1,temp);
}




#ifdef msdos
void refresh(void){}
void initscr(void){}
void cbreak(void) {}
void noecho(void) {}
void curs_set() {}
void endwin(void) {strcpy(temp,dirstring);strcat(temp,"\\c.exe");remove(temp); }
#endif
