% Inizializzazione variabili
%clear all
% Massa del SOLE
mtarget = 2e30;         % kg
% Posizione SOLE
posxtgt = 0;            % m
posytgt = 0;            % m
posztgt = 0;            % m
% Velocita' SOLE
velxtgt = 0;            % m/s
velytgt = 0;            % m/s
velztgt = 0;            % m/s

% Massa TERRA
mintruso = 5.98e24;     % kg
% Posizione TERRA
posxint = 150e9;        % m
posyint = 0;            % m
poszint = 0;            % m
% Velocita' TERRA
velxint = 0;            % m/s
velyint = 2 * pi * posxint / (365.26 * 24 * 60 ^ 2);  % m/s
velzint = 0;            % m/s

% Numero di iterazioni
iter = 25;
% Numero di deltaT per ogni iterazione
deltaT_iter = 30;
% Passo temporale
deltaT = 3600 * 24;

% Lancio dell'algoritmo
planet(mtarget, posxtgt, posytgt, posztgt, velxtgt, velytgt, velztgt,...
    mintruso, posxint, posyint, poszint, velxint, velyint, velzint,...
    deltaT_iter, iter, deltaT);
