package it.edmaster.eLisa.common;

import java.util.*;

public class Pagina {
    
    public static final Pagina VUOTA = new Pagina( Collections.EMPTY_LIST, 0, false );
    
    List elenco;
    boolean hasNext;
    int inizio;
    
    public Pagina( List elenco, int inizio, boolean hasNext ) {
        this.elenco = elenco;
        this.inizio = inizio;
        this.hasNext = hasNext;
    }
    
    public boolean isNext() {
        return hasNext();
    }
    
    public boolean hasNext() {
        return hasNext;
    }
    
    public int getInizio() {
        return inizio;
    }
    
    public List getElenco() {
        return elenco;
    }
    
    public String toString() {
        StringBuffer sb = new StringBuffer( "Pagina=[elenco=" );
        sb.append( elenco.toString() );
        sb.append( ", inizio=" );
        sb.append( inizio );
        sb.append( ", hasNext=" );
        sb.append( hasNext );
        sb.append( "]" );
        
        return sb.toString();
    }
}
