package it.edmaster.eLisa.ordini;

import java.util.*;

public class Ordine {
    
    String id;
    String codiceUtente;
    Date dataInoltro;
    float importoTotale;
    boolean evaso;
    
    public Ordine( String id, String codiceUtente, Date dataInoltro, float importoTotale, boolean evaso ) {
        this.id = id;
        this.codiceUtente = codiceUtente;
        this.dataInoltro = dataInoltro;
        this.importoTotale = importoTotale;
        this.evaso = evaso;
    }
    
    public String getCodiceUtente() {
        return codiceUtente;
    }
    
    public Date getDataInoltro() {
        return dataInoltro;
    }
    
    public float getImportoTotale() {
        return importoTotale;
    }
    
    public boolean isEvaso() {
        return evaso;
    }
    
    public String toString() {
        StringBuffer sb = new StringBuffer();
        
        sb.append("Ordine=[id=");
        sb.append(id);
        sb.append(", codiceUtente=");
        sb.append(codiceUtente);
        sb.append(", dataInoltro=");
        sb.append(dataInoltro);
        sb.append(", importoTotale=");
        sb.append(importoTotale);
        sb.append(", evaso=");
        sb.append(evaso);
        sb.append("]");
        
        return sb.toString();
    }
}

