package it.edmaster.eLisa.ordini;

import java.sql.*;
import java.util.*;

import it.edmaster.eLisa.common.*;

public class OrdiniHelper {
    
    ElencoOrdini elencoOrdini;
    
    int inizio;
    int quanti;
    
    String codiceUtente;
    boolean evaso;
    
    public OrdiniHelper() {
        elencoOrdini = new ElencoOrdini();
    }
    
    public void setInizio( String inizio ) {
        if (inizio != null) {
            this.inizio = (new Integer(inizio)).intValue();
        }
    }
    
    public void setQuanti( String quanti ) {
        if (quanti != null) {
            this.quanti = (new Integer(quanti)).intValue();
        }
    }
    
    public Pagina getPagina() throws CaricamentoOrdiniException {
        return elencoOrdini.getElenco( codiceUtente, evaso, inizio, quanti );
    }
    
    public void setCodiceUtente( String codiceUtente ) {
        this.codiceUtente = codiceUtente;
    }
    
    public void setEvaso( boolean evaso ) {
        this.evaso = evaso;
    }
    
}

