
import java.sql.*;

public class Utenti extends TabellaDB {
    
    public Utenti( Connection conn ) {
        super(conn);
    }
    
    void drop() throws SQLException {
        String sql = "DROP TABLE UTENTI";
        execute( sql );
    }
    
    void create() throws SQLException {
        String sql = "CREATE TABLE UTENTI ("+
                        "ID int(11) NOT NULL auto_increment,"+
                        "CODUTENTE varchar(20) NOT NULL default '',"+
                        "PASSWORD varchar(20) NOT NULL default '',"+
                        "NOME varchar(50) NOT NULL default '',"+
                        "COGNOME varchar(50) NOT NULL default '',"+
                        "LIVELLO int(11) NOT NULL default 0,"+
                        "PRIMARY KEY (ID),"+
                        "KEY UTENTI_IDX1 (CODUTENTE)"+
                    ")";
        execute( sql );
    }
    
    void fill() throws SQLException {
        String sql = "INSERT INTO UTENTI (CODUTENTE, PASSWORD, LIVELLO) VALUES ('admin','eLisa',9)";
        execute(sql);
        
        sql = "INSERT INTO UTENTI (CODUTENTE, PASSWORD, LIVELLO) VALUES ('guest','guest',0)";
        execute(sql);
    }
    
}
