<%@ page errorPage="../include/PaginaErrore.jsp" %>
<%@ taglib prefix='c' uri='http://java.sun.com/jstl/core' %>

<jsp:useBean
  id="catalogo"
  class="it.edmaster.eLisa.catalogo.CatalogoHelper"
  scope="session"
/>

<HTML>
<HEAD>
    <TITLE>eLisa - Dettagli Prodotto</TITLE>
    <LINK REL="stylesheet" HREF="css/default.css" TYPE="text/css"/>
</HEAD>    
<BODY MARGINHEIGHT="0" MARGINWIDTH="0" MARGINTOP="0" MARGINLEFT="0">
<jsp:include page="../include/testata.jsp" />

<TABLE BORDER="0" WIDTH="100%" CELLSPACING="0" CELLPADDING="5">
<TR>
    <TD WIDTH="20%" CLASS="sidebar"></TD>
    <TD WIDTH="60%">
        <H1>Dettagli Prodotto</H1>
    </TD>
    <TD WIDTH="20%" CLASS="sidebar"></TD>
</TR>

<TR>
    <TD CLASS="sidebar">
        <jsp:include page="../include/sinistra.jsp"/>
    </TD>
    <TD STYLE="padding: 20px">

<A HREF="controller?op=carrello.aggiungi&id=<c:out value="${param.id}" />"/>Ordina</A>
<P>

<c:set value="${param.id}" target="${catalogo}" property="idProdotto"/>
<c:set value="${catalogo.prodotto}" var="prodotto" />

<IMG SRC="immagine?id=<c:out value="${param.id}" />" BORDER="0" ALIGN="left"/>
<SPAN CLASS="prodotto-titolo"><c:out value="${prodotto.nome}" /></SPAN><P>
<c:out value="${prodotto.descrizione}" /><P>

<TABLE BORDER="0" WIDTH="50%">
<TR>
    <TD CLASS="prodotto-econ">Prezzo:</TD><TD>euro <c:out value="${prodotto.prezzo}" /></TD>
</TR>    
<TR>
    <TD CLASS="prodotto-econ">IVA:</TD><TD><c:out value="${prodotto.iva.descrizione}" /></TD>
</TR>    
<TR>
    <TD CLASS="prodotto-econ">Sconto:</TD><TD>euro <c:out value="${prodotto.sconto}" />%</TD>
</TR>
</TABLE>
    
<P>
    <c:if test="${!empty prodotto.link}">
        <A HREF="<c:out value="${prodotto.link}" />">Il sito web del prodotto</A>
    </c:if>

    </TD>
    
    <TD CLASS="sidebar">
        <jsp:include page="../include/destra.jsp"/>
    </TD>
</TR>

<jsp:include page="../include/piede.jsp" />

</BODY>
</HTML>
