<%@ page errorPage="../include/PaginaErrore.jsp" session="false" %>
<%@ taglib prefix='c' uri='http://java.sun.com/jstl/core' %>

<HTML>
<HEAD>
    <TITLE>eLisa - Utenti - Nuovo</TITLE>
    <LINK REL="stylesheet" HREF="css/default.css" TYPE="text/css"/>
</HEAD>    
<BODY MARGINHEIGHT="0" MARGINWIDTH="0" MARGINTOP="0" MARGINLEFT="0">
<jsp:include page="../include/testata.jsp" />

<TABLE BORDER="0" WIDTH="100%" CELLSPACING="0" CELLPADDING="5">
<TR>
    <TD WIDTH="20%" CLASS="sidebar"></TD>
    <TD WIDTH="60%">
        <H1>Nuovo utente</H1>
    </TD>
    <TD WIDTH="20%" CLASS="sidebar"></TD>
</TR>

<TR>
    <TD CLASS="sidebar">
        &nbsp;
    </TD>

    <TD STYLE="padding: 20px">
        <c:if test="${!empty errore}">
            <SPAN CLASS="errore">Attenzione: <c:out value="${errore.message}"/></SPAN>
        </c:if>
        <FORM ACTION="controller?op=utenti.nuovo.salva" METHOD="post">
            Utente:<BR>
            <INPUT NAME="codiceUtente" SIZE="10" VALUE="<c:out value="${param.codiceUtente}"/>"/>
            <c:if test="${!empty errore}">
                <c:set target="${errore}" property="codiceCampo" value="codiceUtente" />
                <c:if test="${errore.InErrore == true}">
                    <SPAN CLASS="errore">*</SPAN>
                </c:if>
            </c:if>
            <P>
            
            Password:<BR>
            <INPUT NAME="password1" SIZE="10" TYPE="password" VALUE="<c:out value="${param.password1}"/>"/>
            &nbsp;(almeno 6 caratteri)
            <c:if test="${!empty errore}">
                <c:set target="${errore}" property="codiceCampo" value="password1" />
                <c:if test="${errore.InErrore == true}">
                    <SPAN CLASS="errore">*</SPAN>
                </c:if>
            </c:if>
            <P>

            Ripeti la password:<BR>
            <INPUT NAME="password2" SIZE="10" TYPE="password" VALUE="<c:out value="${param.password2}"/>"/>
            <c:if test="${!empty errore}">
                <c:set target="${errore}" property="codiceCampo" value="password2" />
                <c:if test="${errore.InErrore == true}">
                    <SPAN CLASS="errore">*</SPAN>
                </c:if>
            </c:if>
            <P>
            
            Nome:<BR>
            <INPUT NAME="nome" SIZE="30" VALUE="<c:out value="${param.nome}"/>"/>
            <c:if test="${!empty errore}">
                <c:set target="${errore}" property="codiceCampo" value="nome" />
                <c:if test="${errore.InErrore == true}">
                    <SPAN CLASS="errore">*</SPAN>
                </c:if>
            </c:if>
            <P>
            
            Cognome:<BR>
            <INPUT NAME="cognome" SIZE="30" VALUE="<c:out value="${param.cognome}"/>"/>
            <c:if test="${!empty errore}">
                <c:set target="${errore}" property="codiceCampo" value="cognome" />
                <c:if test="${errore.InErrore == true}">
                    <SPAN CLASS="errore">*</SPAN>
                </c:if>
            </c:if>
            <P>
            &nbsp;
            
            <P>
            <INPUT NAME="conferma" TYPE="submit" VALUE="Conferma"/>
            <INPUT NAME="annulla" TYPE="submit" VALUE="Annulla"/>
        </FORM>
    </TD>
    
    <TD CLASS="sidebar">
        &nbsp;
    </TD>
</TR>

<jsp:include page="../include/piede.jsp" />

</BODY>
</HTML>
