package cap01;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class CookieServlet extends HttpServlet {

    public void doGet(HttpServletRequest request, HttpServletResponse response) 
            throws IOException, ServletException {

        if( request.getSession().isNew() ) {
            Cookie c = new Cookie( "lingua", "IT_it" );
            response.addCookie( c );
            
            response.getWriter().println("<html><body>La cookie &egrave; stata impostata</body></html");
        } else {
            
            Cookie[] listaCookie = request.getCookies();
            PrintWriter pw = response.getWriter();
            
            pw.println("<html><body>");
            pw.println("<table border=\"1\" cellpadding=\"5\">");
            
            for( int i=0; i<listaCookie.length; i++ ) {
                Cookie c = listaCookie[i];
                
                pw.println("<tr>");
                pw.println("<td>");
                pw.println( c.getName() );
                pw.println("</td>");
                pw.println("<td>");
                pw.println( c.getValue() );
                pw.println("</td>");
                pw.println("<td>");
                pw.println( c );
                pw.println("</td>");
                pw.println("</tr>");
            }
            
            pw.println("</table>");
            pw.println("</body></html>");
        }
    }
    
}
