package cap01;

import java.io.*;
import javax.servlet.http.*;
import javax.servlet.*;

public class DumpServlet extends HttpServlet {
    
    public void service( HttpServletRequest request, HttpServletResponse response ) 
            throws ServletException, IOException {
                
        //HttpServletRequest request = (HttpServletRequest) req;
        //HttpServletResponse response = (HttpServletResponse) res;
        
        response.setContentType("text/html");
        
        PrintWriter pw = response.getWriter();
        
        pw.println("<html>");
        pw.println("<head><title>Dump Servlet</title></head>");
        pw.println("<body bgcolor=#ffffff>");
        pw.println();
        pw.println("<h1>URL richiesto:</h1>");
        pw.println("<pre>");
        pw.println(HttpUtils.getRequestURL(request));
        pw.println("</pre>");
        
        pw.println("<h1>Informazioni relative alla richiesta:</h1>");
        pw.println("<table>");
        pw.print("<tr><td>Metodo di richiesta      <td>");
        pw.println(request.getMethod());
        pw.print("<tr><td>URI della richiesta      <td>");
        pw.println(request.getRequestURI());
        pw.print("<tr><td>Protocollo di richiesta  <td>");
        pw.println(request.getProtocol());
        pw.print("<tr><td>Percorso Servlet         <td>");
        pw.println(request.getServletPath());
        pw.print("<tr><td>Informazioni percorso    <td>");
        pw.println(request.getPathInfo());
        pw.print("<tr><td>Stringa di richiesta     <td>");
        pw.println(request.getQueryString());
        pw.print("<tr><td>Lunghezza del contenuto  <td>");
        pw.println(request.getContentLength());
        pw.print("<tr><td>Tipo del contenuto       <td>");
        pw.println(request.getContentType());
        pw.print("<tr><td>Nome del server          <td>");
        pw.println(request.getServerName());
        pw.print("<tr><td>Porta del server         <td>");
        pw.println(request.getServerPort());
        pw.print("<tr><td>Utente remoto            <td>");
        pw.println(request.getRemoteUser());
        pw.print("<tr><td>Indirizzo remoto         <td>");
        pw.println(request.getRemoteAddr());
        pw.print("<tr><td>Nome computer remoto     <td>");
        pw.println(request.getRemoteHost());
        pw.println("</table>");
    }
}
