package cap01;

import java.io.*;
import java.util.*;

import javax.servlet.*;
import javax.servlet.http.*;

public class LogFilter implements Filter {
	FilterConfig config;
	ServletContext context;
	
	public void init(FilterConfig config) {
		this.config = config;
		context = config.getServletContext();
	}
	
	public void destroy() {
		System.out.println("LogFilter.destroy()");
	}
	
	public void doFilter(ServletRequest req, ServletResponse res, FilterChain chain) 
	  	throws IOException, ServletException {
		
	    //chain.doFilter(req, res);

	    System.out.println("Richiesta da " + req.getRemoteAddr() +
            ": " + ((HttpServletRequest)req).getRequestURI() );
    }
}


