package cap01;

import java.io.*;
import java.util.*;

import javax.servlet.*;
import javax.servlet.http.*;

public class ParametriServlet extends HttpServlet {

	public void doGet(HttpServletRequest req, HttpServletResponse res) 
			throws ServletException, IOException {
			
		res.setContentType("text/html");
		PrintWriter pw = res.getWriter();
	
		pw.println("<html>");
		pw.println("<body>");
		
		ServletContext app = getServletContext();
		
		Enumeration e = app.getInitParameterNames();
		
		pw.println("<h1>Parametri dell'applicazione:</h1>");
		pw.println("<table>");
	
		while (e.hasMoreElements()) {
		  String name = (String) e.nextElement();
	
		  pw.print("<tr><td>");
		  pw.print(name);
		  pw.print("<td>");
		  pw.println(app.getInitParameter(name));
		}
	
		pw.println("</table>");
		
		e = getInitParameterNames();
		
		pw.println("<h1>Parametri della servlet:</h1>");
		pw.println("<table>");
	
		while (e.hasMoreElements()) {
		  String name = (String) e.nextElement();
	
		  pw.print("<tr><td>");
		  pw.print(name);
		  pw.print("<td>");
		  pw.println(getInitParameter(name));
		}
	
		pw.println("</table>");
		pw.println("</body>");
		pw.println("</html>");
	}
}
