package cap03;

import java.io.*;
import java.util.*;

import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;

public class RandomTag extends TagSupport {
    
    protected Random random = new Random( System.currentTimeMillis() );
    protected String type = "normale";
    
    public void setSeed( String seed ) {
        if( "oraCorrente".equals( seed ) ) {
            random.setSeed( System.currentTimeMillis() );
        } else {
            try {
                random.setSeed( Long.parseLong( seed ) );
            } catch( NumberFormatException ex ) {
                try {
                    pageContext.getOut().println( 
                        "<B>Hai specificato un attributo 'seed' non valido ("+seed+"): non  un numero</B>" 
                    );
                } catch( IOException ex1 ) {
                }
            }
        }
    }
    
    public void setType( String type ) {
        this.type = type;
    }
    
    public int doEndTag() {
        double valore = 0;
        
        try {
            if( "booleano".equals(type) ) {
                pageContext.getOut().println( random.nextBoolean() );
            } else {
                if( "normale".equals(type) ) {
                    valore = random.nextDouble();
                }
                if( "gaussiano".equals(type) ) {
                    valore = random.nextGaussian();
                }
            
                pageContext.getOut().println( valore );
            }
        } catch( IOException ex ) {
        }
        
        return EVAL_PAGE;
    }
    
}