package cap03;

import java.io.*;
import java.util.*;

import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;

public class SplitTag extends BodyTagSupport {
    
    protected int size = 40;
    
    public void setSize( String sizeString ) {
        try {
            size = Integer.parseInt( sizeString );
        } catch( NumberFormatException ex ) {
            try {
                pageContext.getOut().println( 
                    "<B>Hai specificato un attributo 'size' non valido ("+size+"): non  un numero</B>" 
                );
            } catch( IOException ex1 ) {
            }
        }
    }
    
    public int doEndTag() {
        try {
            StringBuffer sb = new StringBuffer();
            String text = getBodyContent().getString();
            
            int k=0;
            for( int i=0; i<text.length(); i++ ) {
                char c = text.charAt(i);
                
                //Converte \n e \r in spazio
                c = ( c == '\n' || c == '\r' ) ? ' ' : c;
                
                sb.append(c);
                k++;
                
                if( k==size-1 ) {
                    k = 0;
                    String temp = sb.toString();
                    int ultimoSpazio = temp.lastIndexOf(' ');
                    if( ultimoSpazio >= 0 ) {
                        temp = temp.substring(0,ultimoSpazio);
                        i -= sb.toString().length()-ultimoSpazio-1;
                    }
                    pageContext.getOut().println( temp );
                    pageContext.getOut().println( "<BR>" );
                    
                    sb.setLength(0);
                }
            }
            
            //Stampa i caratteri rimanenti
            pageContext.getOut().println( sb.toString() );
            pageContext.getOut().println( "<BR>" );
            
        } catch( IOException ex ) {
        }
        
        return EVAL_PAGE;
    }
    
}
