#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <termio.h>

#define  VELOCE  ( 1 )
#define  DEFAULT ( 5 )
#define  LENTO   ( 9 )

static int ritardo=DEFAULT;

ap_main()
{
  int c;
  char buffer[2];
  unsigned long int loop;
  struct termio t_old, t_new;

  ioctl(0,TCGETA,&t_old);     /* leggo la config. attuale del terminale      */
  ioctl(0,TCGETA,&t_new);     /* leggo la config. attuale del terminale      */
  
  t_new.c_lflag &= ~ICANON;   /* modifico, in modo da togliere ICANON        */
  t_new.c_lflag &= ~ECHO;     /* modifico, in modo da togliere ECHO          */
  t_new.c_cc[VMIN] = 0;       /* modifico, in modo da NON aspettare l' input */
  t_new.c_cc[VTIME] = ritardo;/* modifico, in modo da NON aspettare l' input */
  ioctl(0,TCSETA,&t_new);     /* salvo la modifica                           */

  *buffer='#'; do read(0,buffer,1); while (*buffer == '.');
  if (*buffer == '+') if (ritardo < LENTO)   ritardo+=1;
  if (*buffer == '-') if (ritardo > VELOCE)  ritardo-=1;
  if (*buffer == '*')                        ritardo =DEFAULT;
  if (*buffer == '/')                        ritardo =LENTO;
  if (*buffer == ' ')                        ritardo =0;

  ioctl(0,TCSETA,&t_old);     /* rimetto a posto il terminale                */
  ioctl(0,TCFLSH,0);          /* svuoto il buffer di input                   */
  return(0);
}
