#define MAXRECORDS 40
#define PPC 21 /*20+1*/

#define	MAXROB 24

#define msdos 1
/*#define djgpp 1*/
/* da ELIMINARE x compilare in LINUX
*/

/*#define debug 1*/

#ifdef msdos
#ifdef djgpp
#define MAXENTRY 20000
#else
#define MAXENTRY 19000
#endif
/*questo e' il max per il TurboC
Sorry */
#else
#define MAXENTRY 20000
#endif


#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<time.h>
#include	<ctype.h>
#ifdef linux
#include	<termio.h>
#include	<curses.h>
#else
#include 	<process.h>
#include	<conio.h>
#include	<io.h>
#include        <sys\stat.h>
#ifdef __TURBOC__
#include        <alloc.h>
#endif
#endif


#ifdef	msdos
void	patch();
#endif

void	scambia(int i,int j,char *in);
void	mischia(int j, char *in);
int	getval(char *from);
void 	analisi();
void    aggiorna(long nr);
void	finale(long nr);
void	init(FILE *fp, char status);
void	stampa(FILE *fp, int maxrow, long nr);
#ifdef linux
void	stampaw(long nr);
#endif
void	save(long k);
void	esci();
void	pulisci();
void	scambiaf2f(int i,int j,char *in);
void	mischiaf2f(int j, char *in);
void	uso();
void	errore(char status);
void	comando(char* cm, int argc, char *argv[]);
int	torneo(char);
void	mpush(int n);
void	mpop(int n);
char	inlist(long var);
void	cut(long var);
void	togli(int i);

#ifdef msdos
void refresh(void);
void initscr(void);
void cbreak(void);
void noecho(void);
void curs_set();
void endwin(void);
#endif

#ifndef __TURBOC__
#define randomize() srand((unsigned int)time(NULL));
#else
	#define calloc farcalloc
#endif



int	numrob=0,limrob=1;
int	numinc=0,mnuminc=0;
int	bitorneo=0;
int	birep=0;
char	rob[MAXROB+1][50];
char	srob[MAXROB+1][50];
char	testrob[50];
long	c=0,bias=0;
int	matches=0;
int	matchperc=10;
char	*in;
char	fileout[50];
int	isfileout=0;
char	temp[128];
int	log=0;
FILE	*flog=NULL;
char	extcount[100];
int	ordine=0;
int	rep=0;
int	winbonus=3;
int	drawbonus=0;
int	loosepen=1;
int	rtest=0,mtest=0;
int	quiet=0;
int	f2f=0;
char	versio[50]="ECAT2k v1.0 - metodo Ascheri";
char	*memoria;
char	robstring[100]="torneo.rob";
char	dirstring[100];
char	outstring[100];
int	fake=0;
char 	fk[8]="";
long	var;
long	memlen=0;

#ifdef linux
	#define clrscr clear
#else
	#define clear clrscr
	#define printw printf
#endif


int main(int argc, char *argv[])
{
	int	z;
	FILE	*fp;
	int	nuovo=0;
	int	swap;

	outstring[0]=0;
	extcount[0]=0;


	if (argc!=1) {
		if(!strcmp(argv[1],"save")) comando("save",argc,argv);
		else if(!strcmp(argv[1],"quit")) comando("quit",argc,argv);
		else if(!strcmp(argv[1],"agg")) comando("aggiorna",argc,argv);

		else for(z=1;z<argc;z++)
		{
			if(argv[z][0]=='-') {
				if((tolower(argv[z][1]))=='f') f2f=1;
				else if((tolower(argv[z][1]))=='r'&&(strlen(argv[z])>3)) {
					rtest=1;
					strcpy(rob[0],(argv[z]+3));
				}
				else if((tolower(argv[z][1]))=='m') {
					mtest=1;
					mnuminc=getval(argv[z]);
				}
				else if((tolower(argv[z][1]))=='t') log=1;
				else if((tolower(argv[z][1]))=='q') quiet=1;
				else if((tolower(argv[z][1]))=='w') winbonus=getval(argv[z]);
				else if((tolower(argv[z][1]))=='p') drawbonus=getval(argv[z]);
				else if((tolower(argv[z][1]))=='l') loosepen=getval(argv[z]);
				else if((tolower(argv[z][1]))=='d') strcpy(outstring,(argv[z]+3));
				else if((tolower(argv[z][1]))=='c') {
					if (strlen(argv[z])>3) {
					#ifdef correctcrh
						if(argv[z][3]!='\'')
					#endif
						strcpy(extcount,(argv[z]+3));
					}
				} else if((tolower(argv[z][1]))=='a') {
					bitorneo=1;
					birep=getval(argv[z]);
				}

			}
			else strcpy(robstring,argv[z]);
		}


	}
	remove("cmnd");
	if(!quiet) {
		printf("\n\n\n\n\nCROBOTS %s\nCopyright (C) Michelangelo Messina\n",versio);
		printf("e-mail m.messina@tiscalinet.it\n       m.messina@libero.it\n\n\n\n");
		printf("http://go.to/crobots\nwww.yahoogroups.com/group/crobots\n\n\n\n");
	}

	if((in=(char *)calloc(((long)MAXROB*(MAXROB-1)*(MAXROB-2)*(MAXROB-3)/6)+1,sizeof(char)))==NULL) {
		printf("Memoria non allocata\n");
		exit(-1);
	}
	if((memoria=(char *)calloc(((long)MAXENTRY*PPC),sizeof(char)))==NULL) {
		printf("Memoria non allocata\n");
		exit(-1);
	}

	if(!strstr(robstring,".")) strcat(robstring,".rob");
	if(!outstring[0]) {
		strcpy(outstring,robstring);
		while(strstr(outstring,"\\"))strcpy(outstring,strstr(outstring,"\\")+1);
		while(strstr(outstring,"/"))strcpy(outstring,strstr(outstring,"/")+1);
		if(strstr(outstring,".")) *(strstr(outstring,"."))=0;
		strcpy(dirstring,outstring);
		strcat(outstring,".sco");
	} else {
		strcpy(dirstring,outstring);
		if(strstr(dirstring,".")) *(strstr(dirstring,"."))=0;
		while(strstr(dirstring,"\\"))strcpy(dirstring,strstr(dirstring,"\\")+1);
		while(strstr(dirstring,"/"))strcpy(dirstring,strstr(dirstring,"/")+1);
		if(!strstr(outstring,".")) strcat(outstring,".sco");

	}
	strcpy(fileout,outstring);
	if(bitorneo) f2f=1;

	if(!quiet) {
		initscr();
		cbreak();
		noecho();

		clear();
		curs_set(0);
		printw("CROBOTS %s\nCopyright (C) Michelangelo Messina\n",versio);
		printw("e-mail m.messina@tiscalinet.it\n       m.messina@libero.it\n");
		printw("http://go.to/crobots\nwww.yahoogroups.com/group/crobots\n\n\n\n");
		printw("Un ringraziamento speciale a\n TOM POINTEXTER - autore del programma CROBOTS\n\n\n");
		printw("\n\nDedicato a tutti gli amanti di Crobots\n\n");
		if(f2f) printw("\n\nModalita' Face2Face");
		else printw("\n\n");
		printw("\n\n Premi un tasto\n");
		refresh();
		#ifdef msdos
			while(!kbhit());
		#endif
		getch();
		clear();
	}


	strcpy(temp,dirstring);
	strcat(temp,".dat");
	if((fp=fopen(temp,"rt"))!=NULL) {
		if(!quiet) {
			printw("\nHo trovato un salvataggio precedente !\n");
			printw("Digitare N se si vuole iniziare un nuovo torneo (i vecchi dati saranno persi)\n");
		#ifdef linux
			refresh();
			if((z=getchar())=='N' || z=='n') {
		#else
			while(!kbhit());
			if((z=getch())=='N' || z=='n') {
		#endif
				nuovo=1;
				fclose (fp);
				remove(temp);
				strcpy(temp,dirstring);
				strcat(temp,".mes");
				remove(temp);
			}
		}
	}
	else nuovo=1;
	if(torneo(nuovo)){
		if(bitorneo&&f2f) {
			f2f=0;
			c=0,bias=0;
			if(rep!=1) rep=0;
			if(log)log=1;
			clear();
			torneo(1);
		}
	}
	exit(0);
	return(0);
}



int torneo(char nuovo)
{
	long	L;
	FILE	*fp;
	long 	k;

	char	i,j;
	int	z,exitmode=0;
	int	rp;
	char	parameter[256];
	char    ppars[256],pars[256],nr[10];

	randomize();
	if (nuovo) {
		if(!quiet) {
			printw("\nInizio un nuovo torneo\n\n");
			printw("\n\n\nDurante il torneo:\nS: salva la situazione\nQ: abbandona il torneo");
			printw("\nAltro tasto: aggiorna la classifica\n");
			refresh();
		}
		if((fp=fopen(robstring, "rb"))==NULL) uso();
		init(fp,0);
		fclose(fp);

		if(f2f) {
			for(i=0;i<limrob;i++) {
				for(j=i+1;j<numrob;j++)
				{
					in[(long)c*2]=i;
					in[(long)(c++)*2+1]=j;
				 }
			}

			k=c;
			if (!ordine) {
				for(c=0;c<k;c++) scambiaf2f(c, c+rand()%(k-c), in);
			}
		}
		else {
			for(i=0;i<limrob;i++) {
				for(j=i+1;j<numrob;j++)
					for(k=j+1;k<numrob;k++)
						for(z=k+1;z<numrob;z++)
						{
							in[(long)c*4]=i;
							in[(long)c*4+1]=j;
							in[(long)c*4+2]=k;
							in[((long)(c++))*4+3]=z;
						}
			}

			for(i=1,k=0;i<=limrob;i++)
				k+=(int)((long)(numrob-i)*(long)(numrob-(i+1))*(long)(numrob-(i+2))/6);
			if (!ordine) {
				for(c=0;c<k;c++) scambia(c, c+rand()%(k-c), in);
			}
		}
		if(matchperc) matches=(int)((float)(k*matchperc)/100);
	} else	{
		if(!quiet) {
			printw("\nContinuo il torneo salvato in precedenza\n\n");
			printw("\n\n\nDurante il torneo:\nS: salva la situazione\nQ: abbandona il torneo");
			printw("\nAltro tasto: aggiorna la classifica");
			refresh();
		}
		init(fp=fopen(temp,"rt"),1);
		fscanf(fp, "%ld", &k);
		if(f2f) for(L=0;L<(2*(long)k);L++) fscanf(fp, "%d", &in[L]);
		else for(L=0;L<(4*k);L++) fscanf(fp, "%d", &in[L]);
		fscanf(fp,"%ld",&bias);
		while (fgets(temp,80,fp)){
			if (toupper(temp[0])=='M' && strstr(temp,"=")) {
				if(!(matches=getval(temp))) matches=100;
			} else if (toupper(temp[0])=='D') {
				strcpy(fileout,strstr(temp,"=")+1);
				isfileout=1;
				if(strchr(fileout,13))
				*(strchr(fileout,13))=0;
				if(strchr(fileout,10))
				*(strchr(fileout,10))=0;
			} else if (toupper(temp[0])=='T') log=2;
			else if (toupper(temp[0])=='C'&&!(extcount[0])) strcpy(extcount,strstr(temp,"=")+1);
		}
		fclose(fp);
		strcpy(temp,dirstring);
		strcat(temp,".dat");
		remove(temp);
		strcpy(temp,dirstring);
		strcat(temp,".mes");
		remove(temp);

		if (log==2) {
			strcpy(temp,dirstring);
			strcat(temp,".log");
			if((flog=fopen(temp,"rt"))==NULL) {
				endwin();
				printf("File di log non trovato\n");
				exit(-1);
			}
			else fclose(flog);
		}
	}
	if (extcount[0] && !log) {
		if(quiet) extcount[0]=0;
		else {
		#ifdef msdos
			while(kbhit())getch();
		#endif
			clear();
			printw("\n\n Per utilizzare un programma di conteggio esterno e' necessario creare il log\n");
			printw("degli incontri. Inserire la riga\n\n  T\n\n nel .rob\n\noppure, su linea di comando\n\n  -t\n");
			printw("\n\n Digitare S per abilitare la creazione del log\n");
			refresh();
			#ifdef msdos
				while(!kbhit());
				if((z=getch())!='S' && z!='s') {
			#else
				if((z=getchar())!='S' && z!='s') {
			#endif
					chdir(dirstring);
					esci();
				}
			log=1;
		}
	}
	if(!matches) matches=1;
	if(!rep) {
		rep=numinc;
		numinc=1;
	}
	if (log){
		strcpy(temp,dirstring);
		strcat(temp,".log");
		if(log==2||((!f2f)&&bitorneo)) flog=fopen(temp,"ab");
		else flog=fopen(temp,"wb");
		if (flog==NULL) {
			endwin();
			printf("\n\nNon riesco a creare il file di log.\n");
			exit(-1);
		}
		if (log==1) {
			if((!f2f)&&bitorneo) {
				fprintf(flog,"\n\n----------\n\n\n");
				bitorneo=0;
			}
			fprintf(flog,"Torneo gestito da %s di Michelangelo Messina\n",versio);
			fprintf(flog,"Numero incontri=%ld",((long)k)*numinc*rep);
		}
	}
	#ifdef linux
	if(extcount[0]) if(!strstr(extcount,">/dev/null") ) {
		if(extcount[strlen(extcount)-1]==10) extcount[strlen(extcount)-1]=0;
		strcat(extcount," >/dev/null");
	}
	strcpy(pars,"crobots </dev/null >L 2>/dev/null -l200000 -m");
	strcpy(ppars,"ppc </dev/null >/dev/null ");
	strcpy(nr,"0000");
	#else
	strcpy(pars,"crobots<nul>L -l200000 -m");
	strcpy(ppars,"ppc <nul >nul ");
	#endif
	strcat(ppars,testrob);
	strcat(ppars,"-v=mem:");
	if(f2f) {
		#ifdef msdos
		gotoxy(1,17);
		#endif
		nr[0]='0'+(numinc)/1000;
		nr[1]='0'+(numinc-1000*(int)((numinc)/1000))/100;
		nr[2]='0'+(numinc-100*(int)((numinc)/100))/10;
		nr[3]='0'+numinc%10;
		nr[4]=' ';
		nr[5]=0;
	} else {
		#ifdef msdos
		gotoxy(1,16);
		#endif
		nr[0]='0'+(numinc)/10;
		nr[1]='0'+(numinc)%10;
		nr[2]=' ';
		nr[3]=0;
	}
	strcat(pars,nr);
	strcat(pars,fk);
	chdir(dirstring);

	#ifdef linux
	if(!quiet) nodelay(stdscr,TRUE);
	#endif

	for(c=0;c<k;c++) {
		#ifdef linux
		if(!quiet) {
			move(23,1);
			printw("In corso: Match %d su %d",c+bias+1,k+bias);
			refresh();
		}
		#endif
		for(rp=0;rp<rep;rp++) {
			strcpy(parameter,ppars);
			var=(long)(rand()%memlen);
			strcat(parameter,memoria+(var*(long)PPC*sizeof(char)));
			#ifdef debug
			printf("eseguo:%s",parameter);
			#endif
			if(system(parameter)) {
				clrscr();
				#ifdef linux
				endwin();
				#endif
				#ifdef debug
				printf("\nCMDLINE=%s\n",parameter);
				printf("\nvar=%ld\nmemlen=%ld\n",var,memlen);
				#endif
				printf("Errore nell'uso del preprocessore\n");
				esci();
			}
			strcpy(parameter,pars);
			if(f2f) {
				mischiaf2f(c,in);
				strcat(parameter,srob[in[(long)c*2]]);
				strcat(parameter,srob[in[(long)c*2+1]]);
			}
			else {
				mischia(c,in);
				strcat(parameter,srob[in[(long)c*4]]);
				strcat(parameter,srob[in[(long)c*4+1]]);
				strcat(parameter,srob[in[(long)c*4+2]]);
				strcat(parameter,srob[in[(long)c*4+3]]);
			}
			#ifdef msdos
			if(fake) {
				gotoxy(1,21);
				printf("In corso: Match %ld su %ld",(long)c+bias+1,((long)k)+bias);
				clreol();
			}
			else if (f2f) gotoxy(1,17);
			else gotoxy(1,16);

			if(system(parameter)) {
				clrscr();
				#ifdef debug
				printf("\nCMDLINE=%s\n",parameter);
				#endif
				if(strlen(parameter)>123) printf("\nErrore DOS: riga di comando troppo lunga: %d caratteri\nRidurre la lunghezza dei path dei robot (max CMDLINE = 123 caratteri)\n",strlen(parameter));
				else printf("\nErrore DOS nell'esecuzione di crobots.exe\nProgramma interrotto\n");
				esci();
			}
			#else
			if(system(parameter)) {
				endwin();
				#ifdef debug
				printf("\nCMDLINE=%s\n",parameter);
				#endif
				printf("\nProgramma interrotto\n");
				esci();
			}
			#endif
			analisi();
			togli(0);

			if(!quiet||rp==rep-1) {
				if((fp=fopen("cmnd","rt"))!=NULL) {
					aggiorna(k);
					fscanf(fp,"%s",temp);
					fclose(fp);
					remove("cmnd");
					if(!strcmp("save",temp)) exitmode=2;
					else if(!strcmp("quit",temp)&&!exitmode) {
						exitmode=1;
						break;
					}
				}
				#ifdef linux
				else if((fp=fopen("../cmnd","rt"))!=NULL) {
				#else
				else if((fp=fopen("..\\cmnd","rt"))!=NULL) {
				#endif
					aggiorna(k);
					fscanf(fp,"%s",temp);
					fclose(fp);
					if(!strcmp("save",temp)) exitmode=2;
					else if(!strcmp("quit",temp)&&!exitmode) {
						exitmode=1;
						break;
					}
				}
				#ifdef linux
				else if(!quiet) {
					if((z=getch())!=ERR) {
						aggiorna(k);
						if(z=='q'||z=='Q'||z=='s'||z=='S') {
							if(z=='s'||z=='S') exitmode=2;
							else if(!exitmode){
								exitmode=1;
								break;
							}
						}
					}
				}
				#else
				if(kbhit()) {
					aggiorna(k);
					if((z=getch())=='q' || z=='Q' || z=='s' ||z=='S') {
						if(z=='s' || z=='S') exitmode=2;
						else if(!exitmode){
							exitmode=1;
							break;
						}
					}
				}
				#endif
			}
		}
		if(exitmode==2) save(k);
		if(exitmode) break;
		else if(!((c+1)%matches))aggiorna(k);

	}
	if(c==k) c--;
	if (log) fclose(flog);
	finale(k);
	pulisci();
	return(!exitmode);
}

void	togli(int i)
{
	#ifdef msdos
	remove(srob[i]);
	#else
	strcpy(temp,srob[i]);
	if(strstr(temp," ")) *(strstr(temp," "))=0;
	if(strstr(temp,"\\")) strcpy(strstr(temp,"\\"),strstr(temp,"\\")+1);
	remove(temp);
	#endif
}

void	init(FILE *fp, char status)
{
	int	i;
	int	tipo=0;
	int	dummy;
	FILE	*test;
	char	temp[40];

	if((!bitorneo)||f2f){
		strcpy(temp,dirstring);
		if(status) strcat(temp,".mes");
		else strcat(temp,".mem");
		if((test=fopen(temp,"r"))==NULL) {
			printf("Manca il file di memoria %s\n",temp);
			exit(-1);
		}
		while (fscanf(test, "%s", temp)!=EOF) {
			strcpy(memoria+(memlen++)*(long)PPC*sizeof(char),temp);
			#ifdef debug
			printf("temp=%s\n",temp);
			printf("%ld",memlen);
			printf(" - %s\n",(memoria+((memlen-1)*(long)PPC*sizeof(char))));
			getche();
			#endif
		}
		fclose(test);
	}
	if(status){
		fscanf(fp, "%d",&tipo);
		if(tipo !=9) {
			printf("Errore: questo non e' un salvataggio di %s\n",versio);
			exit(-1);
		}

		mtest=0;
		rtest=0;
		rep=0;
		log=0;
		f2f=0;
		bitorneo=0;
		fscanf(fp, "%d",&tipo);
		if(tipo>1) {
			bitorneo=1;
			tipo-=2;
		}
		if(tipo>0) f2f=1;
		if(bitorneo) {
			fscanf(fp,"%d",&birep);
			fscanf(fp,"%s",robstring);
			fscanf(fp,"%d",&limrob);
		}

	}
	fscanf(fp, "%d",&numrob);
	if(!numrob) errore(status);
	fscanf(fp, "%d",&numinc);
	if(birep&&f2f) {
		if(!mtest) {
			mnuminc=numinc;
			mtest=1;
		}
		numinc=birep;
	} else if(mtest) numinc=mnuminc;

	if(!numinc) errore(status);
	numrob+=rtest;
	for(i=rtest;i<numrob;i++) if(fscanf(fp,"%s",rob[i])==EOF) errore(status);
	#ifdef djgpp
	if (mkdir(dirstring,S_IWUSR)) {
	#else
	if (mkdir(dirstring)) {
	#endif
		endwin();
		fclose(fp);
		printf("E' in corso un'altro torneo nella directory %s !\n",dirstring);
		printf("\nSe la directory %s e' stata creata da una esecuzione non andata a buon fine,\n eliminarla prima di lanciare %s\n",dirstring,versio);
		printf("\n\nAltrimenti utilizzare -d=xxxx per cambiare directory di destinazione\n");
		exit(-1);
	}
	#ifdef msdos
	patch();
	#else
	strcpy(temp,"chmod a=rwx ");
	strcat(temp,dirstring);
	system(temp);
	#endif


	for(i=0;i<numrob;i++) {
		if(strchr(rob[i],13))
		*(strchr(rob[i],13))=0;
		if(strchr(rob[i],10))
		*(strchr(rob[i],10))=0;
		strcpy(srob[i],rob[i]);

		strcpy(temp,srob[i]);
		if(strstr(temp," ")) *(strstr(temp," "))=0;
		#ifdef linux
		if(strstr(temp,"\\")) strcpy(strstr(temp,"\\"),strstr(temp,"\\")+1);
		#endif
		if((test=fopen(temp,"r"))!=NULL) fclose(test);
		else {
			printf("Robot: %s\n",temp);
			errore(2);
		}
		strcat(srob[i]," ");
		#ifdef linux
		strcpy(temp,"ln -s >/dev/null ");
		if(srob[i][0]!='/') strcat(temp,"../");
		strcat(temp,srob[i]);
		strcat(temp,dirstring);
		while(strstr(srob[i],"/"))strcpy(srob[i],strstr(srob[i],"/")+1);
		#else
		strcpy(temp,"copy >nul ");
		strcat(temp,srob[i]);
		while(strstr(srob[i],":")) strcpy(srob[i],strstr(srob[i],":")+1);
		while(strstr(srob[i],"\\")) strcpy(srob[i],strstr(srob[i],"\\")+1);
		strcat(temp,dirstring);
		#endif
		if(system(temp)) {
			endwin();
			printf("Errore nell'apertura dei files\n");
			exit(-1);
		}


		if(i&&(strstr(srob[i],".pr") || strstr(srob[i],".PR"))) {
			#ifdef linux
			strcpy(temp,"ppc </dev/null >/dev/null ");
			#else
			strcpy(temp,"ppc <nul >nul ");
			#endif
			strcat(temp,dirstring);
			#ifdef linux
			strcat(temp,"/");
			#else
			strcat(temp,"\\");
			#endif
			strcat(temp,srob[i]);
			if(system(temp)) {
				endwin();
				printf("Errore nel file %s.rob\no nell'utilizzo del preprocessore\n",dirstring);
				exit(-1);
			}

			strcpy(temp,dirstring);
			#ifdef linux
			strcat(temp,"/");
			#else
			strcat(temp,"\\");
			#endif
			strcat(temp,srob[i]);
			if(strstr(temp," ")) *(strstr(temp," "))=0;
			remove(temp);

			*(strstr(srob[i],"."))=0;
			strcat(srob[i],".r ");
		}

		if(i&&!strstr(srob[i],".r") && !strstr(srob[i],".R")) {
			printf("Robot: %s\n",srob[i]);
			errore(2);
		}

	}

	if(!strstr(srob[0],".pr") && !strstr(srob[0],".PR") ) {
		endwin();
		printf("Errore\n Il primo robot non e' del tipo *.pr\nRobot:%s\n",srob[0]);
		exit(-1);
	}
	else {
		strcpy(testrob,srob[0]);
		*(strstr(srob[0],"."))=0;
		strcat(srob[0],".r ");
	}

	if (status) {
		if(bitorneo) fscanf(fp,"%d",&rtest);
		return;
	}

	while (fgets(temp,80,fp)){
		if (toupper(temp[0])=='M' && strstr(temp,"=")) {
			if(!(matches=getval(temp))) matches=100;
		}
		else if (toupper(temp[0])=='D') {
			strcpy(fileout,strstr(temp,"=")+1);
			isfileout=1;
			if(strchr(fileout,13))
			*(strchr(fileout,13))=0;
			if(strchr(fileout,10))
			*(strchr(fileout,10))=0;

		}
		else if (toupper(temp[0])=='T') log=1;
		else if (toupper(temp[0])=='O') ordine=1;
		else if (toupper(temp[0])=='C'&&!extcount[0]) strcpy(extcount,strstr(temp,"=")+1);

	}
	if ((!limrob)||(limrob>numrob)) limrob=numrob;
}

void	scambia(int i,int j,char *in)
{
	char k,temp;
	for(k=0;k<4;k++) {
		temp=in[(long)j*4+(long)k];
		in[(long)j*4+(long)k]=in[(long)i*4+(long)k];
		in[(long)i*4+(long)k]=temp;
	}

}

void mischia(int j, char *in)
{
	int k,temp,z;
	for(k=0;k<4;k++) {
		z=rand()%(4);
		temp=in[(long)j*4+(long)z];
		in[(long)j*4+(long)z]=in[(long)j*4+(long)k];
		in[(long)j*4+(long)k]=temp;
	}
}

void save(long k)
{
	long	L;
	FILE	*fp;
	long i,j;

	#ifdef msdos
	strcpy(temp,"..\\");
	#else
	strcpy(temp,"../");
	#endif
	strcat(temp,dirstring);
	strcat(temp,".dat");
	if((fp=fopen(temp,"wt"))!=NULL) {
		fprintf(fp, "9\n");
		fprintf(fp, "%d\n",(f2f+2*bitorneo));
		if(bitorneo) {
			fprintf(fp, "%d\n",birep);
			fprintf(fp, "%s\n",robstring);
			fprintf(fp, "%d\n",limrob);
		}
		fprintf(fp, "%d\n",numrob);
		if(mtest) fprintf(fp, "%d\n",mnuminc);
		else {
			if(rep==1) fprintf(fp, "%d\n",numinc);
			else fprintf(fp,"%d\n",rep);
		}

		for(i=0;i<numrob;i++)
			fprintf(fp,"%s\n",rob[i]);
		if(bitorneo) fprintf(fp,"%d\n",rtest);
		fprintf(fp,"%ld\n",k-c-1);

		if(f2f) for(L=(2*((long)c+1));L<(2*(long)k);L++) {
			fprintf(fp, "%d\n", in[L]);
		}
		else for(L=(4*((long)c+1));L<(4*(long)k);L++) {
			fprintf(fp, "%d\n", in[L]);
		}
		fprintf(fp,"%ld\n", bias+c+1);
		if (matches!=100) fprintf(fp, "M=%d\n", matches);
		if (log) fprintf(fp, "T\n");
		if (extcount[0]) fprintf(fp, "C=%s\n",extcount);
		if (isfileout) fprintf(fp, "D=%s\n", fileout);
		fclose(fp);
		if (!quiet) printf("\n\n Situazione salvata nel file  %s.dat\n",dirstring);
	}
	else {
		endwin();
		printf("Errore nel salvataggio!\n");
		esci();
	}

	/*savemem*/
	for(i=0;i<memlen-1;i++) {
		for(j=i+1;j<memlen;j++) {
			if(strcmp(memoria+i*(long)PPC*sizeof(char),memoria+j*(long)PPC*sizeof(char))>0) {
				strcpy(temp,memoria+i*(long)PPC*sizeof(char));
				strcpy(memoria+i*(long)PPC*sizeof(char),memoria+j*(long)PPC*sizeof(char));
				strcpy(memoria+j*(long)PPC*sizeof(char),temp);
			}
		}
	}
	#ifdef msdos
	strcpy(temp,"..\\");
	#else
	strcpy(temp,"../");
	#endif
	strcat(temp,dirstring);
	strcat(temp,".mes");
	fp=fopen(temp,"w");
	for (i=0;i<memlen;i++) fprintf(fp,"%s\n",memoria+i*(long)PPC*sizeof(char));
	fclose(fp);
}



void analisi()
{
	char	buffer[17][80];
	int	i,j,k;
	FILE	*fp;
	char	car,ncar;


	if(log) {
		if((fp=fopen("L", "rb"))==NULL) {
			endwin();
			printf("Errore nel caricamento di L\n");
			esci();
		}
		car=fgetc(fp);
		while (!feof(fp)) {
			ncar=fgetc(fp);
			if(fputc(car,flog)==EOF) {
				endwin();
				printf("Errore nella scrittura del log\n");
				fclose(fp);
				esci();
			}
			car=ncar;
		}
		fflush(flog);
		fclose(fp);
	}

	if((fp=fopen("L", "rt"))==NULL) {
		endwin();
		printf("Errore nel caricamento di L\n");
		esci();
	}
	i=0;

	if(f2f) {
		while (!feof(fp)) {
			fscanf(fp,"%s",buffer[((++i)%10)]);
		}
		fclose (fp);

		if(i++<3) {
			endwin();
			printf("\n\nErrore nella compilazione di un robot!\n");
			esci();
		}

		for(j=0;j<2;j++)
		{
			k=in[c*2+j];

			if(!k) {
				if(getval((char *)buffer[((i+4*j+3)%10)])) mpush(winbonus);
				else if(!(getval((char *)buffer[((i+4*j+4)%10)]))) mpop(loosepen);
				else mpush(drawbonus);
			}

		}
		return;

	}
	while (!feof(fp)) {
		fscanf(fp,"%s",buffer[((++i)%17)]);
	}
	fclose (fp);

	i++;

	for(j=0;j<4;j++)
	{
		k=in[c*4+j];
		if(!k) {
			if(getval((char *)buffer[((i+4*j+2)%17)])) mpush(winbonus);
			else if(!(getval((char *)buffer[((i+4*j+3)%17)]))) mpop(loosepen);
			else mpush(drawbonus);
		}


	}
	if(strspn(buffer[(i+13)%17],srob[in[c*4+3]])!=(strlen(srob[in[c*4+3]])-1)) {
		endwin();
		printf("\n\nErrore a runtime nella compilazione di un robot!\n");
		esci();
	}

/*	#ifdef msdos
	gotoxy(1,16);
	#endif
  */
}
void	mpush(int n)
{
	int i;
	if((memlen+n)>MAXENTRY) {
		printf("Errore fatale!\nFile di memoria troppo lungo\n");
		esci();
	}
	for(i=0;i<n;i++) strcpy(memoria+(memlen++)*(long)PPC*sizeof(char),(memoria+var*(long)PPC*sizeof(char)));
}
void	mpop(int n)
{
	int i;
	for(i=0;i<n;i++) if (inlist(var)) cut(var);
}
char 	inlist(long var)
{
	long i;
	for(i=0;i<memlen;i++) if(!strcmp( memoria+i*(long)PPC*sizeof(char),memoria+var*(long)PPC*sizeof(char)) && i!=var) return 1;
	return 0;
}
void	cut(long var)
{
	strcpy(memoria+var*(long)PPC*sizeof(char),memoria+(--memlen)*(long)PPC*sizeof(char));
}


void	aggiorna(long nr)
{
	FILE	*fp;


	chdir("..");
	if(extcount[0]) system(extcount);
	if (isfileout) {
		if((fp=fopen(fileout, "wt"))==NULL) {
			endwin();
			printf("Errore nella scrittura dei risultati\n");
			esci();
		}
		stampa(fp,100,nr);
		fclose(fp);
	}
	if(!quiet) {
		#ifdef msdos
		clrscr();
		gotoxy(1,1);
		stampa(stdout,18,nr);
		#else
		stampaw(nr);
		#endif
	}
	chdir(dirstring);

/*	#ifdef msdos
	if (f2f) gotoxy(1,17);
	else gotoxy(1,16);
	#endif
*/
}

int	getval(char *from)
{
	char *r;
	r=strchr(from,'=');
	return(atoi(r+1));
}

void finale(long nr)
{
	FILE	*fp;

	chdir("..");
	if(extcount[0]) system(extcount);
	clrscr();
	endwin();
	if((fp=fopen(fileout,"wt"))==NULL) {
		printf("\nRisultati non salvati!\n");
		chdir(dirstring);
		esci();
	}
	stampa(fp,100,nr);
	fclose(fp);
	if(!quiet) {
		stampa(stdout,20,nr);
		printf("\n\n I risultati sono stati salvati nel file %s\n",fileout);
	}
	chdir(dirstring);
}

void stampa(FILE *fp,int maxrow, long nr)
{
	int	classifica[MAXRECORDS],maxentry,tempo;
	long	i,j;
	char	memrec[MAXRECORDS][PPC];
	long	memnum[MAXRECORDS];

	for(i=0;i<memlen-1;i++) {
		for(j=i+1;j<memlen;j++) {
			if(strcmp(memoria+i*(long)PPC*sizeof(char),memoria+j*(long)PPC*sizeof(char))>0) {
				strcpy(temp,memoria+i*(long)PPC*sizeof(char));
				strcpy(memoria+i*(long)PPC*sizeof(char),memoria+j*(long)PPC*sizeof(char));
				strcpy(memoria+j*(long)PPC*sizeof(char),temp);
			}
		}
	}
	maxentry=0;
	strcpy(memrec[maxentry],memoria);
	memnum[maxentry]=1;
	for(i=1;i<memlen;i++) {
		if(!strcmp(memrec[maxentry],memoria+i*(long)PPC*sizeof(char))) memnum[maxentry]++;
		else {
			if((++maxentry)>=MAXRECORDS) {
				fprintf(fp,"Errore:\nTroppi records!\nMax = %d",MAXRECORDS);
				chdir(dirstring);
				esci();
			}
			memnum[maxentry]=1;
			strcpy(memrec[maxentry],memoria+i*(long)PPC*sizeof(char));
		}
	}
	#ifdef debug
	while(!kbhit());
	clear();
	fprintf(fp,"Questi sono i records\n");
	for (i=0;i<=maxentry;i++) fprintf(fp,"%ld : %ld - %s\n",i,memnum[i],memrec[i]);
	getche();
	#endif


	for(i=0;i<=maxentry;i++) classifica[i]=i;
	fprintf(fp," Migliori valori dopo %ld incontri su %ld (%ld %%):\n",(long)(c+1+bias),(long)(nr+bias),(((long)(c+bias+1)*100))/(nr+bias));
	fprintf(fp," Ripetizioni   -   Valore\n");
	for(i=0;i<maxentry;i++) {
		for (j=i+1;j<=maxentry;j++) {
			if(memnum[classifica[i]]<memnum[classifica[j]]) {
				tempo=classifica[i];
				classifica[i]=classifica[j];
				classifica[j]=tempo;
			}
		}
	}
	for(i=0;i<=maxentry&&i<maxrow;i++) {
		fprintf(fp,"%6ld         - %20s\n",memnum[classifica[i]],memrec[classifica[i]]);
	}


}


#ifdef linux
void stampaw(long nr)
{
	int	classifica[MAXENTRY],maxentry,tempo;
	long	i,j;
	char	memrec[MAXRECORDS][PPC];
	long	memnum[MAXRECORDS];


	for(i=0;i<memlen-1;i++) {
		for(j=i+1;j<memlen;j++) {
			if(strcmp(memoria+i*(long)PPC*sizeof(char),memoria+j*(long)PPC*sizeof(char))>0) {
				strcpy(temp,memoria+i*(long)PPC*sizeof(char));
				strcpy(memoria+i*(long)PPC*sizeof(char),memoria+j*(long)PPC*sizeof(char));
				strcpy(memoria+j*(long)PPC*sizeof(char),temp);
			}
		}
	}
	maxentry=0;
	strcpy(memrec[maxentry],memoria);
	memnum[maxentry]=1;
	for(i=1;i<memlen;i++) {
		if(!strcmp(memrec[maxentry],memoria+i*(long)PPC*sizeof(char))) memnum[maxentry]++;
		else {
			if((++maxentry)>=MAXRECORDS) {
				printw("Errore:\nTroppi records!\nMax = %d",MAXRECORDS);
				chdir(dirstring);
				esci();
			}
			memnum[maxentry]=1;
			strcpy(memrec[maxentry],memoria+i*(long)PPC*sizeof(char));
		}
	}

	for(i=0;i<=maxentry;i++) classifica[i]=i;
	clear();
	printw(" Migliori valori dopo %ld incontri su %ld (%ld %%):\n",(long)(c+1+bias),(long)(nr+bias),(((long)(c+bias+1)*100))/(nr+bias));
	printw(" Ripetizioni   -   Valore\n");
	for(i=0;i<maxentry;i++) {
		for (j=i+1;j<=maxentry;j++) {
			if(memnum[classifica[i]]<memnum[classifica[j]]) {
				tempo=classifica[i];
				classifica[i]=classifica[j];
				classifica[j]=tempo;
			}
		}
	}
	for(i=0;i<=maxentry;i++) {
		printw("%6d         -   %s\n",memnum[classifica[i]],memrec[classifica[i]]);
	}
}
#else
void patch()
{
	unsigned long 	c,l;
	char	i,j,temp[128];
	FILE	*fp1,*fp2,*fp;

	if((fp1=fopen("ppc.exe","rb"))==NULL) {
		printf("Il file PPC.EXE deve essere nella directory corrente!\n");
		exit(-1);
	}
	fclose(fp1);
	strcpy(temp,"copy >nul ppc.exe ");
	strcat(temp,dirstring);
	strcat(temp,"");
	/*if(system(temp)) {
		__system_flags|=__system_call_cmdproc;*/
		if(system(temp)) {
			printf("Errore nella copia del file ppc.exe\n");
			printf("%s\n",temp);
			exit(-1);
		}
	/*}*/
	if((fp1=fopen("crobots.exe","rb"))==NULL) {
		printf("Il file CROBOTS.EXE deve essere nella directory corrente!\n");
		exit(-1);
	}

	if(filelength(fileno(fp1))!=60224) fake=1;

	strcpy(temp,dirstring);
	strcat(temp,"\\crobots.exe");
	if((fp2=fopen(temp,"wb"))==NULL) {
		printf("Errore in scrittura!\n");
		fclose(fp1);
		exit(-1);
	}
	if((fp=fopen("patch.dat","rb"))==NULL) {
		printf("Il file PATCH.DAT deve essere nella directory corrente!\n");
		fclose(fp1);
		fclose(fp2);
		exit(-1);
	}
	if(filelength(fileno(fp))!=5280) {
		printf("E' necesaria la nuova versione del file PATCH.DAT\n");
		fclose(fp);
		fclose(fp1);
		fclose(fp2);
		exit(-1);
	}
	fread(&l,sizeof(long),1,fp);

	if(fake) strcpy(fk,"-g ");
	for(c=0;!feof(fp1);c++) {
		if(!(fread(&i,sizeof(char),1,fp1))) break;
		if(c==l&& !fake) {
			fread(&j,sizeof(char),1,fp);
			fwrite(&j,sizeof(char),1,fp2);
			fread(&l,sizeof(long),1,fp);
		}
		else  fwrite(&i,sizeof(char),1,fp2);
	}
	fclose(fp1);
	fclose(fp2);
	fclose(fp);
}
#endif
void esci()
{
	if (log&&flog) fclose(flog);
	pulisci();
	exit(-1);
}

void	scambiaf2f(int i,int j,char *in)
{
	char k,temp;
	for(k=0;k<2;k++) {
		temp=in[(long)j*2+(long)k];
		in[(long)j*2+(long)k]=in[(long)i*2+(long)k];
		in[(long)i*2+(long)k]=temp;
	}

}

void mischiaf2f(int j, char *in)
{
	char k,temp,z;
	for(k=0;k<2;k++) {
		z=rand()%(2);
		temp=in[(long)j*2+(long)z];
		in[(long)j*2+(long)z]=in[(long)j*2+(long)k];
		in[(long)j*2+(long)k]=temp;
	}
}

void uso()
{
	if(quiet) printf("Errore - digitare ecat ? per ottenere l'aiuto\n");
	else {
		clear();
		printw("Uso: ecat [switches] [file di comando[.rob]]\n");
		printw("     ecat save|quit|agg [nometorneo]\n");
		printw("Per default il file di comando e' torneo.rob\n\n");
		printw("Switches:\n\n");
		printw("-d=x  : files di output del tipo x.est\n");
		printw("-r=x.r: aggiunge x.r come primo robot\n");
		printw("-f    : attiva modalita' Face2Face\n");
		printw("-a[=x]: esegue il torneo F2F e poi il 4vs4 (F2F con x ripetizioni per incontro)\n");
		printw("-m=x  : x incontri per match \n");
		printw("-t    : crea il file di log  \n");
		#ifdef msdos
		printw("\"-c=x\": esegue il prog. esterno di conteggio (p.es. \"-c=count73 torneo /a\")\n");
		#else
		printw("\"-c=x\": esegue il prog. esterno di conteggio (p.es. \"-c=count73 torneo -a\")\n");
		#endif
		printw("-q    : modalita' 'QUIET' per i batch\n");
		printw("-w=x  : premio per vittoria (default=3)\n");
		printw("-p=x  : premio per pareggio (default=0)\n");
		printw("-l=x  : penalita' per sconfitta (default=1)\n");
		printw("\nQuesti switches hanno la priorita' su quelli inseriti nel file di comando\n");
		printw("\n Premi un tasto\n");
		refresh();
		#ifdef msdos
		while(!kbhit());
		getch();
		#else
		getchar();
		#endif
		clear();
		printw("\nIl file di comando deve contenere:\nnumero robot\nnumero incontri\nrobot del torneo (max %d, comprensivi di path)\n\n",MAXROB);
		printw("Opzioni da inserire dopo l'ultimo robot, obbligatoriamente senza spazi:\n\n");
		printw("M=n  per avere l'aggiornamento della situazione ogni n partite (default 100)\n");
		printw("D=fileoutput\n     per avere l'aggiornamento su un file diverso dal default (.sco)\n");
		printw("T    per conservare il log completo degli incontri (.log)\n");
		printw("C=progconteggio (da usare in congiunzione all'opzione T - creazione log)\n     per usare un programma esterno per l'analisi\n");
		printw("\nIl primo robot del file di comando, o quello inserito tramite switch -r \nDEVE essere quello da testare\n");
		printw("\n Premi un tasto\n");
		refresh();
		#ifdef msdos
		while(!kbhit());
		getch();
		#else
		getchar();
		#endif
		endwin();
	}
	exit(-1);

}
void comando(char* cm,int argc, char *argv[])
{
	FILE *fp;


	printf("\n\n\n\n\nCROBOTS %s\nCopyright (C) Michelangelo Messina\n",versio);
	printf("e-mail m.messina@tiscalinet.it\n       m.messina@libero.it\n\n\n\n");
	printf("www.gol.it/crobots\nhttp://go.to/crobots\n\n\n\n");

	if (argc>2) {
		strcpy(temp,argv[2]);
		if(temp[strlen(temp)-1] !='/') strcat(temp,"/");
		strcat(temp,"cmnd");
	}
	else {
		if(!strcmp(cm,"aggiorna")) {
			printf("Errore\nSpecificare il nome del torneo\n");
			exit(-1);
		}
		strcpy(temp,"cmnd");
	}
	if((fp=fopen(temp,"wt"))==NULL) {
		printf("Errore\nFile %s non creato\n",temp);
		exit(-1);
	}
	fprintf(fp,"%s\n",cm);
	fclose(fp);
	printf("Inviato comando %s\n",cm);
	exit(0);
}
void errore(char status)
{
	endwin();
	if(!status) printf("\nErrore nel file .rob\n");
	else if(status==1) printf("\nErrore nel file .dat\n");
	else printf("\nErrore nella compilazione\n");
	exit(-1);
}




void pulisci()
{
	int i;

	remove("L");
	strcpy(srob[0],testrob);
	for(i=0;i<numrob;i++) togli(i);
	chdir("..");
	endwin();
	rmdir(dirstring);
}



#ifdef msdos
void refresh(void){}
void initscr(void){}
void cbreak(void) {}
void noecho(void) {}
void curs_set() {}
void endwin(void) {
	strcpy(temp,dirstring);strcat(temp,"\\crobots.exe");remove(temp);
	strcpy(temp,dirstring);strcat(temp,"\\ppc.exe");remove(temp);
}
#endif

