
/*                          E   N   I   G   M   A





Programmato da:  Alessandro Carlin
                 Via Rivabella 4
                 32100 Belluno
                 Tel. 0437/930775
                      049/8277020
                 E-mail: carlin@padova.infm.it
                         a.carlin@libero.it
                 Web Page: it.geocities.com/a_carlin77


Pre-premessa:

Enigma e' una versione ristretta di Rudolf_7, conseguentemente rientra
nella categoria dei classicbots da 1000 istruzioni, perdendo tuttavia una
buona dose della sua efficienza a causa della liposuzione

Premessa:

Gli anni scorsi nel momento in cui si poneva il problema di iniziare il
nuovo robot ho sempre avuto la tendenza ad ispirarmi (copiare!!!) le idee
dal vincitore dell'anno prima... vedi The Invisible Man simile a Diabolik,
Cyborg ispirato a Goblin, lo stesso Rudolf_2 simile tatticamente al
predecessore ed a !.r.
Quest'anno mi sono trovato in una situazione nuova visto che Rudolf versione 6
lo avevo gia' ottimizzato io stesso ed avevo pressoche' saturato idee e Vb.
Tuttavia l'anno scorso ero rimasto molto impressionato da Fizban di Simone
Ascheri per la sua peculiarita' di avere un rendimento piu' o meno costante
in ogni torneo.
Mi sono allora chiesto da dove venisse questa peculiarita'... dopo aver
osservato il comportamento (grazie al mitico benefattore per il debugger)
in molteplici match, ho dedotto che Fizban non aveva particolari attitudini
offensive, ma un movimento (quadrato)che gli permetteva di essere molto piu'
sfuggente dei normali robot oscillanti.
L'unica pecca in tutto questo era la scarsa attitudine offensiva, che si
traduceva in un (a mio parere) poco convincente aumento delle dimensioni
del quadrato.
Da qui l'idea di trapiantare il movimento furbissimo di Fizban in un
"cervello" Rudolf_6-like, il quale attaccava l'uno o l'altro angolo adiacente
con certe regole e priorita' dipendenti da un discreto numero di parametri.
Ne e' uscito un moto a "rettangolo" che mi ha sorpreso da subito per
l'efficacia gia' dimostrata nei test preliminari proprio dal presente
Enigma, che poi ha dato lo spunto per i due big del gruppo, Zorn e Rudolf_7.


Strategia:

Come quasi tutti i crobot piu' recenti e furbi Enigma comincia l'incontro
raggiungendo l'angolo piu'vicino (spostandosi prima verticalmente e poi
orizzontalmente).
Qui verifica se sia il caso di attaccare subito l'eventuale unico avversario
altrimenti inizia un movimento del tutto fizban-like a quadrato.
Dopo un breve periodo passato in questa situazione inizia ad attaccare i robot
che occupano gli angoli adiacenti con un moto a rettangolo, con un lato
pari alla minima distanza che e' in grado di percorrere (circa 60 metri) e
l'altro tale da portarlo alla distanza ottimale dal nemico.
Questa distanza aumenta nel finale se Enigma non ha troppi danni, in modo
da evitare pareggi inutili.
Quando vede un solo avversario lo attacca con una routine molto simile a
quella del suo predecessore Rudolf_6.


Note tecniche:

1) Il movimento a quadrato non e' per niente nuovo, anche se non credo che
nessuno finora lo avesse trasformato in un moto a rettangolo, come detto
prima il pregio e' la straordinaria capacita' di non prenderle messa in evidenza
da Simone con Fizban.r

2) Lo sparo e' stato rifatto da zero, e credo in effetti che la routine, pur
essendo molto semplice, non sia mai stata usata prima anche se il punto
di partenza e' stato anche qui Fizban. Rispetto alla routine di Zorn e Rudolf e'
temporizzata peggio per ovvi motivi di spazio :-(

3) Le temporizzazioni hanno un ruolo fondamentale, non chiedetevi perche' ci
siano istruzioni inutili e sovrabbondanti disseminate qua e la' per il
listato, il loro ruolo e' solo ritardare l'esecuzione di altre istruzioni

4) L'attacco e' stato migliorato essenzialmente perche' e' stata rifatta la
routine di sparo, simile a quella usata nel corso del match

5) non ci sono le toxiche, ma questa non e' una grande novita', a maggior
ragione in un robot sotto le 1000 istruzioni


Commenti:

Enigma e' un robot abbastanza "estremo", nel senso che si basa su un
delicatissimo equilibrio di parametri e accorgimenti.
Variare di 1% alcuni parametri si riflette in un crollo anche di 3-4% nell'
efficienza, ed eliminare alcune peculiarita' apparentemente secondarie del
suo comportamento lo penalizzano anche di 15% in alcuni tornei.
Tuttavia cosi' com'e' ha veramente un'efficienza notevole e una dipendenza
minima dagli aversari che trova, tanto da avere praticamente la stessa
efficienza contro i mini e contro i bigs dell'anno scorso.


Ringraziamenti:

Un ringraziamento a tutti gli autori di robot che mi hanno ispirato, in
particolare Fizban ma anche Disco di Mich Messina e Dna di Daniele Nuzzo.
Un enorme grazie al misterioso benefattore che ci ha deliziato con il suo
meraviglioso debugger e a Mich e Simone per le utilities che continuano a
migliorare ed aggiornare, grazie alle quali lo sviluppo e il testaggio dei
robot e' davvero user-friendly.                                             */




int pezzo,asb,asa,ss,dimitri,dp,d,or,ul,ll,b,tempo,oscar,xora,flag,flag1,daa,rng,t,oldr,deg,odeg,dist;

main(){
if (asa=(loc_y(t=11)>500)) up(920); else dn(80);
if (asb=(loc_x()>500)) dx(920); else sx(80);
b=2*asa+(asa!=asb);      /* per questa devo ringraziare Simone Ascheri */
ll=90*b-35;

sganna(ul=ll+130);
while(t<10000){
daa=damage(++t);
pezzo=(ss*(dist-850+oscar));

     while(speed()>49);
     drive(d=360+180*asb,100);
       if (ss){if (or) look(350-180*asb);
       else look(80+180*asa);
     }


     if (asb) sx(xora=loc_x()-45-or*pezzo); else dx(xora=loc_x()+45+or*pezzo);
              zozzo=45+!or*pezzo;
     if(!asa) {d=90;up(loc_y()+zozzo);}
     else {d=270;dn(loc_y()-zozzo);}
     tempo();
     if (asb) dx(920); else sx(80);
     tempo();
     if(!asa) {dn(80);}
     else {up(920);}

     if (ss) if((damage())>daa) or=!or;
     
         if ((t>3&&!(oldr<800)||t>6))
              {
               if (++tempo>20) {oscar=60;or=!or;}
               if (tempo>5) ss=1;
               if (damage()>85) {ss=0;}
              sganna();
              }
}
fine();
}

up(limt) {while(loc_y()<limt) {drive(90,100);Fire();}drive(90,0);}
dn(limt) {while(loc_y()>limt) {drive(270,100);Fire();}drive(270,0);}
dx(limt) {while(loc_x()<limt) {drive(360,100);Fire();}drive(0,0);}
sx(limt) {while(loc_x()>limt) {drive(180,100);Fire();}drive(180,0);}

Fire() {
 if((oldr=scan(deg,10))&&(oldr<830))
        {
           if (oldr=scan(deg,4));
           else if (oldr=scan(deg-=7,3));
           else if (oldr=scan(deg+=14,3));
           else return;
           if (!scan(deg+=2,2)) deg-=4;
           cannon (deg,oldr);
        }
     else
       if(scan(deg+=20,10));
       else
         if(scan(deg-=40,10));
         else
           if(scan(d,10)) deg=d;
           else
             return (deg+=80);
}


Fuoco()
{
    if (oldr=scan(odeg=deg,10)) {
           if (scan(deg-=7,4));
           else if (scan(deg+=14,4));
           else if (scan(deg-=7,4));
    if (!(scan(deg+=2,2))) deg-=4; return(cannon(deg+(deg-odeg),2*scan(deg,10)-oldr));
    }
    else {
        if (oldr=scan(deg+=340,10)) return cannon(deg,oldr);
        if (oldr=scan(deg+=40,10)) return cannon(deg,oldr);
        if (oldr=scan(deg+=300,10)) return cannon(deg,oldr);
        if (oldr=scan(deg+=80,10)) return cannon(deg,oldr);
        if (oldr=scan(deg+=260,10)) return cannon(deg,oldr);
        if (oldr=scan(deg+=120,10)) return cannon(deg,oldr);
        deg+=80;
    }
}

fine()                                
{
if (!b||b==3) while(loc_x()<500) zzy(115+257*b,300,60);
else while(loc_x()>500) zzy(115+(b-1)*770,240,120);
while(1)
{
while(loc_y()>150) zz(190,350);
 while(loc_y()<850) zz(170,10);
} 
}


zz(d1,d2){
                    while(loc_x()>500) {drive(d1,100);Fuoco();}
                    while(loc_x()<500) {drive(d2,100);Fuoco();}
}

zzy(lom,d1,d2){
                    while(loc_y()>lom) {drive(d1,100);Fuoco();}
                    while(loc_y()<lom) {drive(d2,100);Fuoco();}
}


look(par)
{if (!(dist=scan(par,10))) if (!(dist=scan(par+20,10))) dist=850;}

sganna(){
               flag=ll;
               flag1=2;
               while (flag<=ul&&flag1) flag1-=(scan(flag+=20,10)>0);
               t=10002*((flag1>0));
        }

tempo(){
dn=d;dn=d;dn=d;
}
