#define MAXROB 32

/*#define msdos 1
#define correctcrh 1
#define djgpp 1*/
/* Remark these lines to compile in linux
*/
/*#define debug 1*/


#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<time.h>
#ifdef linux
#include	<termio.h>
#include	<curses.h>
#else
#include 	<process.h>
#include	<conio.h>
#include	<io.h>
#include    	<sys\stat.h>
#include	<ctype.h>
#include	<alloc.h>
/*#include	<direct.h>*/
#endif

#ifdef	msdos
void	patch(void);
#endif
void	scambia(long i,long j,char *in);
void	mischia(long j, char *in);
int	getval(char *from);
void 	analisi();
void	aggiorna(long nr);
void	finale(int exitmode);
void	init(FILE *fp, char status);
void	stampa(FILE *fp, int maxrow, long nr);
#ifdef linux
void	stampaw(long nr);
#endif
void	save(long k);
void	esci();
void	pulisci();
void	scambiaf2f(long i,long j,char *in);
void	mischiaf2f(long j, char *in);
void	uso();
void	errore(char status);
void	comando(char* cm, int argc, char *argv[]);
int     torneo(char);

#ifdef msdos
void refresh(void);
void initscr(void);
void cbreak(void);
void noecho(void);
void curs_set();
void endwin(void);
#endif

#ifndef __TURBOC__
#define randomize() srand((unsigned int)time(NULL));
#endif

int	numrob=0,limrob=0;
int	numinc=0,mnuminc=0;
int	bitorneo=0;
int	birep=0;
char	rob[MAXROB+1][50];
char	srob[MAXROB+1][50];
long	data[MAXROB+1][4];
long	c=0,bias=0;
long	matches=0;
int	matchperc=10;
#ifdef __TURBOC__
char huge in[143841L]; /*(MAXROB*(MAXROB-1)*(MAXROB-2)*(MAXROB-3)/6)+1*/
#else
char	*in;
#endif

char	fileout[50];
int	isfileout=0;
char	temp[256];
int	log=0;
FILE	*flog=NULL;
char	extcount[256];
int	ordine=0;
int	rep=1;
int	win=3;
int	pari=1;
int	rtest=0,mtest=0;
int	quiet=0;
int	f2f=0;
#ifdef debug
char	versio[50]="TORNEO 2K1 debug version";
#else
char	versio[50]="TORNEO 2K1 v1.2";
#endif
char	robstring[100]="torneo.rob";
char	dirstring[100];
char	outstring[100];
int	fake=0;
char 	fk[8]="";




#ifdef linux
	#define clrscr clear
#else
	#define clear clrscr
	#define printw printf
#endif


int main(int argc, char *argv[])
{
	int	z;
	FILE	*fp;
	int	nuovo=0;

	outstring[0]=0;
	extcount[0]=0;

	if (argc!=1) {
		if(!strcmp(argv[1],"save")) comando("save",argc,argv);
		else if(!strcmp(argv[1],"quit")) comando("quit",argc,argv);
		else if(!strcmp(argv[1],"upd")) comando("update",argc,argv);

		else for(z=1;z<argc;z++)
		{
			if(argv[z][0]=='-') {
				if((tolower(argv[z][1]))=='f') f2f=1;
				else if((tolower(argv[z][1]))=='r'&&(strlen(argv[z])>3)) {
					rtest=1;
					strcpy(rob[0],(argv[z]+3));
				}
				else if((tolower(argv[z][1]))=='m') {
					mtest=1;
					mnuminc=getval(argv[z]);
				}
				else if((tolower(argv[z][1]))=='o') ordine=1;
				else if((tolower(argv[z][1]))=='x') rep=0;
				else if((tolower(argv[z][1]))=='t') log=1;
				else if((tolower(argv[z][1]))=='l') limrob=getval(argv[z]);
				else if((tolower(argv[z][1]))=='q') quiet=1;
				else if((tolower(argv[z][1]))=='w') win=getval(argv[z]);
				else if((tolower(argv[z][1]))=='p') pari=getval(argv[z]);
				else if((tolower(argv[z][1]))=='d') strcpy(outstring,(argv[z]+3));
				else if((tolower(argv[z][1]))=='c') {
					if (strlen(argv[z])>3) {
					#ifdef correctcrh
						if(argv[z][3]!='\'')
					#endif
						strcpy(extcount,(argv[z]+3));
					}
				} else if((tolower(argv[z][1]))=='a') {
					bitorneo=1;
					birep=getval(argv[z]);
				}

			}
			else strcpy(robstring,argv[z]);
		}

	}
	remove("cmnd");
	if(!quiet) {
		printf("\n\n\n\n\nCROBOTS %s\nCopyright (C) Michelangelo Messina\n",versio);
		printf("e-mail m.messina@tiscalinet.it\n       m.messina@libero.it\n");
		printf("http://go.to/crobots\n");
		printf("www.yahoogroups.com/group/crobots\n\n\n\n");
	}

	if(!strstr(robstring,".")) strcat(robstring,".rob");
	if(!outstring[0]) {
		strcpy(outstring,robstring);
		while(strstr(outstring,"\\"))strcpy(outstring,strstr(outstring,"\\")+1);
		while(strstr(outstring,"/"))strcpy(outstring,strstr(outstring,"/")+1);
		if(strstr(outstring,".")) *(strstr(outstring,"."))=0;
		strcpy(dirstring,outstring);
		strcat(outstring,".sco");
	} else {
		strcpy(dirstring,outstring);
		if(strstr(dirstring,".")) *(strstr(dirstring,"."))=0;
		while(strstr(dirstring,"\\"))strcpy(dirstring,strstr(dirstring,"\\")+1);
		while(strstr(dirstring,"/"))strcpy(dirstring,strstr(dirstring,"/")+1);
		if(!strstr(outstring,".")) strcat(outstring,".sco");

	}
	strcpy(fileout,outstring);
	if(bitorneo) f2f=1;

	if(!quiet) {
		initscr();
		cbreak();
		noecho();

		clear();
		curs_set(0);
		printw("CROBOTS %s\nCopyright (C) Michelangelo Messina\n",versio);
		printw("e-mail m.messina@tiscalinet.it\n       m.messina@libero.it\n");
		printw("http://go.to/crobots\n");
		printw("www.yahoogroups.com/group/crobots\n\n");
		printw("English translation by Quicker-Fabio\n\n");
		printw("A Special Thanks To \n TOM POINTEXTER - author Of CROBOTS program\n\n\n");
		printw("\n\nDevoted to all fans of Crobots\n\n");
		if(f2f) printw("\n\nFace2Face Mode");
		else printw("\n\n");

		/* debug */
		#ifdef debug
		{
			int i;
			printw("\nCommand line ");
			for(i=0;i<argc;i++) printw("%s ",argv[i]);
		}
		#endif
		/*debug */

		printw("\n\n Press a key\n");
		refresh();
		#ifdef msdos
			while(!kbhit());
		#endif
		getch();
		clear();
	}

	strcpy(temp,dirstring);
	strcat(temp,".dat");
	if((fp=fopen(temp,"rt"))!=NULL) {
		fclose (fp);
		if(!quiet) {
			printw("\nI have found data saved !\n");
			printw("Press N to start a New Tournament (old data will be lost)\n");
		#ifdef linux
			refresh();
			if((z=getchar())=='N' || z=='n') {
		#else
			while(!kbhit());
			if((z=getch())=='N' || z=='n') {
		#endif
				nuovo=1;
				remove(temp);
			}
		}
	}
	else nuovo=1;

	#ifndef __TURBOC__
	if((in=(char *)calloc((MAXROB*(MAXROB-1)*(MAXROB-2)*(MAXROB-3)/6)+1,sizeof(char)))==NULL) {
		printf("No Memory available\n");
		exit(-1);

	}
	#endif

	if(torneo(nuovo)){
		#ifdef debug
		printf("At the end of the tournament:\n");
		printf("numinc=%d - mtest=%d - mnuminc=%d\n",numinc,mtest,mnuminc);
		while(!kbhit());
		getch();
		#endif

		if(bitorneo&&f2f) {
			strcpy(fileout,outstring);
			f2f=0;
			c=0,bias=0;
			if(rep!=1) rep=0;
			if(log)log=1;
			clear();
			torneo(1);
		}
	}
	exit(0);
	return(0);
}

int torneo(char nuovo)
{
	long	L;
	FILE	*fp;
	long 	k;

	int	i,j,z,kk,exitmode=0;
	int	rp;
	char	parameter[256];
	char    pars[256],nr[10];

	randomize();
	if (nuovo) {
		if((fp=fopen(robstring, "rb"))==NULL) uso();
		if(!quiet) {
			printw("\nStarting New Tournament\n\n");
			printw("\n\n\nThroughout the tournament:\nS: Save status\nQ: Quit");
			printw("\nAny other key: Result refresh\n\n");
			refresh();
		}
		init(fp,0);
		fclose(fp);

		for(i=0;i<numrob;i++) for(j=0;j<3;j++) data[i][j]=0;

		if(f2f) {
			for(i=0;i<limrob;i++) {
				for(j=i+1;j<numrob;j++)
				{
					in[(long)c*2]=(char)i;
					in[(long)(c++)*2+1]=(char)j;
				}
			}

			k=c;
			if (!ordine) {
				for(c=0;c<k;c++) scambiaf2f(c, c+rand()%(k-c), in);
			}
		}
		else {
			for(i=0;i<limrob;i++) {
				for(j=i+1;j<numrob;j++)
					for(kk=j+1;kk<numrob;kk++)
						for(z=kk+1;z<numrob;z++)
						{
							in[(long)c*4]=(char)i;
							in[(long)c*4+1]=(char)j;
							in[(long)c*4+2]=(char)kk;
							in[((long)(c++))*4+3]=(char)z;
						}
			}

			for(i=1,k=0;i<=limrob;i++)
				k+=((long)(numrob-i)*(long)(numrob-(i+1))*(long)(numrob-(i+2))/6);
			if (!ordine) {
				for(c=0;c<k;c++) scambia(c, c+rand()%(k-c), in);
			}
		}
		if(matchperc) matches=((float)(k*matchperc)/100);
	} else	{
		if(!quiet) {
			printw("\nResuming Tournament previously saved\n\n");
			printw("\n\n\nThroughout the tournament:\nS: Save status\nQ: Quit");
			printw("\nAny other key: Result refresh\n\n");
			refresh();
		}
		init(fp=fopen(temp,"rt"),1);
		fscanf(fp, "%ld", &k);
		if(f2f) for(L=0;L<(2*k);L++) fscanf(fp, "%d", &in[L]);
		else for(L=0;L<(4*k);L++) fscanf(fp, "%d", &in[L]);
		fscanf(fp,"%ld",&bias);
		temp[0]=0;
		while(toupper(temp[0]!='C')&&(temp[0]<'0'||temp[0]>'9')) fgets(temp,80,fp);
		if (toupper(temp[0])=='C'){
			if(!(extcount[0])) strcpy(extcount,strstr(temp,"=")+1);
		} else {
			for(i=0;i<numrob;i++) for(j=0;j<3;j++) {
				data[i][j]=atol(temp);
				fscanf(fp,"%s",temp);
			}
		}
		do {
			if (toupper(temp[0])=='M' && strstr(temp,"=")) {
				if(!(matches=getval(temp))) matches=100;
			} else if (toupper(temp[0])=='X') rep=0;
			else if (toupper(temp[0])=='D') {
				strcpy(fileout,strstr(temp,"=")+1);
				isfileout=1;
				if(strchr(fileout,13))
				*(strchr(fileout,13))=0;
				if(strchr(fileout,10))
				*(strchr(fileout,10))=0;
			} else if (toupper(temp[0])=='T') log=2;
		} while (fgets(temp,80,fp));
		fclose(fp);
		strcpy(temp,dirstring);
		strcat(temp,".dat");
		if (remove(temp)) {
			printf("Error deleting file %s\n",temp);
			exit(0);
		}


		if (log==2) {
			strcpy(temp,dirstring);
			strcat(temp,".log");
			if((flog=fopen(temp,"rt"))==NULL) {
				endwin();
				printf("Log File not found\n");
				exit(-1);

			}
			else fclose(flog);
		}
	}
	if (extcount[0] && !log) {
		if(quiet) extcount[0]=0;
		else {
		#ifdef msdos
			while(kbhit())getch();
		#endif
			clear();
			printw("\n\n To use an external program of calculation is necessary to create the log \n");
			printw("of the matches. Insert the line\n\n  T\n\n in .rob\n\nor, on command line\n\n  -t\n");
			printw("\n\n Press S to run the log creation\n");
			refresh();
			#ifdef msdos
				while(!kbhit());
				if((z=getch())!='S' && z!='s') {
			#else
				if((z=getchar())!='S' && z!='s') {
			#endif
					chdir(dirstring);
					esci();
				}
			log=1;
		}
	}
	else if (!(quiet||extcount[0]||(!nuovo)||(bitorneo&&!f2f))) {
		#ifdef msdos
			while(kbhit())getch();
		#endif
		clear();
		printw("\nATTENTION\n\nFor a precise control of robots' efficiencies\n");
		printw("it's recommended to use COUNT v8.0 and superior (by S. Ascheri and M. Messina)\nfor the control of the results");
		printw("and implementing the PRANZO method,\nused in the official crobots tournaments.\n");
		printw("\n\nTo use the Pranzo method is enough to add in the file .rob the line\n");
		printw("\n   C=count logfile (without extension) /p (- p in Linux)\n\n");
		printw("or on command line\n\n");
		printw("   \"-c=count logfile (without extension) /p (-p in Linux)\"\n\n");
		printw("For further information about COUNT consult the enclosed guide of the program.\n");
		printw("Download: http://go.to/crobots or www.itportal.it/crobots/");
	}
	#ifdef debug
	printf("The number of matches for the refresh is: %d",matches);
	#endif
	if(!matches) matches=1;
	if(!rep) {
		rep=numinc;
		numinc=1;
	}
	if (log) {
		strcpy(temp,dirstring);
		#ifdef debug
		printf("\ntemp=%s\n",temp);
		#endif
		strcat(temp,".log");
		#ifdef debug
		printf("temp=%s\n",temp);
		#endif
		if(log==2||((!f2f)&&bitorneo)) flog=fopen(temp,"ab");
		else flog=fopen(temp,"wb");
		if (flog==NULL) {
			endwin();
			printf("\n\nError creating Log file.\n");
			exit(-1);
		}
		if (log==1) {
			if((!f2f)&&bitorneo) {
				fprintf(flog,"\n\n----------\n\n\n");
				bitorneo=0;
			}
			fprintf(flog,"Torneo gestito da <a href=\"http://go.to/crobots\">TORNEO 2K1</a>\n");
			/*fprintf(flog,"Torneo gestito da <a href=\"http://go.to/crobots\">%s</a> di Michelangelo Messina\n",versio);*/
			fprintf(flog,"Numero incontri=%ld",k*numinc*rep);
		}
	}
	if(!extcount[0]&&bitorneo&&f2f) {
		if(strstr(fileout,".")) *(strstr(fileout,"."))=0;
		strcat(fileout,".f2f");
	}

	#ifdef linux
	if(extcount[0]) if(!strstr(extcount,">/dev/null") ) {
		if(extcount[strlen(extcount)-1]==10) extcount[strlen(extcount)-1]=0;
		strcat(extcount," >/dev/null");
	}
	/*if(extcount[0]) quiet=1;*/
	strcpy(pars,"crobots </dev/null >L 2>/dev/null -l200000 -m");
	strcpy(nr,"0000");
	#else
	strcpy(pars,"c<nul>L -l200000 -m");
	#endif
	if(f2f) {
		#ifdef msdos
		gotoxy(1,17);
		#endif
		if(numinc>9999) {
			#ifdef linux
			endwin();
			#else
			clrscr();
			#endif
			printf("\nMaximum repetiotions for F2F matches: 9999\n");
			esci();
		}
		nr[0]='0'+(numinc)/1000;
		nr[1]='0'+(numinc-1000*(int)((numinc)/1000))/100;
		nr[2]='0'+(numinc-100*(int)((numinc)/100))/10;
		nr[3]='0'+numinc%10;
		nr[4]=' ';
		nr[5]=0;
	} else {
		#ifdef msdos
		gotoxy(1,16);
		#endif
		if(numinc>99) {
			#ifdef linux
			endwin();
			#else
			clrscr();
			#endif
			printf("\nMaximum repetitions for 4vs4 matches: 99\n");
			esci();
		}
		nr[0]='0'+(numinc)/10;
		nr[1]='0'+(numinc)%10;
		nr[2]=' ';
		nr[3]=0;
	}
	strcat(pars,nr);
	strcat(pars,fk);
	chdir(dirstring);

	#ifdef linux
	if(!quiet) nodelay(stdscr,TRUE);
	#endif

	for(c=0;c<k;c++) {
		#ifdef linux
		if(!quiet) {
			move(23,1);
			printw("Executing: Match %ld over %ld",c+bias+1,k+bias);
			refresh();
		}
		#endif
		for(rp=0;rp<rep;rp++) {
			strcpy(parameter,pars);
			if(f2f) {
				mischiaf2f(c,in);
				strcat(parameter,srob[in[(long)c*2]]);
				strcat(parameter,srob[in[(long)c*2+1]]);
			}
			else {
				mischia(c,in);
				strcat(parameter,srob[in[(long)c*4]]);
				strcat(parameter,srob[in[(long)c*4+1]]);
				strcat(parameter,srob[in[(long)c*4+2]]);
				strcat(parameter,srob[in[(long)c*4+3]]);
			}
			#ifdef msdos
			if(fake) {
				gotoxy(1,21);
				printf("Executing: Match %ld over %ld",(long)c+bias+1,k+bias);
				clreol();
			}
			else if (f2f) gotoxy(1,17);
			else gotoxy(1,16);
			if(system(parameter)) {
				clrscr();
				if(strlen(parameter)>123) printf("\nDOS ERROR: command line too long: %d chars\nReduce length of robots path (max CMDLINE = 123 chars)\n",strlen(parameter));
				else printf("\nDOS Error executing crobots.exe\nProgram interrupted\n");
				#ifdef debug
				printf("\nCMDLINE=%s\n",parameter);
				exit(0);
				#endif
				esci();
			}
			#else
			if(system(parameter)) {
				endwin();
				printf("\nCMDLINE=%s\n",parameter);
				printf("\nProgram aborted\n");
				esci();
			}
			#endif
			analisi();

			if(!quiet||rp==rep-1) {
				if((fp=fopen("cmnd","rt"))!=NULL) {
					aggiorna(k);
					fscanf(fp,"%s",temp);
					fclose(fp);
					remove("cmnd");
					if(!strcmp("save",temp)) exitmode=2;
					else if(!strcmp("quit",temp)&&!exitmode) {
						exitmode=1;
						break;
					}
				}
				#ifdef linux
				else if((fp=fopen("../cmnd","rt"))!=NULL) {
				#else
				else if((fp=fopen("..\\cmnd","rt"))!=NULL) {
				#endif
					aggiorna(k);
					fscanf(fp,"%s",temp);
					fclose(fp);
					if(!strcmp("save",temp)) exitmode=2;
					else if(!strcmp("quit",temp)&&!exitmode) {
						exitmode=1;
						break;
					}
				}
				#ifdef linux
				else if(!quiet) {
					if((z=getch())!=ERR) {
						aggiorna(k);
						if(z=='q'||z=='Q'||z=='s'||z=='S') {
							if(z=='s'||z=='S') exitmode=2;
							else if(!exitmode){
								exitmode=1;
								break;
							}
						}
					}
				}
				#else
				if(kbhit()) {
					aggiorna(k);
					if((z=getch())=='q' || z=='Q' || z=='s' ||z=='S') {
						if(z=='s' || z=='S') exitmode=2;
						else if(!exitmode){
							exitmode=1;
							break;
						}
					}
				}
				#endif
			}
		}
		if(exitmode==2) save(k);
		if(exitmode) break;
		else if(!((c+1)%matches))aggiorna(k);
	}
	if(c==k) c--;
	if (log) fclose(flog);
	finale(exitmode);
	pulisci();
	return(!exitmode);
}

void	init(FILE *fp, char status)
{
	int	i;
	int	tipo=0;
	FILE	*test;
	char	temp[256];

	if(status){
		mtest=0;
		rtest=0;
		rep=1;
		log=0;
		f2f=0;
		bitorneo=0;
		fscanf(fp, "%d",&tipo);
		if(tipo>1) {
			bitorneo=1;
			tipo-=2;
		}
		if(tipo>0) f2f=1;
		if(bitorneo) {
			fscanf(fp,"%d",&birep);
			fscanf(fp,"%s",robstring);
			fscanf(fp,"%d",&limrob);
		}
	}
	fscanf(fp, "%d",&numrob);
	if(!numrob) errore(status);
	fscanf(fp, "%d",&numinc);
	if(birep&&f2f) {
		if(!mtest) {
			mnuminc=numinc;
			mtest=1;
		}
		numinc=birep;
	} else if(mtest) numinc=mnuminc;
	if(!numinc) errore(status);
	#ifdef debug
	printf("numinc=%d - mtest=%d - mnuminc=%d",numinc,mtest,mnuminc);
	while(!kbhit());
	getch();
	#endif
	numrob+=rtest;
	for(i=rtest;i<numrob;i++) if(fscanf(fp,"%s",rob[i])==EOF) errore(status);
	#ifdef djgpp
	if (mkdir(dirstring,S_IWUSR)) {
	#else
	if (mkdir(dirstring)) {
	#endif
		endwin();
		fclose(fp);
		printf("\n\nAnother tournament is in progress in the directory %s !\n",dirstring);
		printf("\nIf the directory %s has been created by an aborted execution,\n eliminate it before running  %s\n",dirstring,versio);
		printf("\n\nOtherwise use -d=xxxx to change directory of destination\n");
		exit(-1);
	}
	#ifdef msdos
	patch();
	#else
	strcpy(temp,"chmod a=rwx ");
	strcat(temp,dirstring);
	system(temp);
	#endif

	for(i=0;i<numrob;i++) {
		strcpy(srob[i],rob[i]);
		if(strchr(rob[i],13))
		*(strchr(rob[i],13))=0;
		if(strchr(rob[i],10))
		*(strchr(rob[i],10))=0;
		strcpy(srob[i],rob[i]);

		strcpy(temp,srob[i]);
		if(strstr(temp," ")) *(strstr(temp," "))=0;
		#ifdef linux
		if(strstr(temp,"\\")) strcpy(strstr(temp,"\\"),strstr(temp,"\\")+1);
		#endif
		if((test=fopen(temp,"r"))!=NULL) fclose(test);
		else {
			printf("Robot: %s\n",temp);
			errore(2);
		}
		strcat(srob[i]," ");
		#ifdef linux
		strcpy(temp,"ln -s >/dev/null ");
		if(srob[i][0]!='/') strcat(temp,"../");
		strcat(temp,srob[i]);
		strcat(temp,dirstring);
		while(strstr(srob[i],"/"))strcpy(srob[i],strstr(srob[i],"/")+1);
		#else
		strcpy(temp,"copy >nul ");
		strcat(temp,srob[i]);
		while(strstr(srob[i],":")) strcpy(srob[i],strstr(srob[i],":")+1);
		while(strstr(srob[i],"\\")) strcpy(srob[i],strstr(srob[i],"\\")+1);
		strcat(temp,dirstring);
		#endif
		if(system(temp)) {
			endwin();
			printf("Error opening files\n");
			#ifdef debug
			printf("command:%s\n",temp);
			#endif
			exit(-1);
		}

		if(strstr(srob[i],".pr") || strstr(srob[i],".PR") ) {
			#ifdef linux
			strcpy(temp,"ppc </dev/null >/dev/null ");
			#else
			strcpy(temp,"ppc <nul >nul ");
			#endif
			strcat(temp,dirstring);
			#ifdef linux
			strcat(temp,"/");
			#else
			strcat(temp,"\\");
			#endif
			strcat(temp,srob[i]);
			if(system(temp)) {
				endwin();
				printf("\nError in file %s.rob\nor in the preprocessor use\n",dirstring);
				exit(-1);
			}

			strcpy(temp,dirstring);
			#ifdef linux
			strcat(temp,"/");
			#else
			strcat(temp,"\\");
			#endif
			strcat(temp,srob[i]);
			if(strstr(temp," ")) *(strstr(temp," "))=0;
			remove(temp);

			*(strstr(srob[i],"."))=0;
			strcat(srob[i],".r ");
		}

		if(!strstr(srob[i],".r") && !strstr(srob[i],".R")) {
			printf("Robot: %s\n",srob[i]);
			errore(2);
		}
	}

	if (status) {
		if(bitorneo) fscanf(fp,"%d",&rtest);
		return;
	}

	while (fgets(temp,80,fp)){
		if (toupper(temp[0])=='L' && strstr(temp,"=") &&(!limrob)) limrob=getval(temp);
		else if (toupper(temp[0])=='M' && strstr(temp,"=")) {
			if(strstr(temp,"%")) {
				if(!(matchperc=getval(temp))) matchperc=10;
			}
			else {
				if(!(matches=getval(temp))) matches=100;
				matchperc=0;
			}
		}
		else if (toupper(temp[0])=='X') rep=0;
		else if (toupper(temp[0])=='D') {
			strcpy(fileout,strstr(temp,"=")+1);
			isfileout=1;
			if(strchr(fileout,13))
			*(strchr(fileout,13))=0;
			if(strchr(fileout,10))
			*(strchr(fileout,10))=0;

		}
		else if (toupper(temp[0])=='T') log=1;
		else if (toupper(temp[0])=='O') ordine=1;
		else if (toupper(temp[0])=='C'&&!extcount[0]) strcpy(extcount,strstr(temp,"=")+1);

	}
	if ((!limrob)||(limrob>numrob)) limrob=numrob;
}

void	scambia(long i,long j,char *in)
{
	char k;
	long temp;
	for(k=0;k<4;k++) {
		temp=in[(long)j*4+(long)k];
		in[(long)j*4+(long)k]=in[(long)i*4+(long)k];
		in[(long)i*4+(long)k]=temp;
	}

}

void mischia(long j, char *in)
{
	char k;
	long temp,z;
	for(k=0;k<4;k++) {
		z=rand()%(4);
		temp=in[(long)j*4+(long)z];
		in[(long)j*4+(long)z]=in[(long)j*4+(long)k];
		in[(long)j*4+(long)k]=temp;
	}
}

void save(long k)
{
	long	L;
	int	i,j;
	FILE	*fp;

	#ifdef msdos
	strcpy(temp,"..\\");
	#else
	strcpy(temp,"../");
	#endif
	strcat(temp,dirstring);
	strcat(temp,".dat");
	if((fp=fopen(temp,"wt"))!=NULL) {
		fprintf(fp, "%d\n",(f2f+2*bitorneo));
		if(bitorneo) {
			fprintf(fp, "%d\n",birep);
			fprintf(fp, "%s\n",robstring);
			fprintf(fp, "%d\n",limrob);
		}
		fprintf(fp, "%d\n",numrob);
		if(mtest) fprintf(fp, "%d\n",mnuminc);
		else {
			if(rep==1) fprintf(fp, "%d\n",numinc);
			else fprintf(fp,"%d\n",rep);
		}
		for(i=0;i<numrob;i++)
			fprintf(fp,"%s\n",rob[i]);
		if(bitorneo) fprintf(fp,"%d\n",rtest);
		fprintf(fp,"%ld\n",k-c-1);

		if(f2f) for(L=(2*((long)c+1));L<(2*k);L++) {
			fprintf(fp, "%d\n", in[L]);
		}
		else for(L=(4*((long)c+1));L<(4*k);L++) {
			fprintf(fp, "%d\n", in[L]);
		}
		fprintf(fp,"%ld\n", bias+c+1);
		if (extcount[0]) fprintf(fp, "C=%s\n",extcount);
		else {
			for(i=0;i<numrob;i++)
				for(j=0;j<3;j++) fprintf(fp,"%ld\n",data[i][j]);
		}
		if (matches!=100) fprintf(fp, "M=%ld\n", matches);
		if (rep!=1) fprintf(fp, "X\n");
		if (log) fprintf(fp, "T\n");
		if (isfileout) fprintf(fp, "D=%s\n", fileout);
		fclose(fp);
		if (!quiet) printf("\n\n Status saved in file  %s.dat\n",dirstring);
	}
	else {
		endwin();
		printf("Error saving!\n");
		esci();
	}
}



void analisi()
{
	char	buffer[17][80];
	int	i,j,k;
	FILE	*fp;
	char	car,ncar;


	if(log) {
		if((fp=fopen("L", "rb"))==NULL) {
			endwin();
			printf("Error loading data\n");
			esci();
		}
		car=fgetc(fp);
		while (!feof(fp)) {
			ncar=fgetc(fp);
			if(fputc(car,flog)==EOF) {
				endwin();
				printf("Error writing log\n");
				fclose(fp);
				esci();
			}
			car=ncar;
		}
		fflush(flog);
		fclose(fp);
	}

	if(!extcount[0]) {
		if((fp=fopen("L", "rt"))==NULL) {
			endwin();
			printf("Errore loading data\n");
			esci();
		}
		i=0;
		if(f2f) {
			while (!feof(fp)) {
				fscanf(fp,"%s",buffer[((++i)%10)]);
			}
			fclose (fp);

			if(++i<3) {
				endwin();
				printf("\n\nRuntime error compiling any robot!\n");
				esci();
			}
			for(j=0;j<2;j++) {
				k=in[c*2+j];
				data[k][0]+=numinc;
				data[k][1]+=getval((char *)buffer[((i+4*j+3)%10)]);
				data[k][2]+=getval((char *)buffer[((i+4*j+4)%10)]);
			}
			return;

		}
		while (!feof(fp)) {
			fscanf(fp,"%s",buffer[((++i)%17)]);
		}
		fclose (fp);

		i++;
		for(j=0;j<4;j++)
		{
			k=in[c*4+j];
			data[k][0]+=numinc;
			data[k][1]+=getval((char *)buffer[((i+4*j+2)%17)]);
			data[k][2]+=getval((char *)buffer[((i+4*j+3)%17)]);

		}
		if(strspn(buffer[(i+13)%17],srob[in[c*4+3]])!=(strlen(srob[in[c*4+3]])-1)) {
			endwin();
			printf("\n\nRuntime error compiling any robot!\n");
			esci();
		}
	}

}


void	aggiorna(long nr)
{
	FILE	*fp;


	chdir("..");
	if(extcount[0]) {
		system(extcount);
#ifdef debug
		printw("\n\n executed %s\n",extcount);
		refresh();
#endif
	} else {
		if (isfileout||quiet) {
			if((fp=fopen(fileout, "wt"))==NULL) {
				endwin();
				printf("Error writing results\n");
				esci();
			}
			stampa(fp,100,nr);
			fclose(fp);
		}
		if(!quiet) {
			#ifdef msdos
			clrscr();
			gotoxy(1,1);
			stampa(stdout,19,nr);
			#else
			stampaw(nr);
			#endif
		}
	}
	chdir(dirstring);

}

int	getval(char *from)
{
	char *r;
	r=strchr(from,'=');
	return(atoi(r+1));
}

void finale(int exitmode)
{
	FILE	*fp;

	chdir("..");
	clrscr();
	endwin();
	if(extcount[0]) {
		if(!exitmode) system(extcount);
	} else {
		if((fp=fopen(fileout,"wt"))==NULL) {
			printf("\n No results saved!\n");
			chdir(dirstring);
			esci();
		}
		stampa(fp,100,0);
		fclose(fp);
		if(!quiet) {
			stampa(stdout,100,0);
			printf("\n\n Result saved in file %s\n",fileout);
		}
	}
	chdir(dirstring);
}

void stampa(FILE *fp,int maxrow, long nr)
{
	int	i,j,temp,classifica[MAXROB+1];
	float	media[MAXROB+1];

	for(i=0;i<numrob;i++) {
		if(data[i][0])
		media[i]=(float)(100*((float)data[i][1]+(float)data[i][2]*pari/win)/(float)data[i][0]);
		else media[i]=-1;
	}
	for(i=0;i<numrob;i++) classifica[i]=i;
	if (!nr) fprintf(fp, " Final Results:\n");
	else fprintf(fp," Results after %ld matches over %ld (%d %%):\n",(long)c+1+bias,(long)nr+bias,(((long)(c+bias+1)*(long)100))/(long)(nr+bias));
	fprintf(fp,"Pos -   Robot - matches -  win  - draw  - lost  -    score -   eff.%\n");
	for(i=0;i<numrob;i++) {
		for(j=i;j<numrob;j++) {
			if(media[classifica[i]]<media[classifica[j]]) {
				temp=classifica[i];
				classifica[i]=classifica[j];
				classifica[j]=temp;
			}
		}
	}
	for(i=0;i<numrob&&i<maxrow;i++) {
		if(data[classifica[i]][0])
		fprintf(fp,"%2d%14s %5ld   %6ld   %5ld   %5ld   %8.0f    %6.2f\n",(i+1),srob[classifica[i]],
		data[classifica[i]][0], data[classifica[i]][1],
		data[classifica[i]][2], data[classifica[i]][0]-data[classifica[i]][1]-data[classifica[i]][2],
		(float) data[classifica[i]][1]*win+(float)data[classifica[i]][2]*pari,
		media[classifica[i]]);
		else fprintf(fp,"%2d%14s\n",(i+1),srob[classifica[i]]);
	}
}

#ifdef linux
void stampaw(long nr)
{
	int	i,j,temp,classifica[MAXROB+1];
	float	media[MAXROB+1];

	for(i=0;i<numrob;i++) {
		if(data[i][0])
		media[i]=(float)(100*((float)data[i][1]+(float)data[i][2]*pari/win)/(float) data[i][0]);
		else media[i]=-1;
	}
	for(i=0;i<numrob;i++) classifica[i]=i;
	clear();
	printw(" Results after %ld matches on %ld (%ld %%):\n",c+1+bias,nr+bias,(((long)(c+bias+1)*100))/(nr+bias));
	printw("Pos -   Robot - matches -  win  - draw  - lost  -    score -   eff.%\n");
	for(i=0;i<numrob;i++) {
		for(j=i;j<numrob;j++) {
			if(media[classifica[i]]<media[classifica[j]]) {
				temp=classifica[i];
				classifica[i]=classifica[j];
				classifica[j]=temp;
			}
		}
	}
	for(i=0;i<numrob&&i<21;i++) {
		if(data[classifica[i]][0])
		printw("%2d%14s %5ld   %6ld   %5ld   %5ld   %8.0f    %6.2f\n",(i+1),srob[classifica[i]],
		data[classifica[i]][0],	data[classifica[i]][1],
		data[classifica[i]][2],data[classifica[i]][0]-data[classifica[i]][1]-data[classifica[i]][2],
		(float) data[classifica[i]][1]*win+(float)data[classifica[i]][2]*pari,
		media[classifica[i]]);
		else printw("%2d%14s\n",(i+1),srob[classifica[i]]);
	}
}
#else
void patch()
{
	unsigned long 	c,l;
	char	i,j,temp[128];
	FILE	*fp1,*fp2,*fp;

	if((fp1=fopen("crobots.exe","rb"))==NULL) {
		printf("CROBOTS.EXE has to be in the current directory!\n");
		exit(-1);
	}

	if(filelength(fileno(fp1))!=60224) fake=1;

	strcpy(temp,dirstring);
	strcat(temp,"\\c.exe");
	if((fp2=fopen(temp,"wb"))==NULL) {
		printf("Error writing!\n");
		fclose(fp1);
		exit(-1);
	}
	if((fp=fopen("patch.dat","rb"))==NULL) {
		printf("PATCH.DAT has to be in the current directory!\n");
		fclose(fp1);
		fclose(fp2);
		exit(-1);
	}
	if(filelength(fileno(fp))!=5280) {
		printf("The new version of PATCH.dat is necessary.\n");
		fclose(fp);
		fclose(fp1);
		fclose(fp2);
		exit(-1);
	}
	fread(&l,sizeof(long),1,fp);
	if(fake) strcpy(fk,"-g ");
	for(c=0;!feof(fp1);c++) {
		if(!(fread(&i,sizeof(char),1,fp1))) break;
		if(c==l&& !fake) {
			fread(&j,sizeof(char),1,fp);
			fwrite(&j,sizeof(char),1,fp2);
			fread(&l,sizeof(long),1,fp);
		}
		else  fwrite(&i,sizeof(char),1,fp2);
	}
	fclose(fp1);
	fclose(fp2);
	fclose(fp);
}
#endif
void esci()
{
	if (log&&flog) fclose(flog);
	pulisci();
	exit(-1);
}

void	scambiaf2f(long i,long j,char *in)
{
	char k;
	long temp;
	for(k=0;k<2;k++) {
		temp=in[(long)j*2+(long)k];
		in[(long)j*2+(long)k]=in[(long)i*2+(long)k];
		in[(long)i*2+(long)k]=temp;
	}

}

void mischiaf2f(long j, char *in)
{
	char k;
	long temp,z;
	for(k=0;k<2;k++) {
		z=rand()%(2);
		temp=in[(long)j*2+(long)z];
		in[(long)j*2+(long)z]=in[(long)j*2+(long)k];
		in[(long)j*2+(long)k]=temp;
	}
}

void uso()
{
	if(quiet) printf("Error - type t2k1 ? to get help\n");
	else {
		clear();
		#ifdef linux
		printw("Usage: t2k1 [switches] [command file[.rob]]\n");
		printw("     t2k1 save|quit|upd [tournamentname]\n");
		#else
		printw("Usage: T2k1 [switches] [command file[.rob]]\n");
		printw("     T2k1 save|quit|upd [tournamentname]\n");
		#endif
		printw("Default command file is torneo.rob\n\n");
		printw("Switches:\n\n");
		printw("-d=x  : type of output file x.est\n");
		printw("-r=x.r: adds x.r as first robot\n");
		printw("-f    : enables Face2Face Mode\n");
                printw("-a[=x]: executes F2F and then 4vs4 (F2F with x repetitions for match)\n");
                printw("-x    : runs crobots always with switch -m1 (obsolete - for old crobots.exe)\n");
                printw("-m=x  : x repetitions for every match \n");
		printw("-t    : creates log file  \n");
		#ifdef msdos
		printw("\"-c=x\": runs external calculation prog. (for ex. \"-c=count73 torneo /a\")\n");
		#else
		printw("\"-c=x\": runs external calculation prog. (for ex. \"-c=count73 torneo -a\")\n");
		#endif
		printw("-o    : tidy tournament\n");
		printw("-l=x  : tournament completed by the first x robots\n");
		#ifdef linux
		printw("-q    : 'QUIET' mode for batches\n");
		#endif
		printw("-w=x  : assign x points for victory)\n");
		printw("-p=x  : assign x points for draw (default=1)\n");
		printw("\n\nThese switches have the priority on those inserted in the command file\n");
		printw("\n\n Press a key");
		refresh();
		#ifdef msdos
		while(!kbhit());
		getch();
		#else
		getchar();
		#endif
		clear();
                printw("\nCommand file must contain:\nnumber of robots\nnumber of repetitions for every match\nrobots of tournament (max %d, comprehensive of path)\n\n",MAXROB);
		printw("Options to be inserted after the last robot, obligatorily without spaces:\n\nL=n (with n <=number of robots)\n     ");
                printw("to make play only the matches of the first n robots\n");
		printw("O to have the tournament in order\n");
		printw("M=n  to have the status refresh every n matches\n");
                printw("M=n\%% to have the refresh every n\%% of the tournament(default 10)\n");
                printw("X    to run crobots with switch -m1 (obsolete - for old crobots.exe)\n");
		printw("D=fileoutput\n     to have the refresh on a file different from the default (. sco)\n");
                printw("T    to save complete log of matches (.log)\n");
		printw("C=progcalculate (to use only with option T - log creation)\n     to use an external analysis program\n");
		printw("\n\n Press a key\n");
		refresh();
		#ifdef msdos
		while(!kbhit());
		getch();
		#else
		getchar();
		#endif
		endwin();
	}
	exit(-1);
}


void comando(char* cm,int argc, char *argv[])
{
	FILE *fp;


	printf("\n\n\n\n\nCROBOTS %s\nCopyright (C) Michelangelo Messina\n",versio);
	printf("e-mail m.messina@tiscalinet.it\n       m.messina@libero.it\n");
	printf("http://go.to/crobots\n");
	printf("www.yahoogroups.com/group/crobots\n\n");

	if (argc>2) {
		strcpy(temp,argv[2]);
		if(temp[strlen(temp)-1] !='/') strcat(temp,"/");
		strcat(temp,"cmnd");
	}
	else {
		if(!strcmp(cm,"update")) {
			printf("Error\nMissing tournament name\n");
			exit(-1);
		}
		strcpy(temp,"cmnd");
	}
	if((fp=fopen(temp,"wt"))==NULL) {
		printf("Error\nCouldn't create File %s\n",temp);
		exit(-1);
	}
	fprintf(fp,"%s\n",cm);
	fclose(fp);
	printf("Sending command %s\n",cm);
	exit(0);
}
void errore(char status)
{
	endwin();
	if(!status) printf("\nError in .rob file\n");
	else if(status==1) printf("\nError in .dat file\n");
	else printf("\nCompiler error\n");
	exit(-1);
}

void pulisci()
{
	int i;

	remove("L");
	#ifdef msdos
	for(i=0;i<numrob;i++) remove(srob[i]);
	#else
	for(i=0;i<numrob;i++) {
		strcpy(temp,srob[i]);
		if(strstr(temp," ")) *(strstr(temp," "))=0;
		if(strstr(temp,"\\")) strcpy(strstr(temp,"\\"),strstr(temp,"\\")+1);
		remove(temp);
	}
	#endif
	endwin();
	chdir("..");
	rmdir(dirstring);
}


#ifdef msdos
void refresh(void){}
void initscr(void){}
void cbreak(void) {}
void noecho(void) {}
void curs_set() {}
void endwin(void) {strcpy(temp,dirstring);strcat(temp,"\\c.exe");remove(temp); }
#endif
